--
-- PostgreSQL database dump
--

SET client_encoding = 'UTF8';
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: postgres
--

COMMENT ON SCHEMA public IS 'Standard public schema';


SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: acctype; Type: TABLE; Schema: public; Owner: dez; Tablespace: 
--

CREATE TABLE acctype (
    id serial NOT NULL,
    description text
);


ALTER TABLE public.acctype OWNER TO dez;

--
-- Name: acctype_id_seq; Type: SEQUENCE SET; Schema: public; Owner: dez
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('acctype', 'id'), 5, true);


--
-- Name: awards; Type: TABLE; Schema: public; Owner: chckens; Tablespace: 
--

CREATE TABLE awards (
    id serial NOT NULL,
    username text,
    score integer,
    whn timestamp(0) without time zone,
    who text,
    why text
);


ALTER TABLE public.awards OWNER TO chckens;

--
-- Name: awards_id_seq; Type: SEQUENCE SET; Schema: public; Owner: chckens
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('awards', 'id'), 12, true);


--
-- Name: books; Type: TABLE; Schema: public; Owner: chckens; Tablespace: 
--

CREATE TABLE books (
    id integer DEFAULT nextval(('"books_id_seq"'::text)::regclass) NOT NULL,
    title text,
    author text,
    keywords text,
    comments text,
    onloan boolean,
    loandate timestamp with time zone,
    publisher text,
    loanwho text,
    got boolean,
    isbn text,
    amazon_data text,
    image_url text
);


ALTER TABLE public.books OWNER TO chckens;

--
-- Name: books_id_seq; Type: SEQUENCE; Schema: public; Owner: chckens
--

CREATE SEQUENCE books_id_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.books_id_seq OWNER TO chckens;

--
-- Name: books_id_seq; Type: SEQUENCE SET; Schema: public; Owner: chckens
--

SELECT pg_catalog.setval('books_id_seq', 148, true);


--
-- Name: games; Type: TABLE; Schema: public; Owner: chckens; Tablespace: 
--

CREATE TABLE games (
    id serial NOT NULL,
    name text,
    connect text
);


ALTER TABLE public.games OWNER TO chckens;

--
-- Name: games_id_seq; Type: SEQUENCE SET; Schema: public; Owner: chckens
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('games', 'id'), 5, true);


--
-- Name: menu; Type: TABLE; Schema: public; Owner: dez; Tablespace: 
--

CREATE TABLE menu (
    id serial NOT NULL,
    title text NOT NULL,
    parent integer DEFAULT 1,
    menuorder integer,
    target text,
    title_cy text,
    permission text
);


ALTER TABLE public.menu OWNER TO dez;

--
-- Name: menu_id_seq; Type: SEQUENCE SET; Schema: public; Owner: dez
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('menu', 'id'), 34, true);


--
-- Name: news; Type: TABLE; Schema: public; Owner: chckens; Tablespace: 
--

CREATE TABLE news (
    id serial NOT NULL,
    title text,
    body text,
    date timestamp(0) without time zone,
    category character varying(15),
    sticky boolean,
    author character varying(20)
);


ALTER TABLE public.news OWNER TO chckens;

--
-- Name: news_id_seq; Type: SEQUENCE SET; Schema: public; Owner: chckens
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('news', 'id'), 5, true);


--
-- Name: pagemap; Type: TABLE; Schema: public; Owner: arthur; Tablespace: 
--

CREATE TABLE pagemap (
    id serial NOT NULL,
    path text,
    depth integer,
    component text
);


ALTER TABLE public.pagemap OWNER TO arthur;

--
-- Name: pagemap_id_seq; Type: SEQUENCE SET; Schema: public; Owner: arthur
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('pagemap', 'id'), 19, true);


--
-- Name: pastebin; Type: TABLE; Schema: public; Owner: dez; Tablespace: 
--

CREATE TABLE pastebin (
    id serial NOT NULL,
    created timestamp without time zone DEFAULT now(),
    username character varying(50),
    code text,
    highlighted_code text,
    "language" character varying(10),
    retain_til timestamp(0) with time zone DEFAULT ('now'::text)::timestamp(0) with time zone
);


ALTER TABLE public.pastebin OWNER TO dez;

--
-- Name: pastebin_id_seq; Type: SEQUENCE SET; Schema: public; Owner: dez
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('pastebin', 'id'), 11, true);


--
-- Name: redirect; Type: TABLE; Schema: public; Owner: dez; Tablespace: 
--

CREATE TABLE redirect (
    id serial NOT NULL,
    from_uri text,
    to_uri text
);


ALTER TABLE public.redirect OWNER TO dez;

--
-- Name: redirect_id_seq; Type: SEQUENCE SET; Schema: public; Owner: dez
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('redirect', 'id'), 18, true);


--
-- Name: session; Type: TABLE; Schema: public; Owner: arthur; Tablespace: 
--

CREATE TABLE "session" (
    hash text,
    username text,
    "time" timestamp(0) without time zone,
    data text,
    ip text
);


ALTER TABLE public."session" OWNER TO arthur;

--
-- Name: shorturi; Type: TABLE; Schema: public; Owner: dez; Tablespace: 
--

CREATE TABLE shorturi (
    id serial NOT NULL,
    url text,
    creator text,
    created timestamp without time zone
);


ALTER TABLE public.shorturi OWNER TO dez;

--
-- Name: shorturi_id_seq; Type: SEQUENCE SET; Schema: public; Owner: dez
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('shorturi', 'id'), 15, true);


--
-- Name: static; Type: TABLE; Schema: public; Owner: dez; Tablespace: 
--

CREATE TABLE static (
    id serial NOT NULL,
    path text,
    summary text,
    editor text,
    pageorder integer
);


ALTER TABLE public.static OWNER TO dez;

--
-- Name: static_id_seq; Type: SEQUENCE SET; Schema: public; Owner: dez
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('static', 'id'), 51, true);


--
-- Data for Name: acctype; Type: TABLE DATA; Schema: public; Owner: dez
--

COPY acctype (id, description) FROM stdin;
1	public
2	non-member
3	member
4	moderator
5	admin
\.


--
-- Data for Name: awards; Type: TABLE DATA; Schema: public; Owner: chckens
--

COPY awards (id, username, score, whn, who, why) FROM stdin;
1	chckens	2	2006-08-24 13:37:55	chckens	For porting the banana viewer to the new site
2	Dez	5	2006-08-25 11:36:23	chckens	For obtaining nicer banana images
3	frosty	-50	2006-08-25 12:01:59	chckens	For deciding that the website will be launched on 18th August... then doing next-to-nothing to make this happen
7	arthur	-50	2006-08-25 18:25:21	chckens	For not using paramaterised queries
9	chckens	-50	2006-08-26 21:16:48	arthur	For wasting time messing about with unnecessarily complicated features in a rohan inspired over engineering effort
10	chckens	-2	2006-08-26 21:20:04	arthur	For not even attempting an admin form for bananas
101	davea	3	2004-03-06 20:10:49	pwb	For writing a script to print membership receipts
102	arthur	-2	2004-03-09 10:50:28	rollercow	For managing to turn off silver using the anti reset device
103	stringfellow	2	2004-03-09 11:36:25	davea	For buying an air freshener for the SUCS room.
104	stringfellow	-3	2004-03-09 16:35:14	rollercow	For buying an air freshener for the SUCS room that STINKS
105	chckens	1	2004-09-23 15:04:00	greggwilliams	For figuring out how to abuse admin access
106	chckens	-2	2004-09-23 15:41:56	greggwilliams	For abusing my admin username during freshers
107	greggwilliams	-1	2004-09-23 15:49:09	davea	For letting chckens abuse his admin access at freshers
108	pwb	-1	2004-10-04 17:36:57	rollercow	For trying to "guess" how much money we have, rather than counting it.
109	everyone	-1	2004-10-10 17:22:32	rollercow	Not giving me any bananas
110	firefury	2	2004-10-10 23:26:54	cmckenna	For arranging for me to get back in the room whilst he was in England.
111	pwb	1	2004-10-10 23:29:02	cmckenna	For letting me into the sucs room after the card swiper failed.
112	arthur	-1	2004-10-10 23:29:52	cmckenna	For not fixing a known problem with the door card swiper and for not having keys to the room.
113	rollercow	-1	2004-10-11 20:16:42	pwb	For complaining about not having any bananas
116	rollercow	3	2004-10-11 20:20:19	pwb	For being ridiculously helpful during freshers' fayre
118	LIS	-10	2004-10-10 23:26:00	pwb	For continuing to have a completely borken firewall
121	LIS	-10	2004-10-20 14:52:05	pwb	For not replying to email about the societies email problem
122	LIS	10	2004-10-20 15:04:52	greggwilliams	For being consistently inconsistent
123	rollercow	-1	2004-11-10 10:21:08	vortex	For being over-zealous about Debian.  Again.
124	vortex	-1	2004-11-10 10:24:45	rollercow	For not using Debian, despite it obviously being the best Linux distribution
125	rohan	2	2004-11-10 11:22:18	pwb	For donating yet more books to SUCS
126	arthur	2	2004-11-15 12:35:42	rollercow	For creating the oh-so-very-usefull auto signup system
127	davea	-2	2004-11-15 12:36:54	rollercow	For blowing up the recept printer
128	chckens	1	2004-11-15 12:37:47	rollercow	For helping out at the freshers fair
129	greggwilliams	1	2004-11-15 12:37:55	rollercow	For helping out at the freshers fair
130	davea	1	2004-11-15 12:38:05	rollercow	For helping out at the freshers fair
131	stringfellow	1	2004-11-15 12:38:12	rollercow	For helping out at the freshers fair
132	rollercow	-2	2004-11-21 18:05:57	pwb	For leaving himself logged in as root on neptunium
133	sits	3	2004-12-02 20:24:28	rollercow	For assistance with the upgrade to FC3, and the mass of bug reports that followed
134	xtreme	-1	2004-12-07 10:40:30	wedge	Never ever playing any good music. Ever.
135	jk	-2	2004-12-07 10:42:09	wedge	For going on and on and on about his ridiculous N-Gage thing. I mean, really.
136	rollercow	1	2004-12-07 10:45:40	wedge	For his love and prompt return of my Look Around You DVD plus other all-round niftiness.
137	sits	1	2005-01-07 20:58:57	wedge	For giving me a Christmas card
138	sits	-1	2005-01-07 20:59:27	wedge	For giving me a Christmas card which mocked my ability to play Frozen-Bubble.
139	arthur	-2	2005-01-11 11:21:33	rollercow	For breaking silver by exhausting memory
140	rollercow	3	2005-01-11 23:28:56	welshbyte	For leaving SUCS in a pretty good state after his year of presidency
141	sits	1	2005-01-11 23:30:11	welshbyte	For persisting on the USB flash card problem even though he doesnt own one
142	sits	2	2005-01-25 13:44:21	rollercow	For assistance with the upgrade of silver to FC3
143	vortex	1	2005-01-25 13:45:44	chckens	For installing Ubuntu on his laptop... almost Debian :-)
147	wedge	1	2005-02-01 15:06:56	welshbyte	For BZFlag tournament posterage and donating his bluetac to SUCS
148	welshbyte	1	2005-02-02 18:16:12	wedge	For assisting me with putting up lots of posters (even if some of them mysteriously disappeared within a day).
149	arthur	-1	2005-02-07 10:36:00	wedge	For resetting the BZ server scores by changing the map before we could get much-needed aforementioned scores in our tournament.
150	vortex	1	2005-02-07 10:36:55	wedge	Helping at the stall thing and encouraging passers-by to be interested with Red vs Blue DVDs.
151	rollercow	1	2005-02-07 10:37:37	wedge	Helping out at BZ Tournament. (I have no idea what you did, I do, however, know you were there).
152	welshbyte	1	2005-02-07 10:38:33	wedge	BZ Tournament stuff. Other niftiness associated with our stall and things.
153	davea	1	2005-02-07 10:39:08	wedge	Helping with stall and BZ Tournament and whatnot.
154	stringfellow	1	2005-02-07 10:40:01	wedge	Helping with BZ things. Handing out about 300 flyers in all.
155	rollercow	-2	2005-02-08 15:52:28	wedge	For beating me repeatedly with the blue thing (and also being bigger and stronger than me).
156	pwb	1	2005-02-13 23:53:47	stringfellow	For performing CPR on gw 13th Feb :D
157	wedge	-1	2005-02-14 00:18:00	vortex	For excessively awarding bananas.
159	rollercow	1	2005-02-17 16:06:35	wedge	For the sandwich which we kidnapped, held hostage in the cupboard (in full view) and I eventually ate with his permission. Very tasty.
160	vortex	1	2005-02-17 16:08:27	wedge	For loaning me Seasons one and two of (light) Red vs Blue on two occasions. It rocked.
161	pwb	1	2005-02-22 12:33:10	wedge	For emptying the bin after about 6 months' worth of nagging and complaining at him. Yay Pete!
162	rollercow	2	2005-02-22 12:33:31	wedge	For being the best thing ever.
164	arthur	1	2005-02-22 12:35:28	wedge	For LOOMING ominously.
165	welshbyte	1	2005-03-11 19:13:04	welshbyte	For testing the banana adding script after auditing the file
166	rollercow	1	2005-03-12 11:43:13	wedge	For coming in to fix gateway at least twice.
167	welshbyte	2	2005-03-12 11:44:13	wedge	For hoovering. Everyone loves hoovering.
168	wedge	2	2005-03-12 14:28:08	davea	For cleaning every surface in sight
169	chckens	-3	2005-03-13 01:40:49	welshbyte	For trying to make us give you bananas
170	davea	1	2005-03-13 01:42:25	welshbyte	For tidying up the room with wedge this morning
171	wedge	1	2005-03-13 01:42:57	welshbyte	For tidying up the room and cleaning the grubby keyboards this morning
172	davea	2	2005-03-17 14:30:34	wedge	For a quite ridiculous level of cleaning. Frighteningly much cleaning.
173	welshbyte	-2	2005-04-11 08:23:48	rollercow	For committing banana fraud
174	welshbyte	3	2005-04-11 08:25:33	rollercow	For checking large chunks of the website for stupid things like sql injection flaws.
175	wedge	-1	2005-04-11 08:35:13	rollercow	For describing me as "the best <b>thing</b> ever"
176	cmckenna	1	2005-04-24 11:14:37	wedge	For attempting to get hold of Art when Silver broke one day and nobody could log in and everything was bad.
177	stringfellow	-1	2005-04-29 12:22:06	rollercow	For leaving half drunk bottels of Dr Pepper about the room for weeks on end
178	pwb	-2	2005-04-29 12:22:50	rollercow	For leaving his empty coffee cups around the room even after being pesterd about it several times
179	chckens	3	2005-05-11 19:40:23	welshbyte	For staying up late (7:30pm) to fix up the planet.sucs.org web page to look like the rest of them.
180	jo	-1	2005-05-12 14:32:53	welshbyte	For blatant chocolate theft
181	welshbyte	-1	2005-05-12 15:00:49	jo	For blatantly teasing me with chocolate until I could not control my womanly urges and had to steal it.
182	rollercow	-1	2005-05-12 17:54:37	jo	For being crap at xblast and following me round so I died when he numptied himself on the bombs.
183	rollercow	1	2005-05-12 17:55:08	jo	For being crap at xblast and following TR round so TR died when rc numptied himself on the bombs.
184	arthur	3	2005-05-12 17:56:08	jo	For digging out and reinstalling xblast on request, so that I could blow people up.
185	theraven	1	2005-05-12 17:56:57	jo	For admitting that I am better than him at xblast
186	shadows	1	2005-05-12 17:59:26	jo	For being a society whose members are entirely women.  Bendy women.  
187	jo	1	2005-05-12 18:18:14	welshbyte	Because the last one wasnt organic
188	stringfellow	-3	2005-05-13 13:08:44	arthur	For the oranges, for not getting the joke, and for implimenting it very very badly.
189	pwb	1	2005-05-13 19:57:47	chckens	For fixing the banana script to show people who have a banana score totalling zero (e.g. me :D)
190	seymansey	2	2005-05-23 19:03:13	davea	For tidying and hoovering the room.
191	arthur	1	2005-05-25 10:26:15	wedge	For using the word cock-a-maime in a semi-serious way without being self-conscious. Brilliance.
192	jslootweg	2	2005-05-28 11:48:26	davea	For helping to move a shed load of pallettes
193	rollercow	1	2005-06-28 14:13:08	jo	For isntalling a very useful tool
194	rollercow	-3	2005-06-28 14:14:10	jo	For installing a very useful tool that had a security hole in it, and letting someone exploit aforementioned hole.
195	pwb	-3	2005-09-01 14:06:41	welshbyte	For stealing Chris's wok and disappearing
196	pwb	-3	2005-09-01 14:21:53	rollercow	For being wok thief and dirty scoundrel for not returning it
197	greggwilliams	1	2005-09-14 18:00:07	davea	For having a steadier soldering hand than me when fixing door.
198	elsmorian	1	2005-10-04 16:29:43	wedge	For helping at Freshers' Fayre (a bit).
199	vortex	1	2005-10-04 16:30:58	wedge	For helping out at Freshers' Fayre.
200	chckens	2	2005-10-04 16:31:37	wedge	For tons of help at Freshers' Fayre 2005 over more than one day.
201	wedge	1	2005-11-10 11:32:28	elsmorian	For giving me a loverly big bar of Galaxy for my Birthday.
202	wedge	1	2005-12-21 06:56:21	talyn256	For his delicious nifties. And general niftiness. And giving me a Christmas card. Which I chewed up and abandoned.
203	arthur	1	2005-12-21 06:57:38	talyn256	For helping me out with C.
204	saya	2	2006-02-20 13:44:15	wedge	For cleaning the sink, U-bend, etc. Superb dedication and hard work won the day.
205	saya	1	2006-03-02 21:12:51	wedge	For making me laugh a stupid amount with her 'Firefury has a sister?' comment (following a nearly-identical comment made by him referring to Saya's sister). Perhaps you had to be there, perhaps it was just awesome.
206	rollercow	1	2006-03-06 16:24:27	wedge	For fixing the webcam (but not the java stream viewer)
207	psycodom	1	2006-03-09 11:52:34	wedge	For checking an awkward line number for a Shakespeare thing for me. It was useful and saved me time and effort and stuff.
208	akyan	1	2006-03-16 19:22:47	chckens	For running a massive long network cable between the dining room and Divas... and getting through merely double the minimum number of RJ45 plugs
209	bogglesteinsky	1	2006-03-16 19:30:34	chckens	For running a massive long network cable between the dining room and Divas... And sitting patiently in a dark corner for a long time before we actually made the thing work
210	talyn256	1	2006-03-16 21:46:31	chckens	For running a massive long network cable between the dining room and Divas... Or so I'm told, cause you ran off before I actually saw you do anything ;-)
211	elsmorian	1	2006-03-16 21:53:02	talyn256	For hosting the SUCS Red Dwarf night every week without fail. And having a massive room with a massive projector screen.
212	elsmorian	-1	2006-03-22 17:32:25	welshbyte	For consistently not getting a hair cut
213	elsmorian	1	2006-03-22 17:36:46	saya	For all those times he's put the cleaner over in the room. _Now_ will you stop complaining :)
214	LIS	-10	2006-01-10 05:06:06	welshbyte	For firewalling off nntp, being slow at replying to emails, not implementing IPv6 and for having an insane OS on most of their machines. Ah that feels better.
215	saya	1	2006-03-22 20:51:37	chckens	For brightening up the room by making colourful updated versions of the "Did you know?" posters... and recycling (mutilating?) some old Ubuntu discs into an attractive wall decoration
216	rollercow	1	2006-03-23 00:12:10	saya	For helping me print out new posters for the room :)
217	chckens	1	2006-03-23 00:12:32	saya	For helping me print out new posters for the room :)
218	welshbyte	1	2006-03-23 00:15:54	saya	For helping me print out new posters for the room :)
219	vortex	1	2006-03-23 09:26:50	saya	For taking me all the to Asda to get my toffypop fix the other day ^^
220	vortex	2	2006-05-13 22:42:51	seymansey	For kindly giving me a SVideo cable for my powerbook and letting me whine to him about the AIAPPs c/w
221	welshbyte	1	2006-05-14 21:36:43	wedge	For his Communist-fighting haircut. I promise to remember its proud service in Vietnam every Veterans' Day.
222	frosty	-155	2006-05-30 15:34:38	rollercow	6 months+ to sort out a logo? Need I say more?
223	welshbyte	-1	2006-05-30 17:20:08	jo	For moving his head out of optimum trajectory thus causing the mighty power of a flip flop to ravage silver.
224	frosty	3	2006-06-04 16:35:45	rollercow	For <b>finally</b> sorting out the replacement logos.
225	chckens	2	2006-06-04 17:13:53	rollercow	For audting and converting to PHP5 bits of the sucs website.
226	chckens	1	2006-06-04 17:14:46	rollercow	For reimplementing the vote script, in a more sane fashion.
227	sits	2	2006-06-04 17:16:50	rollercow	For helping to upgrade to FC5, and being master of all things related to selinux.
228	saya	1	2006-06-04 17:19:12	rollercow	For biting certian people.
229	saya	-1	2006-06-04 17:19:22	rollercow	For biting certian people.
230	pwb	1	2006-06-04 17:23:25	rollercow	For finally returning said wok
231	frosty	3	2006-06-10 00:22:45	worldinsideme	For announcing the logo on time!
232	vortex	1	2006-06-10 00:26:50	frosty	Taking us to Tescos to buy party supplies!
233	vortex	-1	2006-06-10 00:27:19	frosty	Dropping us off at some traffic lights and driving back to Port Talbot with all of our shopping still in your boot!
234	vortex	1	2006-06-10 00:27:41	frosty	Coming all the way back to bring the shopping back! Legend!
235	frosty	3	2006-06-10 00:34:28	seymansey	For whipping up a page to show the new logo in uber quick time. 
237	chckens	1	2006-06-10 10:35:12	elsmorian	For scouring campus for wood and pallets
238	welshbyte	1	2006-06-10 10:35:31	elsmorian	For scouring campus for wood and pallets
239	talyn256	1	2006-06-10 10:35:46	elsmorian	For scouring campus for wood and pallets
240	worldinsideme	1	2006-06-10 10:36:06	elsmorian	For scouring campus for wood and pallets
241	frosty	1	2006-06-10 10:37:12	elsmorian	For scouring campus for wood and pallets, and nicking one all by yourself :)
242	elsmorian	1	2006-06-10 10:37:41	elsmorian	For scouring campus for wood and pallets
243	elsmorian	1	2006-06-12 23:23:06	seymansey	For taking lots of cool pics at the beach party.
244	elsmorian	-3	2006-06-12 23:23:31	seymansey	For buggering off to a party before uploading the cool pics :(
245	jo	1	2006-06-12 23:26:05	seymansey	For the rum + jaffa cakes idea at the beach party
246	davea	2	2006-06-12 23:27:29	seymansey	For going to the SUCS room with me to buy a poxy DVD (to open the doors), and i've disturbed him a bazillion times during revision with my 'filling a glass with coke' impression.
247	elsmorian	-1	2006-06-13 18:23:18	seymansey	STILL hasn't uploaded the pictures, after teasing me with one of them!
248	frosty	2	2006-06-14 14:55:04	welshbyte	For hoovering the beach party remnants out of the room
249	welshbyte	-1	2006-06-20 16:57:06	arthur	For putting an entry on the sucs wiki (webdav) which links to an offsite personal page. External pages, and even personal local pages, are to be considered transient and are to be avoided.
250	arthur	1	2006-06-30 00:09:34	worldinsideme	For creating a wiki to help the admin team get organised
251	wedge	-1	2006-07-06 23:37:03	welshbyte	For trying to extort money out of people by tempting them with shiny yellow SUCS bananas. Shame on you.
252	firefury	-1	2006-07-06 23:47:13	wedge	for being 'a complete tit' (by his own admission)
253	elsmorian	-1	2006-07-06 23:48:37	wedge	for awarding everyone else bananas for campus-scouring but not me in a heartbreaking fashion
254	worldinsideme	1	2006-08-10 19:51:18	chckens	For his impressive display of optimism in the what-time-will-the-network-explode contest on Monday evening
255	davea	1	2006-08-10 19:52:40	chckens	For eventually getting around to implementing the games server access control system
257	rohan	3	2006-09-13 09:53:04	pwb	For donating a long Cat5 cable to SUCS in my hour of need
258	rohan	3	2006-09-13 15:03:47	pwb	Performing a life-saving PSU transplant on silver
259	sara	2	2006-09-21 23:25:35	saya	For coming up with a neat idea for Freshers' and _doing_ it :) (and also for cooking a lush Chinese in the same night).
260	elsmorian	-1	2006-09-21 23:27:24	saya	For giving me a green banana for "breaking the sink" when it was already broken.
261	frosty	1	2006-09-21 23:29:34	saya	For coming over to Sara's this evening and talking Fresher's and being productive.
262	rollercow	-1	2006-09-23 00:38:38	welshbyte	For giving a society an account without getting the membership fee first.
144	Dez	3	2005-01-25 13:46:11	rollercow	For creating the page style of the 2004/5 members CD, The help wiki, and a new links system
256	Dez	2	2006-08-18 19:01:17	welshbyte	For being the person doing the most work towards developing a new SUCS website.
236	saya	-1	2006-06-10 10:33:36	elsmorian	For breaking the sink &amp; U-bend and promising to fix it, then going home!
\.


--
-- Data for Name: books; Type: TABLE DATA; Schema: public; Owner: chckens
--

COPY books (id, title, author, keywords, comments, onloan, loandate, publisher, loanwho, got, isbn, amazon_data, image_url) FROM stdin;
5	Unix for Dummies	IDG Books	Unix Linux	2nd Edition	f	\N	IDG Books	\N	f	\N	\N	\N
107	Beginning C++	Ivor Horton	C++ Programming	ANSI/ISO Compliant C++, ugly bloke on the front cover	f	\N	Wrox	\N	\N	\N	\N	\N
43	Mastering Linux	Arman Danesh	linux	Published in 1999	f	\N	Sybex	aggie	t	\N	\N	\N
16	Practical Unix and Internet Security	O\\'Reilly	Unix Linux Internet Security	2nd Edition	f	\N	O'Reilly	\N	t	\N	\N	\N
13	sendmail	Bryan Costales with Eric Allman	sendmail smtp	Second edition	f	\N	O'Reilly	\N	t	\N	\N	\N
36	Overview of XView Programming	Dan Heller, Dale Dougherty and Adrian Nye	xview programming	Draft. Published in 1989	f	\N	O'Reilly	\N	t	\N	\N	\N
8	Running Linux	Matt Welsh and Lar Kaufman	Linux Unix Admin	2nd Edition	f	\N	O'Reilly	davea	t	\N	\N	\N
27	Software Process	Wiley	software process engineering	Published in August 1995. Pilot issue.	f	\N	Wiley	\N	t	\N	\N	\N
31	Turbo Pascal Reference Guide	Borland	turbo pascal reference guide programming	Published in 1988	f	\N	Borland	\N	t	\N	\N	\N
9	Teach Yourself Javascript in a Week	Arman Danesh	Javascript	donated by Brian Fegler	f	\N	sams.net	schpengle	t	\N	\N	\N
19	Turbo Pascal User's Guide	Borland	turbo pascal user guide programming		f	\N	Borland	\N	t	\N	\N	\N
56	Turbo Pascal Reference Guide	Borland	turbo pascal reference guide programming	Published in 1988	f	\N	Borland	\N	t	\N	\N	\N
57	Turbo Pascal Reference Guide	Borland	turbo pascal reference guide programming	Published in 1988	f	\N	Borland	\N	t	\N	\N	\N
20	Microsoft MS-DOS User's Guide and Reference	Microsoft	microsoft ms-dos user guide	User guide for MS-DOS version 5.00	f	\N	Microsoft	\N	t	\N	\N	\N
39	Turbo Prolog 2.0 User's Guide	Borland	turbo prolog user guide		f	\N	Borland	\N	t	\N	\N	\N
58	Turbo Prolog 2.0 Reference Guide	Borland	turbo prolog reference guide	\N	f	\N	Borland	\N	t	\N	\N	\N
59	TopSpeed Pascal Language Reference	Jensen & Partners	topspeed pascal language reference	Published in 1991	f	\N	Jensen & Partners	\N	\N	\N	\N	\N
60	TopSpeed Pascal Library Reference	Jensen & Partners	topspeed pascal library reference	Published in 1991	f	\N	Jensen & Partners	\N	\N	\N	\N	\N
134	The Root of All Evil	Illiad		Donated by Steven Whitehouse (rohan) 28/10/05	f	\N	O'Reilly	\N	\N	\N	\N	\N
38	Teach Yourself Visual Basic 6 in 21 Days	Greg Perry	visual basic	Published in 1998	t	2004-10-20 14:12:33.64087+01	Sams	o2m4	t	\N	\N	\N
6	Unix in a Nutshell	Daniel Gilly	Unix Linux	2nd Edition (with corrections)	f	\N	O'Reilly	schpengle	t	\N	\N	\N
67	Linux from Scratch	Gerard Beekmans	Linux distribution	How to create your very own distribution of Linux. Donated by Steven Whitehouse	f	\N	Clearly Open	\N	\N	\N	\N	\N
61	Linux from Scratch	Gerard Beekmans	Linux distribution	How to create your very own distribution of Linux. Donated by Steven Whitehouse	f	\N	Clearly Open	\N	\N	\N	\N	\N
50	Red Hat Linux Unleashed	Kamran Husain, Timothy Parker	redhat linux admin	Contains redhat 3.0.3 cdrom	f	\N	Sams	davea	t	\N	\N	\N
125	Data Analysis for Data Base Design	DR Howe			f	\N	Edward Arnold	\N	\N	\N	\N	\N
46	C Programming Language, The	Brian W. Kernighan & Dennis M. Ritchie	C ANSI K&R	The definitive guide to the C language.  2nd edition.	t	2002-11-06 14:15:13+00	Prentice Hall	cj	t	\N	\N	\N
12	Web Site Programming with Java 1.0	David Harms, Barton C. Fiske, Jeffrey C. Rice	WWW Java Programming		f	\N	McGraw Hill	schpengle	t	\N	\N	\N
129	MCSE Microsoft Internet Security and Acceleration Server 2000	Microsoft			f	\N	Microsoft Press	\N	\N	\N	\N	\N
69	Apache The Definitive Guide	Ben Laurie & Peter Laurie	apache web	A guide to the open source Apache web server. Donated by Steven Whitehouse	f	\N	O'Reilly	\N	\N	\N	\N	\N
71	Stopping Spam	Alan Schwartz & Simson Garfinkel	spam	A guide to spam and how to stop it. Donated by Steven Whitehouse	f	\N	O'Reilly	\N	\N	\N	\N	\N
70	Stopping Spam	Alan Schwartz & Simson Garfinkel	spam	A guide to spam and how to stop it. Donated by Steven Whitehouse	f	\N	O'Reilly	\N	\N	\N	\N	\N
80	Compilers Principles, Techniques and Tools	Aho, Sethi and Ullman	Compilers	Donated by Mr Chris Whyley, 28/02/05\r\nThe Dragon Book	f	\N	Addison-Wesley	davea	\N	\N	\N	\N
130	Applied Numerical Methods with Personal Computers	Alkis Constantinides			f	\N	McGraw-Hill Book Company	\N	\N	\N	\N	\N
52	TCP/IP Illustrated, Volume 1	W Richard Stevens	tcpip ip networking	The Protocols	f	\N	Addison Wesley	schpengle	t	\N	\N	\N
110	Java For Students	Douglas Bell & Mike Parr	Java Programming	A Java programming book for students illustrated with pretty graphics and diagrams.\r\nDonated by Dr Grant 26/4/05	f	\N	Prentice Hall Europe	\N	\N	\N	\N	\N
132	Evil Geniuses in a Nutshell	Illiad		A User Friendly Guide to World Domination\r\n\r\nDonated by Steven Whitehouse (rohan) 28/10/05	f	\N	O'Reilly	\N	\N	\N	\N	\N
133	Evil Geniuses in a Nutshell	Illiad		A User Friendly Guide to World Domination\r\n\r\nDonated by Steven Whitehouse (rohan) 28/10/05	f	\N	O'Reilly	\N	\N	\N	\N	\N
34	Prolog Programming	Nigel Ford	prolog programming	Published in 1989	f	\N	Wiley	welshbyte	t	\N	\N	\N
145	Perl Best Practices	Damian Conway	perl	From the O'Reilly European Open Source Convention 2005.\r\n\r\nDonated by Mr. Andy Gimblett	f	\N	O'Reilly	\N	\N	\N	\N	\N
77	UNIX for the Impatient	Abrahams and Larson	UNIX	Donated by Mr Chris Whyley, 28/02/05	f	\N	Addison-Wesley	\N	\N	\N	\N	\N
78	A Glossary of Computing Terms (10th)	British Computing Society	Glossary Terms	Donated by Mr Chris Whyley, 28/02/05	f	\N	Addison-Wesley	\N	\N	\N	\N	\N
89	Survey of Operating Systems	Janes Holcombe / Charles Holcombe	Operating systems	Donated by Mr Andy Gimblett, 8/03/2005	f	\N	McGraw Hill	\N	\N	\N	\N	\N
10	C++ for Dummies	IDG Books	C++ Programming	2nd Edition	t	2006-02-08 09:55:28.858214+00	IDG Books	vortex	t	\N	\N	\N
84	Prolog and Expert Systems	Kenneth A. Bowen	Prolog expert systems	Donated by Dr Roger Stein, 28/02/05	f	\N	Mc Graw Hill	\N	\N	\N	\N	\N
48	Core PHP Programming	Leon Atkinson	PHP web scripting dynamic	Second edition, covers PHP 4.  CDROM included.	t	2005-09-13 17:01:23.873646+01	PH PTR	greggwilliams	t	\N	\N	\N
53	Apache The Definitive Guide	Ben Laurie & Peter Laurie	apache web	A guide to the open source Apache web server.	t	2005-09-30 14:10:33.571164+01	O'Reilly	greggwilliams	t	\N	\N	\N
17	DNS and BIND	Paul Albitz & Cricket Liu	DNS BIND named	1st Edition (with corrections)	t	2005-09-30 14:13:03.854259+01	O'Reilly	greggwilliams	t	\N	\N	\N
112	Information and Data Modelling	David Benyon		Information and data modelling is concerned with information for enterprise management. It will inform the manager, and the student of mamagement, how to approache the gathering and storage of data so that effective information can be made avalible... analysis, structure, 	f	\N	Blackwell Scientific Publications	\N	\N	\N	\N	\N
113	Relational Database Principles	Colin Ritchie		This book is a practical introduction to the practice and principles of relational databases for HND and undergraduate computing sudents	f	\N	continuum	\N	\N	\N	\N	\N
114	Introduction to Database on Microcomputers	Geoff Sharman			f	\N	Addison-Wesley Publishing Company	\N	\N	\N	\N	\N
115	Foundation Maths	Anthony Croft and Robert Davison			f	\N	Prentice Hall	\N	\N	\N	\N	\N
116	An Introduction to Data Structures	Brain Boffey and Derek Yates			f	\N	Chartwell Bratt	\N	\N	\N	\N	\N
90	Introduction to UNIX and Linux	John Muster	UNIX Linux	On loan from Mr Andy Gimblett, 8/03/2005\r\nReference copy only - not to leave the room.	f	\N	McGraw Hill	\N	\N	\N	\N	\N
95	Introduction to UNIX and Linux - Lab Manual	Creary / Cottrell	UNIX Linux Lab	On loan from Mr Andy Gimblett, 8/03/2005\r\nReference copy only - not to leave the room.	f	\N	McGraw Hill	\N	\N	\N	\N	\N
96	Introducing UNIX and Linux	Joy, Jarvis & Luck	UNIX Linux Tutorial	On loan from Mr Andy Gimblett, 8/03/2005\r\nReference copy only - not to leave the room.	f	\N	Palgrave MacMillan	\N	\N	\N	\N	\N
147	Learning GNU Emacs	Debra Cameron, James Elliott, Marc Loy	emacs editor	Donated by chckens (25/5/06)	f	\N	O'Reilly	\N	\N	\N	\N	\N
117	Databases, an introduction	David M. Rothwell			f	\N	McGraw-Hill Book Company	\N	\N	\N	\N	\N
118	Systems Desgin in the Fourth Generation	John A Lehman			f	\N	John Wiley & Sons	\N	\N	\N	\N	\N
119	Database Management (2nd Ed)	Fred R. McFadden and Jeffrey A. Hoffer			f	\N	The Benjamin/Cummings Publishing Company	\N	\N	\N	\N	\N
106	Algorithms (international edition)	Richard Johnsonbaugh and Marcus Schaefer	algorithms	"Algorithms is written for an introductory upper-level undergraduate or graduate coures in algorithms"\r\n\r\nDonated by Dr. Grant 10/3/05	f	\N	Pearson Prentice Hall	\N	\N	\N	\N	\N
120	Comparative Programing Languages	Leslie B.Wilson			f	\N	Addison-Wesley	\N	\N	\N	\N	\N
121	Visual Basic .NET	Phill Jones			f	\N	continuum	\N	\N	\N	\N	\N
122	MCSE, Designing a Microsoft Windows 2000 Network Infrastructure	Emmett Dulaney and MeasureUp Inc			f	\N	Microsoft Press	\N	\N	\N	\N	\N
135	Programming Perl	Larry Wall, Tom Christiansen & Jon Orwant	Perl	Donated by Steven Whitehouse (rohan) 28/10/05	f	\N	O'Reilly	\N	\N	\N	\N	\N
124	Introductory Java	David Parsons			f	\N	Continuum	\N	\N	\N	\N	\N
15	Learning Perl - MISSING!	O'Reilly	Perl	Gone missing	f	\N	O'Reilly	\N	t	\N	\N	\N
97	Artificial Intelligence 4th Edition	George F Luger	AI Artificial Intelligence	"Structures and Strategies for Complex Problem Solving"\r\n\r\nDonated by Dr. Grant 10/3/05	t	2005-03-14 15:53:37.764704+00	Addison Wesley	vortex	\N	\N	\N	\N
126	From Data to Database	D.S.Bowers			f	\N	Van Nostrand Reinhold (UK)	\N	\N	\N	\N	\N
127	Opperating Systems 4th Ed	Colin Ritchie			f	\N	Continuum	\N	\N	\N	\N	\N
128	Office XP Resource Kit	Mircosoft			f	\N	Microsoft Press	\N	\N	\N	\N	\N
54	DNS and BIND - 3rd Edition	Paul Albitz & Cricket Liu	dns bind	Another copy of the 3rd Edition	f	\N	O'Reilly	davea	t	\N	\N	\N
144	Mobile Interaction Design	Matt Jones and Gary Marsden	hci, design	Donated to the SUCS library by Dr Matt Jones, December 2005.	t	2006-06-09 14:49:21.440574+01	Wiley	davea	\N	\N	\N	\N
40	sed &amp; awk	Dale Dougherty & Arnold Robbins	sed awk grep unix regexp	2nd Edition	f	\N	O'Reilly	talyn256	t	\N	\N	\N
109	Objects First With Java	Barnes & Kolling	Java BlueJ Programming	A practical introduction to using BlueJ\r\nDonated by Dr Grant 26/4/05	f	\N	Prentice Hall	chckens	\N	\N	\N	\N
11	CGI Programming on the World Wide Web - MISSING	O'Reilly	CGI Programming WWW HTML	donated by Rhys Jones	f	\N	O'Reilly	\N	f	\N	\N	\N
111	Linux Answers - MISSING!	Linux Format		A book of FAQ's	f	\N	Linux Format	\N	\N	\N	\N	\N
72	Stopping Spam	Alan Schwartz & Simson Garfinkel	spam	A guide to spam and how to stop it. Donated by Steven Whitehouse	f	\N	O'Reilly	\N	\N	\N	\N	\N
63	Managing NFS and NIS	Hal Stern	NFS NIS	An in-depth guide to the Network Filesystem and the Network Informations System. First edition (with corrections). Donated by Steven Whitehouse	f	\N	O'Reilly	welshbyte	\N	\N	\N	\N
105	Prolog Programming for Artifical Intelligence 2nd ed.	Ivan Bratko	prolog programming ai artificial intelligence	Page 54: "the monkey is on the floor before and  after the move"\r\n\r\nDonated by Dr. Grant 10/3/05	f	\N	Addison Wesley	welshbyte	\N	\N	\N	\N
136	Managing NFS and NIS 2nd Edition	Hal Stern, Mike Eisler & Ricardo Labiaga	NFS NIS	Donated by Steven Whitehouse (rohan) 28/10/05	t	2006-05-05 21:00:17.766451+01	O'Reilly	welshbyte	\N	\N	\N	\N
79	Small Java How To Program	Deitel & Deitel	Java Programming	Donated by Mr Chris Whyley, 28/02/05\r\nSixth Edition	f	\N	Prentice Hall	ioandavies1	\N	\N	\N	\N
131	Evil Geniuses in a Nutshell	Illiad		A User Friendly Guide to World Domination\r\n\r\nDonated by Steven Whitehouse (rohan) 28/10/05	f	\N	O'Reilly	talyn256	\N	\N	\N	\N
146	Mobile Interaction Design	Matt Jones and Gary Marsden	hci, design	Donated to the SUCS library by Dr Matt Jones, January 2006.	t	2006-05-09 12:57:55.47425+01	Wiley	tobeon	\N	\N	\N	\N
148	LDAP System Administration	rollercow	ldap ldif	Owned by rollercow, but can be taken out if you ask nicely.	f	\N	O'Reilly	\N	\N	\N	\N	\N
86	Fundamentals of Database Systems 2nd Edition	Elmasri / Navathe	Database DB	Donated by Dr Roger Stein, 28/02/05	f	\N	Adison / Wesley	\N	\N	0805301453	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>190YD3QHMXGMPW806MZA</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0805301453"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.046004056930542</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0805301453</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0805301453</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0805301453%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0805301453%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>1980314</SalesRank><ItemAttributes><Author>Ramez Elmasri</Author><Binding>Hardcover</Binding><EAN>9780805301458</EAN><ISBN>0805301453</ISBN><Label>Benjamin/Cummings</Label><ListPrice><Amount>5495</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$54.95</FormattedPrice></ListPrice><Manufacturer>Benjamin/Cummings</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>802</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">940</Height><Length Units="hundredths-inches">150</Length><Weight Units="hundredths-pounds">332</Weight><Width Units="hundredths-inches">800</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1989-06</PublicationDate><Publisher>Benjamin/Cummings</Publisher><Studio>Benjamin/Cummings</Studio><Title>Fundamentals of database systems</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>255</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$2.55</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>49</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.49</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>400</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$4.00</FormattedPrice></LowestCollectiblePrice><TotalNew>2</TotalNew><TotalUsed>24</TotalUsed><TotalCollectible>3</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>Responding to the requests of database professors nationwide,the leading textbook for the introductory database management course is being fully revised in time for the startof Fall 1999 classes. Fundamentals of Database Systems, Third Edition is updated to reflect the latest developments indatabase research and practice. It combines clear explanations of theory and real systems, broad coverage of modeling and design of databases, and excellent examples with up-to-date introductions to modern database technology.  &lt;P&gt;Features of the Third Edition  &lt;P&gt;Presents clear and complete discussion of the relational approach including modeling, design, and query languages  &lt;P&gt;Reorganized material on data modeling to clearly separate entity relationship modeling, extended entity relationship modeling, and object-oriented modeling  &lt;P&gt;NEW! Gives examples of real database systems - Oracle and Microsoft Access - in Ch. 10  &lt;P&gt;NEW and EXPANDED! Provides coverage of the object-oriented and object relational approach to data management including ODMG and SQL3  &lt;P&gt;NEW! Includes discussion of decision support applications of data warehousing and data mining, as well as emerging technologies of web databases, multimedia, and mobile databases  &lt;P&gt;NEW! Covers advanced modeling in the areas of active, temporal, and spatial databases  &lt;P&gt;NEW! Discusses current database application areas of GIS, genome, and digital libraries</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	\N
141	Exim The Mail Transfer Agent	Philip Hazel	exim mail transfer agent	Reference/text/tutorial book for the mail transfer agent Exim	f	\N	O'Reilly	\N	\N	0596000987	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0RSPPGC0A4QHMPSTBNMA</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0596000987"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0428891181945801</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0596000987</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0596000987</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0596000987%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0596000987%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>578718</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/0596000987.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">57</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0596000987.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">121</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0596000987.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">377</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/0596000987.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">57</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0596000987.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">121</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0596000987.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">377</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Philip Hazel</Author><Binding>Paperback</Binding><DeweyDecimalNumber>004.692</DeweyDecimalNumber><EAN>9780596000981</EAN><Edition>1st</Edition><ISBN>0596000987</ISBN><Label>O'Reilly Media</Label><ListPrice><Amount>4495</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$44.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly Media</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>624</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">116</Height><Length Units="hundredths-inches">922</Length><Weight Units="hundredths-pounds">197</Weight><Width Units="hundredths-inches">704</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>2001-10-15</PublicationDate><Publisher>O'Reilly Media</Publisher><Studio>O'Reilly Media</Studio><Title>Exim: The Mail Transfer Agent</Title><UPC>636920000983</UPC></ItemAttributes><OfferSummary><LowestNewPrice><Amount>272</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$2.72</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>248</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$2.48</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>4495</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$44.95</FormattedPrice></LowestCollectiblePrice><TotalNew>33</TotalNew><TotalUsed>20</TotalUsed><TotalCollectible>1</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Amazon.com</Source><Content>You can do anything with Sendmail, the saying goes, but why would you want to? The Exim mail-handling daemon is just as capable as the old stalwart of handling everyday electronic mail duties, and far easier to administer. With a style and polish that's typical of the blue-cover series of system administration books from O'Reilly, &lt;I&gt;Exim: The Mail Transfer Agent&lt;/I&gt; shows how to set up and use Exim. You'll be very pleased with this book if you've chosen to work with Exim and require better information than the online documentation can provide. Philip Hazel has done a good job of combining a comprehensive set of details--including lots of command listings--with advice and practical examples that will make an administrator's life easier.&lt;p&gt;  Typical of this approach is the treatment of methods for blocking traffic from bad hosts that attempt to mail to your Exim station. The book runs through alternative techniques--using a public blocking list, blocking hosts explicitly, and so on--in series. Each technique is described in terms of what happens and why, and includes listings of the relevant configuration commands. Other sections, such as those concerned with SMTP configuration, are more reference-like. They contain long lists of commands and options, in which the purpose of each is explained. &lt;I&gt;--David Wall&lt;/I&gt;&lt;p&gt;  &lt;B&gt;Topics covered:&lt;/B&gt; How to set up, configure, and administer the Exim mail-handling agent. Directors, routers, transports, filters, and the integration of Exim with Perl, shell scripts, and database lookups are covered. </Content></EditorialReview><EditorialReview><Source>Book Description</Source><Content>Exim delivers electronic mail, both local and remote. It has all the virtues of a good postman: it's easy to talk to, reliable, efficient, and eager to accommodate even the most complex special requests. It's the default mail transport agent installed on some Linux systems, runs on many versions of Unix, and is suitable for any TCP/IP network with any combination of hosts and end-user mail software.    Exim is growing in popularity because it is open source, scalable, and rich in features such as the following:  &lt;ul&gt;  &lt;li&gt;Compatibility with the calling interfaces and options of  Sendmail (for which Exim is usually a drop-in replacement)  &lt;/li&gt;&lt;li&gt;Lookups in LDAP servers, MySQL and PostgreSQL databases, and NIS or NIS+ services  &lt;/li&gt;&lt;li&gt;Support for many kinds of address parsing, including regular expressions that are compatible with Perl 5  &lt;/li&gt;&lt;li&gt;Sophisticated error handling  &lt;/li&gt;&lt;li&gt;Innumerable tuning parameters for improving performance and handling enormous volumes of mail&lt;/li&gt;  &lt;/ul&gt;    Best of all, Exim is easy to configure. You never have to deal with ruleset 3 or worry that a misplaced asterisk will cause an inadvertent mail bomb.    While a basic configuration is easy to read and can be created quickly, Exim's syntax and behavior do get more subtle as you enter complicated areas like virtual hosting, filtering, and automatic replies. This book is a comprehensive survey that provides quick information for people in a hurry as well as thorough coverage of more advanced material.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/0596000987.01._SCMZZZZZZZ_.jpg
91	Java Enterprise in a Nutshell	Flanagan, Farley, Crawford & Magnusson	Java	Donated by Mr Andy Gimblett, 8/03/2005	f	\N	O'Reilly	\N	\N	1565924835	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0EYQWMQ4N5D2YKN46JX8</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1565924835"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0409839153289795</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1565924835</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1565924835</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1565924835%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1565924835%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>333720</SalesRank><SmallImage><URL>http://ec1.images-amazon.com/images/P/1565924835.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">49</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/1565924835.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">104</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/1565924835.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">325</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://ec1.images-amazon.com/images/P/1565924835.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">49</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/1565924835.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">104</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/1565924835.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">325</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Kris Magnusson</Author><Author>David Flanagan</Author><Author>Jim Farley</Author><Author>William Crawford</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.13</DeweyDecimalNumber><EAN>0636920924838</EAN><Edition>1</Edition><ISBN>1565924835</ISBN><Label>O'Reilly</Label><ListPrice><Amount>2995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$29.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>660</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">112</Height><Length Units="hundredths-inches">902</Length><Weight Units="hundredths-pounds">162</Weight><Width Units="hundredths-inches">605</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1999-09-01</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>Java Enterprise in a Nutshell (In a Nutshell)</Title><UPC>636920924838</UPC></ItemAttributes><OfferSummary><LowestNewPrice><Amount>100</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$1.00</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>23</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.23</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>2995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$29.95</FormattedPrice></LowestCollectiblePrice><TotalNew>20</TotalNew><TotalUsed>47</TotalUsed><TotalCollectible>1</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Amazon.com</Source><Content>&lt;I&gt;Java Enterprise in a Nutshell&lt;/I&gt; gives advanced Java developers a one-stop resource for programming with the disparate APIs required for today's enterprise development, including JDBC, RMI, servlets, and EJBs. Beginning with JDBC database programming, the book gives a chapter-by-chapter tour of various enterprise development APIs, including program strategies for each API. For JDBC, the book includes new Java 2 JDBC enhancements like batch and recordsets. &lt;p&gt; Next comes Java's Remote Method Invocation (RMI) classes for calling remote code. Then it's on to using Java IDL and CORBA basics. A chapter on Java servlets will get you started delivering dynamically generated HTML using Java on Web servers, including useful material on cookies and session management. After coverage of the Java Naming and Directory Interface (JNDI) comes a solid exploration of EJBs with material on both session and entity beans. Specifics here include home and remote interfaces, EJB containers, stateless vs. stateful session beans, and entity beans for accessing corporate databases. &lt;p&gt; Overall, this handy and readable guide to the latest in Java APIs can be truly invaluable to the developer bringing Java to the corporate enterprise for the first time. &lt;I&gt;--Richard Dragan&lt;/I&gt;</Content></EditorialReview><EditorialReview><Source>Book Description</Source><Content>&lt;i&gt;Java Enterprise in a Nutshell&lt;/i&gt; is an indispensable quick reference for Java programmers who are writing distributed enterprise applications.  The book provides fast-paced tutorials on the following Java Enterprise APIs:&lt;p&gt;&lt;ul&gt;&lt;li&gt;JDBC, a vendor-independent API for accessing relational database systems&lt;/li&gt;&lt;li&gt;RMI, a Java-only approach to distributed computing that relies on remote method invocation&lt;/li&gt;&lt;li&gt;Java IDL, a CORBA-based, language-independent approach to distributed computing&lt;/li&gt;&lt;li&gt;Java servlets, a mechanism for extending a web server that allows Java code to perform tasks traditionally handled by CGI scripts&lt;/li&gt;&lt;li&gt;JNDI, a generic Java API for working with networked naming and directory services&lt;li&gt;Enterprise JavaBeans, a component model that separates high-level business logic from low-level housekeeping chores like security and transaction management&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;These APIs are the building blocks of the Java 2 Platform, Enterprise  Edition (J2EE), Sun's recently announced new platform for enterprise computing. J2EE is the standard Java 2 platform with a number of extensions for enterprise development.&lt;p&gt;&lt;i&gt;Java Enterprise in a Nutshell&lt;/i&gt; also contains O'Reilly's classic-style, quick-reference material for all of the classes in the various packages that comprise the Enterprise APIs.  This material includes the core Enterprise APIs that are part of Java 1.2, as well as numerous standard extensions.&lt;p&gt;This book is a companion to both &lt;i&gt;Java in a Nutshell,&lt;/i&gt; 3rd Edition, which covers the key non-graphical, non-enterprise APIs in Java 1.2, and &lt;i&gt;Java Foundation Classes in a Nutshell,&lt;/i&gt; which describes the graphics- and GUI-related classes of Java 1.2.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://ec1.images-amazon.com/images/P/1565924835.01._SCMZZZZZZZ_.jpg
102	Software Design and Development	Philip Gilbert	software development design	"This book presents methods for developing small- to medium-scale software systems"\r\n\r\nDonated by Dr. Grant 10/3/05	f	\N	SRA	\N	\N	0574214305	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0CD9624BNZMY92H2MZEV</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0574214305"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0514130592346191</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0574214305</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0574214305</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0574214305%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0574214305%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>4174522</SalesRank><ItemAttributes><Author>Philip Gilbert</Author><Binding>Paperback</Binding><EAN>9780574214300</EAN><ISBN>0574214305</ISBN><Label>Science Research Associates</Label><ListPrice><Amount>2495</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$24.95</FormattedPrice></ListPrice><Manufacturer>Science Research Associates</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>681</NumberOfPages><ProductGroup>Book</ProductGroup><PublicationDate>1983</PublicationDate><Publisher>Science Research Associates</Publisher><Studio>Science Research Associates</Studio><Title>Software design and development (SRA computer science series)</Title></ItemAttributes><OfferSummary><LowestUsedPrice><Amount>90</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.90</FormattedPrice></LowestUsedPrice><TotalNew>0</TotalNew><TotalUsed>8</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	\N
143	Matrices And Matlab A Tutorial	Marvin Marcus	Matlab matrices tutorial maths	From the back cover:\r\nThis book is designed for a serious one-semester or two-quarter course in elementary matrix theory. It is suitable for undergraduate or graduate students who have successfully completed a standard one-year calculus sequence and are reasonably adept at high school algebra.	f	\N	Prentice Hall	\N	\N	0135629012	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>11TF72EN9T4NE11PZ0P1</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0135629012"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0568368434906006</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0135629012</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0135629012</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0135629012%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0135629012%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>1852509</SalesRank><SmallImage><URL>http://ec1.images-amazon.com/images/P/0135629012.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">42</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/0135629012.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">98</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/0135629012.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">331</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://ec1.images-amazon.com/images/P/0135629012.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">42</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/0135629012.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">98</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/0135629012.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">331</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Marvin Marcus</Author><Binding>Hardcover</Binding><DeweyDecimalNumber>512.94340285</DeweyDecimalNumber><EAN>9780135629017</EAN><Edition>1st</Edition><Format>Facsimile</Format><ISBN>0135629012</ISBN><Label>Prentice Hall</Label><ListPrice><Amount>8860</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$88.60</FormattedPrice></ListPrice><Manufacturer>Prentice Hall</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>736</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">133</Height><Length Units="hundredths-inches">933</Length><Weight Units="hundredths-pounds">234</Weight><Width Units="hundredths-inches">702</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1998-04-07</PublicationDate><Publisher>Prentice Hall</Publisher><Studio>Prentice Hall</Studio><Title>Matrices and MATLAB: A Tutorial</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>2980</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$29.80</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>2277</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$22.77</FormattedPrice></LowestUsedPrice><TotalNew>4</TotalNew><TotalUsed>10</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	http://ec1.images-amazon.com/images/P/0135629012.01._SCMZZZZZZZ_.jpg
35	Xlib Reference Manual	Adrian Nye	xlib reference	Volume Two	f	\N	O'Reilly	\N	t	0937175129	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1ZVHT024TWMYR48ZS5W2</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0937175129"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.077984094619751</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0937175129</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0937175129</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0937175129%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0937175129%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>2862220</SalesRank><ItemAttributes><Author>Adrian Nye</Author><Binding>Paperback</Binding><EAN>9780937175125</EAN><ISBN>0937175129</ISBN><Label>O'Reilly</Label><ListPrice><Amount>3495</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$34.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfItems>1</NumberOfItems><PackageDimensions><Height Units="hundredths-inches">970</Height><Length Units="hundredths-inches">170</Length><Weight Units="hundredths-pounds">302</Weight><Width Units="hundredths-inches">740</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1988</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>Xlib reference manual (The Definitive guides to the X Window System)</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>150</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$1.50</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>1</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.01</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>295</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$2.95</FormattedPrice></LowestCollectiblePrice><TotalNew>4</TotalNew><TotalUsed>14</TotalUsed><TotalCollectible>1</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>Volume 2, &lt;i&gt;Xlib Reference Manual&lt;/i&gt;, is a complete programmer's reference for Xlib. Covers X11 Release 4 and Release 5.    Contents Include:  &lt;ul&gt;&lt;li&gt;Reference pages for Xlib functions&lt;/li&gt;  &lt;li&gt;Reference pages for event types&lt;/li&gt;  &lt;li&gt;Permuted index to Xlib functions&lt;/li&gt;  &lt;li&gt;Description of macros and reference pages for their function versions&lt;/li&gt;  &lt;li&gt;Listing of the server-side color database&lt;/li&gt;  &lt;li&gt;Alphabetical index and description of structures&lt;/li&gt;  &lt;li&gt;Alphabetical index and description of defined symbols&lt;/li&gt;  &lt;li&gt;KeySyms and their meaning&lt;/li&gt;  &lt;li&gt;Illustration of the standard cursor font&lt;/li&gt;  &lt;li&gt;Function group index to the right routine for a particular task&lt;/li&gt;  &lt;li&gt;Reference pages for Xlib-related Xmu functions (miscellaneous utilities)&lt;/li&gt;  &lt;li&gt;Four single-page reference aids for the GC and window attributes&lt;/li&gt;&lt;/ul&gt;    Features in the third edition include:  &lt;ul&gt;&lt;li&gt;Over 100 new man pages covering Xcms, internationalization, and the function versions of macros.&lt;/li&gt;  &lt;li&gt;Updating to the R5 spec.&lt;/li&gt;  &lt;li&gt;New "Returns" sections on all the functions which return values, making this information easier to find.&lt;/li&gt;&lt;/ul&gt;</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	\N
108	Java How To Program	Deitel & Deitel	Java Programming	Third edition. Covers Java 2, introducing Swing\r\nDonated by Dr Grant 26/4/05	f	\N	Prentice Hall	pwb	\N	0130125075	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>00H491EQ7FVSNVQYJWFH</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0130125075"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.067033052444458</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0130125075</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0130125075</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0130125075%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0130125075%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>428312</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/0130125075.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">45</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0130125075.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">106</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0130125075.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">360</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/0130125075.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">45</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0130125075.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">106</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0130125075.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">360</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Harvey M. Deitel</Author><Author>Paul J. Deitel</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.133</DeweyDecimalNumber><EAN>9780130125071</EAN><Edition>3rd Bk&amp;Cdr</Edition><ISBN>0130125075</ISBN><Label>Prentice Hall</Label><ListPrice><Amount>7400</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$74.00</FormattedPrice></ListPrice><Manufacturer>Prentice Hall</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>1355</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">174</Height><Length Units="hundredths-inches">909</Length><Weight Units="hundredths-pounds">434</Weight><Width Units="hundredths-inches">708</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1999-12-15</PublicationDate><Publisher>Prentice Hall</Publisher><Studio>Prentice Hall</Studio><Title>Java How to Program (3rd Edition)</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>500</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$5.00</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>1</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.01</FormattedPrice></LowestUsedPrice><TotalNew>15</TotalNew><TotalUsed>99</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Amazon.com</Source><Content>Dedicated to the principle that more is more, the massive &lt;I&gt;Java: How to Program&lt;/I&gt;, Third Edition, may just be the most comprehensive available textbook for Java. Suitable for both students and home study, this book offers an extremely thorough introduction to Java programming, including all major APIs.&lt;p&gt; The sheer size (and level of detail) presented here is undoubtedly its most impressive feature. Weighing in at over 1,300 pages, it features an almost endless trove of information with over 500 programming tips, over 1,000 summary points, over 900 programming exercises, and a whopping 5,000-plus entries in its index. This is clearly a textbook and reference for students who want to master the entire Java language. The authors present many challenging exercises and examples too, including numerous interesting graphics problems, a simulation for a simple CPU, a compiler (for the same), and an elevator simulation case study. (In all, there is certainly sufficient material in this book for two semesters of college work.)&lt;p&gt; Besides a full tour of all the fundamentals of Java, from basic statements to object-oriented design techniques, the authors also delve into more advanced APIs for servlets, JDBC, RMI, and JavaBeans. (Their guide to Swing components is also a standout here.) &lt;p&gt; While the richness of &lt;I&gt;Java: How-To Program&lt;/I&gt; might intimidate some readers, for those who want to experience all the possibilities of Java, this book is a fine choice for a first textbook on introductory programming in Java. Its authoritative and far-ranging presentation can serve as a reliable and effective guide to the truly exciting world of Java development. &lt;I&gt;--Richard Dragan&lt;/I&gt;&lt;p&gt; &lt;B&gt;Topics covered&lt;/B&gt;: Basic Java, applets and applications, control structures, methods, arrays, object-oriented programming techniques, strings, graphics and Java2D, Swing user interfaces, exceptions, multithreading, multimedia, file I/O, JDBC and databases, servlets, RMI, networking, sockets, custom data structures and collections, and JavaBeans.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/0130125075.01._SCMZZZZZZZ_.jpg
92	Learning the Korn Shell	Bill Rosenblatt	Korn Shell	Donated by Mr Andy Gimblett, 8/03/2005	f	\N	O'Reilly	\N	\N	1565920546	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1BTVXYF8A4NGW20RAAWY</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1565920546"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0541830062866211</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1565920546</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1565920546</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1565920546%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1565920546%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>512365</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/1565920546.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">49</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565920546.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">105</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565920546.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">328</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/1565920546.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">49</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565920546.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">105</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565920546.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">328</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Bill Rosenblatt</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.43</DeweyDecimalNumber><EAN>0636920920540</EAN><Edition>1</Edition><ISBN>1565920546</ISBN><Label>O'Reilly</Label><ListPrice><Amount>3495</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$34.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>360</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">78</Height><Length Units="hundredths-inches">897</Length><Weight Units="hundredths-pounds">113</Weight><Width Units="hundredths-inches">601</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1993-01-15</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>Learning the Korn Shell</Title><UPC>636920920540</UPC></ItemAttributes><OfferSummary><LowestNewPrice><Amount>495</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$4.95</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>103</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$1.03</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>500</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$5.00</FormattedPrice></LowestCollectiblePrice><TotalNew>7</TotalNew><TotalUsed>34</TotalUsed><TotalCollectible>6</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>This Nutshell Handbook(R) is a thorough introduction to the Korn shell, both as a user interface and as a programming language.&lt;p&gt;The Korn shell, like the C and Bourne shells, is a program that interprets UNIX commands. It has many features that aren't found in other shells, including command history (the ability to recall and edit previous commands). The Korn shell is also faster; several of its features allow you to write programs that execute more quickly than their Bourne or C shell equivalents.&lt;p&gt;This book provides a clear and concise explanation of the Korn shell's features. It explains &lt;I&gt;ksh&lt;/I&gt; string operations, co-processes, signals and signal handling, and one of the worst "dark corners" of shell programming: command-line interpretation. It does this by introducing simple real-life examples and then adding options and complexity in later chapters,  illustrating the way real-world script development generally proceeds. An  additional (and unique) programming aid, a Korn shell debugger (&lt;i&gt;kshdb&lt;/i&gt;), is  also included.&lt;p&gt;&lt;i&gt;Learning the Korn Shell&lt;/i&gt; is an ideal resource for many UNIX users and programmers, including software developers who want to "prototype" their designs, system administrators who want to write tools for their own use, and even novices who just want to use some of &lt;i&gt;ksh's&lt;/i&gt; more advanced interactive features.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/1565920546.01._SCMZZZZZZZ_.jpg
30	Software Engineering	Ian Sommerville	software engineering	Third edition	f	\N	Addison-Wesley	\N	t	0201175681	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1X3QA67W2NT42TQ6BXC9</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0201175681"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0483989715576172</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0201175681</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0201175681</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0201175681%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0201175681%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>1212516</SalesRank><ItemAttributes><Author>Ian Sommerville</Author><Binding>Hardcover</Binding><EAN>9780201175684</EAN><Edition>3rd ed</Edition><ISBN>0201175681</ISBN><Label>Addison-Wesley</Label><ListPrice><Amount>2785</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$27.85</FormattedPrice></ListPrice><Manufacturer>Addison-Wesley</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>653</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">806</Height><Length Units="hundredths-inches">55</Length><Weight Units="hundredths-pounds">41</Weight><Width Units="hundredths-inches">538</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1989</PublicationDate><Publisher>Addison-Wesley</Publisher><Studio>Addison-Wesley</Studio><Title>Software engineering (International computer science series)</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>8000</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$80.00</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>150</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$1.50</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>1000</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$10.00</FormattedPrice></LowestCollectiblePrice><TotalNew>2</TotalNew><TotalUsed>15</TotalUsed><TotalCollectible>1</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>The new edition of this best-selling book provides a comprehensive discussion of software  engineering techniques and shows how they can be applied in practical software projects. This book features new coverage of the software process and software process technology, system integration, requirements management, and risk analysis, as well as new chapters on pattern-based reuse, distributed system engineering, and legacy systems. Sommerville has incorporated a more object-oriented approach in this edition&amp;#151;using UML and Java&amp;#151;and has removed much of the material on CASE, formal methods, and Ada, making the book more in tune with current technology and practice. A new discussion of professional ethics in the introduction helps to make readers aware of the responsibilities that come with engineering software.  The sixth edition uses Java for all programming examples, and bases all design examples on UML notation. It includes new chapters on pattern-based reuse, distributed system engineering, and legacy systems, as well as new coverage of the software process and software process technology, system integration, requirements management, and risk analysis.  This book is designed for readers needing a general introduction to software engineering (development, management, and evolution), especially with regard to system requirements engineering and critical systems.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	\N
42	Common LISP	Franz Inc.	lisp reference		f	\N	Addison-Wesley	alexm	t	0201114585	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>04SAQ8RJQ1VBZM7DEC5E</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0201114585"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0554399490356445</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0201114585</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0201114585</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0201114585%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0201114585%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>1012667</SalesRank><ItemAttributes><Author>Franz Inc.</Author><Author>Staff Franz Inc</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.133</DeweyDecimalNumber><EAN>9780201114584</EAN><ISBN>0201114585</ISBN><Label>Addison Wesley Publishing Company</Label><ListPrice><Amount>2995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$29.95</FormattedPrice></ListPrice><Manufacturer>Addison Wesley Publishing Company</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>899</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">154</Height><Length Units="hundredths-inches">920</Length><Weight Units="hundredths-pounds">338</Weight><Width Units="hundredths-inches">736</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1988-12</PublicationDate><Publisher>Addison Wesley Publishing Company</Publisher><Studio>Addison Wesley Publishing Company</Studio><Title>Common Lisp: The Reference</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>2995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$29.95</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>1185</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$11.85</FormattedPrice></LowestUsedPrice><TotalNew>2</TotalNew><TotalUsed>10</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	\N
88	Introduction to the Design and Analysis of Algorithms	Anany Levitin	algorithms	Donated by Dr Monika Seisenberger, 4/03/05	f	\N	Addison Wesley	\N	\N	0201743957	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>00A0NV03E8XZ2MA57HQR</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0201743957"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0562648773193359</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0201743957</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0201743957</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0201743957%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0201743957%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>28055</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/0201743957.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">45</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0201743957.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">105</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0201743957.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">356</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/0201743957.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">45</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0201743957.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">105</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0201743957.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">356</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Anany V. Levitin</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.1</DeweyDecimalNumber><EAN>9780201743951</EAN><Edition>1st</Edition><ISBN>0201743957</ISBN><Label>Addison Wesley</Label><ListPrice><Amount>9720</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$97.20</FormattedPrice></ListPrice><Manufacturer>Addison Wesley</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>528</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">115</Height><Length Units="hundredths-inches">948</Length><Weight Units="hundredths-pounds">217</Weight><Width Units="hundredths-inches">754</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>2002-10-30</PublicationDate><Publisher>Addison Wesley</Publisher><Studio>Addison Wesley</Studio><Title>Introduction to the Design and Analysis of Algorithms</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>5832</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$58.32</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>3998</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$39.98</FormattedPrice></LowestUsedPrice><TotalNew>20</TotalNew><TotalUsed>16</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>&lt;P&gt;&lt;B&gt;&lt;/B&gt; Based on a new classification of algorithm design techniques and a clear delineation of analysis methods, &lt;I&gt;Introduction to the Design and Analysis of Algorithms&lt;/I&gt; presents the subject in a truly innovative manner. &lt;B&gt;&lt;/B&gt;Written in a reader-friendly style, the book encourages broad problem-solving skills while thoroughly covering the material required for introductory algorithms. The author emphasizes conceptual understanding before the introduction of the formal treatment of each technique. Popular puzzles are used to motivate readers' interest and strengthen their skills in algorithmic problem solving. Other enhancement features include chapter summaries, hints to the exercises, and a solution manual. &lt;B&gt;&lt;/B&gt; For those interested in learning more about algorithms.  &lt;/P&gt;</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/0201743957.01._SCMZZZZZZZ_.jpg
41	Xlib Programming Manual	Adrian Nye	xlib programming unix	Volume One	f	\N	O'Reilly	\N	t	0937175269	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>028MATG2XHYV9A6KEBNG</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0937175269"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0483028888702393</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0937175269</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0937175269</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0937175269%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0937175269%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>2244127</SalesRank><ItemAttributes><Author>Adrian Nye</Author><Binding>Paperback</Binding><EAN>9780937175262</EAN><Edition>3</Edition><ISBN>0937175269</ISBN><Label>O'Reilly Media</Label><ListPrice><Amount>6000</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$60.00</FormattedPrice></ListPrice><Manufacturer>O'Reilly Media</Manufacturer><NumberOfItems>1</NumberOfItems><PackageDimensions><Weight Units="hundredths-pounds">110</Weight></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1989-12-01</PublicationDate><Publisher>O'Reilly Media</Publisher><Studio>O'Reilly Media</Studio><Title>Xlib Programming Manual &amp; Xlib Reference Manual, Vols. I &amp; II (Definitive Guides to the X Window System)</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>395</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$3.95</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>25</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.25</FormattedPrice></LowestUsedPrice><TotalNew>4</TotalNew><TotalUsed>14</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>Covering X11 Release 5, the &lt;i&gt;Xlib Programming Manual&lt;/i&gt; is a complete guide to programming the X library (Xlib), the lowest level of programming interface to X. It includes introductions to internationalization, device-independent color, font service, and scalable fonts.    Includes chapters on:    &lt;ul&gt;&lt;li&gt;X Window System concepts&lt;/li&gt;  &lt;li&gt;A simple client application&lt;/li&gt;  &lt;li&gt;Window attributes&lt;/li&gt;  &lt;li&gt;The graphics context&lt;/li&gt;  &lt;li&gt;Graphics in practice&lt;/li&gt;  &lt;li&gt;Color&lt;/li&gt;  &lt;li&gt;Events&lt;/li&gt;  &lt;li&gt;Interclient communication&lt;/li&gt;  &lt;li&gt;Internationalization&lt;/li&gt;  &lt;li&gt;The Resource Manager&lt;/li&gt;  &lt;li&gt;A complete client application  &lt;li&gt;Window management&lt;/li&gt;&lt;/ul&gt;    This manual is a companion to Volume 2, &lt;i&gt;Xlib Reference Manual&lt;/i&gt;.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	\N
81	Automated Reasoning	Wos Overbeek Lusk and Boyle	Reasoning	Donated by Dr Roger Stein, 28/02/05	f	\N	Prentice Hall	\N	\N	0130544469	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0D6GTT0A3NZ6XGACMZXH</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0130544469"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0505068302154541</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0130544469</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0130544469</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0130544469%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0130544469%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>1639914</SalesRank><ItemAttributes><Author>Larry Wos</Author><Author>Ross Overbeek</Author><Author>Ewing Lusk</Author><Author>Jim Boyle</Author><Binding>Paperback</Binding><EAN>9780130544469</EAN><ISBN>0130544469</ISBN><Label>Prentice Hall</Label><ListPrice><Amount>2100</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$21.00</FormattedPrice></ListPrice><Manufacturer>Prentice Hall</Manufacturer><ProductGroup>Book</ProductGroup><PublicationDate>1984-02</PublicationDate><Publisher>Prentice Hall</Publisher><Studio>Prentice Hall</Studio><Title>Automated Reasoning: Introduction and Applications</Title></ItemAttributes><OfferSummary><LowestUsedPrice><Amount>67</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.67</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>780</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$7.80</FormattedPrice></LowestCollectiblePrice><TotalNew>0</TotalNew><TotalUsed>14</TotalUsed><TotalCollectible>1</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	\N
104	Fundamentals of Data Structures	E Horowitz & S Sahni	data structures	"covers most of the topics in degree and polytechnic courses"\r\n\r\nDonated by Dr. Grant 10/3/05	f	\N	Pitman	\N	\N	027301062X	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1JC36GF19HSEEXJC3VCR</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="027301062X"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0384299755096436</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>027301062X</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest><Errors><Error><Code>AWS.InvalidParameterValue</Code><Message>027301062X is not a valid value for ItemId. Please change this value and retry your request.</Message></Error></Errors></Request></Items></ItemLookupResponse>	\N
45	3D Graphics Programming - Games and Beyond	Sergei Savchenko	theory graphics windows linux 3D	Published in 2000. Donated by Douglas Gore.	f	\N	Sams	\N	t	0672319292	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>185XY3FQYWQS4WSG33WX</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0672319292"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0550951957702637</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0672319292</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0672319292</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0672319292%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0672319292%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>680021</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/0672319292.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">47</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0672319292.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">111</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0672319292.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">376</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/0672319292.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">47</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0672319292.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">111</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0672319292.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">376</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Sergei Savchenko</Author><Binding>Paperback</Binding><DeweyDecimalNumber>006.693</DeweyDecimalNumber><EAN>0752063319291</EAN><Edition>Bk&amp;CD-Rom</Edition><ISBN>0672319292</ISBN><Label>Sams</Label><ListPrice><Amount>4999</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$49.99</FormattedPrice></ListPrice><Manufacturer>Sams</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>353</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">84</Height><Length Units="hundredths-inches">910</Length><Weight Units="hundredths-pounds">140</Weight><Width Units="hundredths-inches">734</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>2000-07</PublicationDate><Publisher>Sams</Publisher><Studio>Sams</Studio><Title>3D Graphics Programming: Games and Beyond (with CD-ROM)</Title><UPC>752063319291</UPC></ItemAttributes><OfferSummary><LowestNewPrice><Amount>925</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$9.25</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>423</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$4.23</FormattedPrice></LowestUsedPrice><TotalNew>10</TotalNew><TotalUsed>12</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>&lt;P&gt;&lt;I&gt;3D Graphics Programming: Games &amp; Beyond&lt;/I&gt; is a comprehensive guide to polygonal 3D graphics with an emphasis on techniques used in computer games. It contains descriptions of the most useful algorithms and combines them with practical programming examples to give programmers more control over their programs. The book's structured approach enables programmers to create their own libraries if necessary. It offers a firm theoretical base that is presented in an intuitive manner. Describing both theoretical and practical issues, the book examines thoroughly the underlying mathematical principles of 3D graphics.  It gives code examples and illustrations of vital concepts using an included library, which is well commented, easy to examine, change or use.&lt;/P&gt;</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/0672319292.01._SCMZZZZZZZ_.jpg
87	Artificial Intelligence 2nd Edition	Michael Negnevitsky	Artificial intelligence ai	Donated by Dr Ulrich Berger, 4/03/05	f	\N	Addison Wesley	\N	\N	0321204662	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1GHHRM4E24D7BBG08P54</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0321204662"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0549039840698242</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0321204662</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0321204662</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0321204662%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0321204662%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>392331</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/0321204662.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">39</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0321204662.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">92</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0321204662.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">329</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/0321204662.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">39</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0321204662.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">92</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0321204662.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">329</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Michael Negnevitsky</Author><Binding>Hardcover</Binding><DeweyDecimalNumber>006.33</DeweyDecimalNumber><EAN>9780321204660</EAN><Edition>2</Edition><ISBN>0321204662</ISBN><Label>Addison Wesley</Label><ListPrice><Amount>9520</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$95.20</FormattedPrice></ListPrice><Manufacturer>Addison Wesley</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>440</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">108</Height><Length Units="hundredths-inches">954</Length><Weight Units="hundredths-pounds">172</Weight><Width Units="hundredths-inches">614</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>2004-11-02</PublicationDate><Publisher>Addison Wesley</Publisher><Studio>Addison Wesley</Studio><Title>Artificial Intelligence: A Guide to Intelligent Systems (2nd Edition)</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>3000</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$30.00</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>3454</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$34.54</FormattedPrice></LowestUsedPrice><TotalNew>45</TotalNew><TotalUsed>20</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>Artificial Intelligence is one of the most rapidly evolving subjects  within the computing/engineering curriculum, with an emphasis on creating  practical applications from hybrid techniques. Despite this, the  traditional textbooks continue to expect mathematical and programming  expertise beyond the scope of current undergraduates and focus on areas  not relevant to many of today's courses. Negnevitsky shows students how to build intelligent systems drawing on techniques from knowledge-based  systems, neural networks, fuzzy systems, evolutionary computation and now  also intelligent agents. The principles behind these techniques are  explained without resorting to complex mathematics, showing how the  various techniques are implemented, when they are useful and when they are not. No particular programming language is assumed and the book does not  tie itself to any of the software tools available. However, available  tools and their uses will be described and program examples will be given  in Java. The lack of assumed prior knowledge makes this book ideal for any introductory courses in artificial intelligence or intelligent systems  design, while the contempory coverage means more advanced students will  benefit by discovering the latest state-of-the-art techniques.  </Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/0321204662.01._SCMZZZZZZZ_.jpg
140	Web Design In A Nutshell	Jennifer Niederst	Web design nutshell xhtml html www authoring	From Library Journal\r\nNiederst discusses everything a web designer needs, from basic principles and HTML to designing for multiple browsers, cascading style sheets, and XML. For a working web designer this book will be an invaluable quick reference, and it is written well enough that someone just starting out on the web could also use it. Highly recommended for all libraries.\r\nCopyright 1999 Reed Business Information, Inc.	f	\N	O'Reilly	\N	\N	1565925157	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0ESESC5M7RZKQSDC9YZ9</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1565925157"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0452032089233398</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1565925157</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1565925157</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1565925157%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1565925157%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>400391</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/1565925157.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">49</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565925157.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">104</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565925157.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">325</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/1565925157.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">49</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565925157.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">104</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565925157.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">325</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Jennifer Niederst</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.72</DeweyDecimalNumber><EAN>0636920925156</EAN><Edition>1st</Edition><ISBN>1565925157</ISBN><Label>O'Reilly</Label><ListPrice><Amount>2995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$29.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>580</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">925</Height><Length Units="hundredths-inches">125</Length><Weight Units="hundredths-pounds">170</Weight><Width Units="hundredths-inches">600</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1998-12</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>Web Design in a Nutshell : A Desktop Quick Reference</Title><UPC>636920925156</UPC></ItemAttributes><OfferSummary><LowestNewPrice><Amount>198</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$1.98</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>1</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.01</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>300</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$3.00</FormattedPrice></LowestCollectiblePrice><TotalNew>19</TotalNew><TotalUsed>63</TotalUsed><TotalCollectible>5</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Amazon.com</Source><Content>Are you a print designer working on the Web? An HTML coder learning about server-side hosting for the first time? &lt;I&gt;Web Design in a Nutshell&lt;/I&gt; has slim but whole chapters for those topics-- and everything else you can imagine.&lt;p&gt; Written in the popular "Nutshell" format, this guide is full of helpful tables and lists, making it a perfect desktop reference. The book breaks down the huge topic of Web site development into understandable, readable segments: the Web environment (browsers, displays, design principles), an in-depth guide to HTML tags, graphics manipulation and display, multimedia possibilities, and technologies for larger site management (such as Cascading Style Sheets [CSS] and XML).&lt;p&gt; While this book is certainly comprehensive, the abundance of information could be overwhelming to someone just starting out with HTML. In addition, the heart of this book is filled with technical specificity on Web page creation (for example, a section under "Graphics" is titled "GIF87a versus GIF89a"). Readers looking for more conceptual explanations of Web design and layout would be better served with other titles. But for day-to-day development and maintenance, &lt;I&gt;Web Design in a Nutshell&lt;/I&gt; is a truly well-constructed toolkit.</Content></EditorialReview><EditorialReview><Source>Book Description</Source><Content>&lt;i&gt;Web Design in a Nutshell&lt;/i&gt; contains the nitty-gritty on everything you need to know to design Web pages. It's the good stuff, without the fluff, written and organized so that answers can be found quickly. Written by veteran Web designer Jennifer Niederst, this book provides quick access to the wide range of front-end technologies and techniques from which Web designers and authors must draw. &lt;p&gt;It is an excellent reference for HTML 4.0 tags (including tables, frames, and Cascading Style Sheets) with special attention given to browser support and platform idiosyncrasies. The HTML section is more than a reference work, though. It details strange behavior in tables, for instance, and gives ideas and workarounds for using tables and frames on your site. &lt;i&gt;Web Design in a Nutshell&lt;/i&gt; also covers multimedia and interactivity, audio and video, and emerging technologies like Dynamic  HTML, XML, embedded fonts, and internationalization.&lt;p&gt;The book includes:&lt;ul&gt;&lt;li&gt;Discussions of the Web environment, monitors, and browsers&lt;/li&gt;&lt;li&gt;A complete reference to HTML and Server Side Includes, including browser support for every tag and attribute&lt;/li&gt;&lt;li&gt;Chapters on creating GIF, JPEG and PNG graphics, including designing with the Web Palette&lt;/li&gt;&lt;li&gt;Information on multimedia and interactivity, including audio, video, Flash, Shockwave, and JavaScript &lt;/li&gt;&lt;li&gt;Detailed tutorial and reference on Cascading Style Sheets, including an appendix of browser compatibility information&lt;/li&gt;&lt;li&gt;Appendices detailing HTML tags, attributes, deprecated tags, proprietary tags, and CSS compatibility&lt;/li&gt;&lt;/ul&gt;</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/1565925157.01._SCMZZZZZZZ_.jpg
98	Artificial Intelligence 3rd Edition	George F Luger & William A Stubblefield	AI Artificial Intelligence	"Structures and Strategies for Complex Problem Solving"\r\n\r\nDonated by Dr. Grand 10/3/05	f	\N	Addison Wesley	\N	\N	0805311963	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1D4BRGDB17P8YQRT8S66</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0805311963"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0497760772705078</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0805311963</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0805311963</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0805311963%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0805311963%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>977384</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/0805311963.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">48</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0805311963.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">113</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0805311963.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">384</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/0805311963.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">48</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0805311963.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">113</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0805311963.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">384</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>George F. Luger</Author><Author>William A. Stubblefield</Author><Binding>Hardcover</Binding><DeweyDecimalNumber>006.3</DeweyDecimalNumber><EAN>9780805311969</EAN><Edition>3rd</Edition><ISBN>0805311963</ISBN><Label>Addison Wesley Publishing Company</Label><ListPrice><Amount>9000</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$90.00</FormattedPrice></ListPrice><Manufacturer>Addison Wesley Publishing Company</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>868</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">168</Height><Length Units="hundredths-inches">959</Length><Weight Units="hundredths-pounds">323</Weight><Width Units="hundredths-inches">765</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1997-09</PublicationDate><Publisher>Addison Wesley Publishing Company</Publisher><Studio>Addison Wesley Publishing Company</Studio><Title>Artificial Intelligence: Structures and Strategies for Complex Problem Solving</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>1995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$19.95</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>950</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$9.50</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>9000</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$90.00</FormattedPrice></LowestCollectiblePrice><TotalNew>5</TotalNew><TotalUsed>14</TotalUsed><TotalCollectible>1</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>Combines the theoretical foundations of intelligent problem-solving with he data structures and algorithms needed for its implementation. The book presents logic, rule, object and agent-based architectures, along with example programs written in LISP and PROLOG.  The practical applications of AI have been kept within the context of its broader goal: understanding the patterns of intelligence as it operates in this world of uncertainty, complexity and change.  &lt;P&gt;The introductory and concluding chapters take a new look at the potentials and challenges facing artificial intelligence and cognitive science.  An extended treatment of knowledge-based problem-solving is given including  model-based and case-based reasoning.   Includes new material on: Fundamentals of search, inference and knowledge representation AI algorithms and data structures in LISP and PROLOG Production systems, blackboards, and meta-interpreters including planers, rule-based reasoners, and inheritance systems. Machine-learning including ID3 with bagging and boosting, explanation based&lt;P&gt;learning, PAC learning, and other forms of induction Neural networks, including perceptrons, back propogation, Kohonen networks, Hopfield networks, Grossberg learning, and counterpropagation.  Emergent and social methods of learning and adaptation, including genetic algorithms, genetic programming and artificial life. Object and agent-based problem solving and other forms of advanced knowledge representation</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/0805311963.01._SCMZZZZZZZ_.jpg
44	X Toolkit Intrinsics Reference Manual	David Flanagan	reference x toolkit	Volume Five. Third edition.	f	\N	O'Reilly	\N	t	1565920074	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0GE7TCV4ZAVDAKXQCYW0</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1565920074"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0552699565887451</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1565920074</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1565920074</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1565920074%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1565920074%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>181927</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/1565920074.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">56</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565920074.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">120</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565920074.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">374</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/1565920074.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">56</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565920074.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">120</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565920074.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">374</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Binding>Paperback</Binding><Creator Role="Editor">David Flanagan</Creator><DeweyDecimalNumber>005.43</DeweyDecimalNumber><EAN>9781565920071</EAN><Edition>3</Edition><ISBN>1565920074</ISBN><Label>O'Reilly Media</Label><ListPrice><Amount>4495</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$44.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly Media</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>909</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">185</Height><Length Units="hundredths-inches">913</Length><Weight Units="hundredths-pounds">309</Weight><Width Units="hundredths-inches">698</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1992-04-03</PublicationDate><Publisher>O'Reilly Media</Publisher><Studio>O'Reilly Media</Studio><Title>X Toolkit Intrinsics Ref Man R5 (Definitive Guides to the X Window System)</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>899</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$8.99</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>85</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.85</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>4495</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$44.95</FormattedPrice></LowestCollectiblePrice><TotalNew>23</TotalNew><TotalUsed>26</TotalUsed><TotalCollectible>1</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>The &lt;i&gt;X Toolkit Intrinsics Reference Manual&lt;/i&gt; is a complete programmer's reference for the X Toolkit. It provides reference pages for each of the Xt functions as well as the widget classes defined by Xt and the Athena widgets.    This volume is based on Xt documentation from the X Consortium and has been re-edited, reorganized, and expanded. Contents include:  &lt;ul&gt;&lt;li&gt;Reference pages for each of the Xt Intrinsics and macros, organized alphabetically for ease of use.&lt;/li&gt;  &lt;li&gt;Reference pages for the interface definitions of functions registered using other Xt functions.&lt;/li&gt;  &lt;li&gt;Reference pages for the Core, Composite, and Constraint widget methods.&lt;/li&gt;  &lt;li&gt;Reference pages for the Object, RectObj, Core, Composite, Constraint, and Shell widget classes defined by Xt.&lt;/li&gt;  &lt;li&gt;Reference pages for Athena widget classes.&lt;/li&gt;  &lt;li&gt;Reference pages for Xt-related Xmu functions.&lt;/li&gt;  &lt;li&gt;Permuted index.&lt;/li&gt;  &lt;li&gt;Many appendices and quick reference aids.&lt;/li&gt;&lt;/ul&gt;    The third edition of Volume 5 has been completely revised. In addition to covering Release 4 and Release 5 of X, all the man pages have been completely rewritten for clarity and ease of use, and new examples and descriptions have been added throughout the book.    This manual is a companion to Volume 4M, &lt;i&gt;X Toolkit Intrinsics  Programming Manual&lt;/i&gt;.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/1565920074.01._SCMZZZZZZZ_.jpg
21	Linux - installation, configuration and use	Michael Kofler	linux installation configuration use admin		f	\N	Addison-Wesley	davea	t	059600348X	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0467TMSVTR2AMZYB3AWM</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="059600348X"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0446140766143799</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>059600348X</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>059600348X</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=059600348X%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/059600348X%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>391587</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/059600348X.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">57</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/059600348X.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">122</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/059600348X.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">380</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/059600348X.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">57</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/059600348X.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">122</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/059600348X.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">380</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>David Pogue</Author><Author>Craig Zacker</Author><Author>L. J. Zacker</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.4469</DeweyDecimalNumber><EAN>9780596003487</EAN><Edition>1</Edition><ISBN>059600348X</ISBN><Label>O'Reilly</Label><ListPrice><Amount>3891</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$38.91</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>672</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">158</Height><Length Units="hundredths-inches">918</Length><Weight Units="hundredths-pounds">228</Weight><Width Units="hundredths-inches">708</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>2003-01</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>Windows XP Pro: The Missing Manual</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>306</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$3.06</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>82</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.82</FormattedPrice></LowestUsedPrice><TotalNew>15</TotalNew><TotalUsed>20</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>Windows XP is the latest, most reliable, and best-looking version of the world's most widely used operating system, combining the extremely stable engine of Windows NT and 2000 with the user-friendliness of the Windows 98 and Me consumer models. In its first year, XP became the fastest-selling Windows OS ever. But one major failing remains unaddressed: XP Pro comes without a single page of printed instructions.&lt;p&gt;This superbly written guide fills the gap. Coauthored by David Pogue, &lt;i&gt;New York Times&lt;/i&gt; technology columnist and Missing Manuals creator, &lt;i&gt;Windows XP Pro: The Missing Manual&lt;/i&gt; uses wit, technical insight, and scrupulous objectivity to light the way for first-time and intermediate PC fans. The book reveals which features work well and which don't, such as the Remote Desktop software that enables people to connect to the office from home, the encryption file system that protects sensitive information, and the Windows Messenger that enables real-time text, voice and video communication. Contents include:&lt;ul&gt;&lt;b&gt;Getting started.&lt;/b&gt; The book's early chapters cover using menus, finding lost files, reducing window clutter, and taming the new, multi-column Start menu.&lt;b&gt;Mastering the network.&lt;/b&gt; Special chapters help you navigate the corporate network, dial in from the road, and even set up your own small-office (peer-to-peer) network, step by step.&lt;b&gt;Understanding security.&lt;/b&gt; User accounts, file encryption, and the NTFS file system keep your private files private, while still offering network access to coworkers you specify.&lt;b&gt;Flying the Net.&lt;/b&gt; This book demystifies Outlook Express 6 for email, Internet Explorer 6 for Web browsing, and the new Windows Messenger for voice, chat, and video conferencing.&lt;/ul&gt;&lt;i&gt;Windows XP Pro: The Missing Manual&lt;/i&gt; isn't for system administrators or OS theory geeks; it's for the novice or budding power user who wants to master the machine and get down to work. Yet, anyone who uses XP Pro (including hardcore techies) will find this new system much easier -- and more fun -- to digest with this new Missing Manual. This is the crystal-clear, jargon-free book that should have been in the box.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/059600348X.01._SCMZZZZZZZ_.jpg
142	Windows XP Pro The Missing Manual	Pogue, Zacker and Zacker	windows xp pro	Windows XP Pro for newbies. "The book that should have been in the box" covers up to SP1	f	\N	Pogue Press / O'Reilly	\N	\N	059600348X	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0467TMSVTR2AMZYB3AWM</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="059600348X"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0446140766143799</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>059600348X</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>059600348X</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=059600348X%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/059600348X%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>391587</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/059600348X.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">57</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/059600348X.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">122</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/059600348X.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">380</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/059600348X.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">57</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/059600348X.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">122</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/059600348X.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">380</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>David Pogue</Author><Author>Craig Zacker</Author><Author>L. J. Zacker</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.4469</DeweyDecimalNumber><EAN>9780596003487</EAN><Edition>1</Edition><ISBN>059600348X</ISBN><Label>O'Reilly</Label><ListPrice><Amount>3891</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$38.91</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>672</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">158</Height><Length Units="hundredths-inches">918</Length><Weight Units="hundredths-pounds">228</Weight><Width Units="hundredths-inches">708</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>2003-01</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>Windows XP Pro: The Missing Manual</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>306</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$3.06</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>82</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.82</FormattedPrice></LowestUsedPrice><TotalNew>15</TotalNew><TotalUsed>20</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>Windows XP is the latest, most reliable, and best-looking version of the world's most widely used operating system, combining the extremely stable engine of Windows NT and 2000 with the user-friendliness of the Windows 98 and Me consumer models. In its first year, XP became the fastest-selling Windows OS ever. But one major failing remains unaddressed: XP Pro comes without a single page of printed instructions.&lt;p&gt;This superbly written guide fills the gap. Coauthored by David Pogue, &lt;i&gt;New York Times&lt;/i&gt; technology columnist and Missing Manuals creator, &lt;i&gt;Windows XP Pro: The Missing Manual&lt;/i&gt; uses wit, technical insight, and scrupulous objectivity to light the way for first-time and intermediate PC fans. The book reveals which features work well and which don't, such as the Remote Desktop software that enables people to connect to the office from home, the encryption file system that protects sensitive information, and the Windows Messenger that enables real-time text, voice and video communication. Contents include:&lt;ul&gt;&lt;b&gt;Getting started.&lt;/b&gt; The book's early chapters cover using menus, finding lost files, reducing window clutter, and taming the new, multi-column Start menu.&lt;b&gt;Mastering the network.&lt;/b&gt; Special chapters help you navigate the corporate network, dial in from the road, and even set up your own small-office (peer-to-peer) network, step by step.&lt;b&gt;Understanding security.&lt;/b&gt; User accounts, file encryption, and the NTFS file system keep your private files private, while still offering network access to coworkers you specify.&lt;b&gt;Flying the Net.&lt;/b&gt; This book demystifies Outlook Express 6 for email, Internet Explorer 6 for Web browsing, and the new Windows Messenger for voice, chat, and video conferencing.&lt;/ul&gt;&lt;i&gt;Windows XP Pro: The Missing Manual&lt;/i&gt; isn't for system administrators or OS theory geeks; it's for the novice or budding power user who wants to master the machine and get down to work. Yet, anyone who uses XP Pro (including hardcore techies) will find this new system much easier -- and more fun -- to digest with this new Missing Manual. This is the crystal-clear, jargon-free book that should have been in the box.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/059600348X.01._SCMZZZZZZZ_.jpg
75	Master Class Assembly Language	Lots. WROX	ASM Assembly Programming	Donated by Mr Chris Whyley, 28/02/05	f	\N	WORX	\N	\N	1874416346	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1N7K4A6390FT93Q4FQD1</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1874416346"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0525197982788086</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1874416346</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1874416346</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1874416346%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1874416346%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>700916</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/1874416346.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">46</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1874416346.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">107</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1874416346.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">364</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/1874416346.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">46</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1874416346.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">107</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1874416346.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">364</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Igor Chebotko</Author><Author>Peter Kalatchin</Author><Author>Yuri Kiselev</Author><Author>Efim Podvoisky</Author><Author>Kiril Malakhov</Author><Author>Yuri Petrenko</Author><Author>Mike Schmit</Author><Author>Sergei Shkredov</Author><Author>Gennady Soudlenkov</Author><Author>Daniel Wronski</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.265</DeweyDecimalNumber><EAN>9781874416340</EAN><Edition>Bk&amp;Disk</Edition><ISBN>1874416346</ISBN><Label>Apress</Label><ListPrice><Amount>4995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$49.95</FormattedPrice></ListPrice><Manufacturer>Apress</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>1024</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">925</Height><Length Units="hundredths-inches">200</Length><Weight Units="hundredths-pounds">380</Weight><Width Units="hundredths-inches">775</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1994-10</PublicationDate><Publisher>Apress</Publisher><Studio>Apress</Studio><Title>Assembly Language Master Class (Wrox Press Master Class)</Title></ItemAttributes><OfferSummary><LowestUsedPrice><Amount>500</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$5.00</FormattedPrice></LowestUsedPrice><TotalNew>0</TotalNew><TotalUsed>12</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/1874416346.01._SCMZZZZZZZ_.jpg
99	8086/8088 Primer 2nd ed.	Stephen P. Morse	8086 8088 microprocessor cpu	"An Introduction to Their Architecture, System Design, and Programming"\r\n\r\nDonated by Dr. Grant 10/3/05	f	\N	Hayden	\N	\N	0810462559	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0W833D6R8BGC65WTV5E4</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0810462559"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0627601146697998</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0810462559</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0810462559</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0810462559%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0810462559%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>1478450</SalesRank><ItemAttributes><Author>Stephen P. Morse</Author><Binding>Paperback</Binding><EAN>9780810462557</EAN><Edition>2nd ed</Edition><ISBN>0810462559</ISBN><Label>Hayden Books</Label><ListPrice><Amount>1995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$19.95</FormattedPrice></ListPrice><Manufacturer>Hayden Books</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>276</NumberOfPages><ProductGroup>Book</ProductGroup><PublicationDate>1982-01</PublicationDate><Publisher>Hayden Books</Publisher><Studio>Hayden Books</Studio><Title>The 8086/8088 Primer: An Introduction to Their Architecture, System Design, and Programming</Title></ItemAttributes><OfferSummary><LowestUsedPrice><Amount>93</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.93</FormattedPrice></LowestUsedPrice><TotalNew>0</TotalNew><TotalUsed>16</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	\N
74	Essence Of Compilers, The	Robin Hunter	Compilers	Donated by Mr Chris Whyley, 28/02/05\r\nCovers Lex and YACC, exercises with solutions\r\n\r\n	f	\N	Pearson Education	pwb	\N	0137278357	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>00MND6WCA3S0H0FXM4QX</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0137278357"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0382499694824219</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0137278357</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest><Errors><Error><Code>AWS.InvalidParameterValue</Code><Message>0137278357 is not a valid value for ItemId. Please change this value and retry your request.</Message></Error></Errors></Request></Items></ItemLookupResponse>	\N
66	Perl in a Nutshell	Ellen Siever et al	Perl	A comprehensive reference guide to the Perl programming language. Donated by Steven Whitehouse	f	\N	O'Reilly	\N	\N	1565922867	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0T0AKAJH2R3F48E3Q2CS</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1565922867"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0442659854888916</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1565922867</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1565922867</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1565922867%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1565922867%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>564610</SalesRank><SmallImage><URL>http://ec1.images-amazon.com/images/P/1565922867.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">49</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/1565922867.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">105</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/1565922867.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">329</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://ec1.images-amazon.com/images/P/1565922867.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">49</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/1565922867.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">105</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/1565922867.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">329</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Ellen Siever</Author><Author>Ellen Siever</Author><Author>Nathan Patwardhan</Author><Binding>Paperback</Binding><EAN>0636920922865</EAN><Edition>1st</Edition><ISBN>1565922867</ISBN><Label>O'Reilly</Label><ListPrice><Amount>3495</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$34.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>674</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">133</Height><Length Units="hundredths-inches">899</Length><Weight Units="hundredths-pounds">176</Weight><Width Units="hundredths-inches">602</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1998-12-01</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>Perl in a Nutshell (In a Nutshell (O'Reilly))</Title><UPC>636920922865</UPC></ItemAttributes><OfferSummary><LowestNewPrice><Amount>200</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$2.00</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>78</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.78</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>1500</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$15.00</FormattedPrice></LowestCollectiblePrice><TotalNew>5</TotalNew><TotalUsed>39</TotalUsed><TotalCollectible>3</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Amazon.com</Source><Content>&lt;I&gt;Perl in a Nutshell&lt;/I&gt; strives to be a perfect set of socket tools for the active Perl programmer. By and large, it succeeds, providing endless and well-thought-out lists and tables on the language's modules, flags, and extensions. The authors briefly address basic learner's questions--such as the difference between a hash and an array--but these concepts are not the purpose of the book. (Those new to Perl would be better off with others in the O'Reilly Perl series, such as &lt;I&gt;Learning Perl&lt;/I&gt;, while programmers making the switch to Perl can pick up the nuances of the language with &lt;I&gt;Programming Perl&lt;/I&gt;.) This book is pure Perl reference, briefly covering Perl/Tk (for GUI Perl programs on Unix and Windows 95/NT) and Perl for Win 32.&lt;p&gt; The authors do start at the very beginning, and even in a self-described "desktop quick reference" find the time to comment on less urgent--but still interesting--Perl-related matters (like how to find online help amidst the "Perl culture"). The format of the book makes sections on topics such as Perl debugging easily understandable, illustrating how to make an interactive and timesaving environment.&lt;p&gt; Of particular convenience is the outstanding section on the standard Perl modules. A four-page "quick look" allows you to easily scan through short definitions of all the modules and find the entry you're looking for. An index with full definitions for each module follows, showing you how to use each module and providing a more in-depth explanation (and often, examples). &lt;I&gt;Perl in a Nutshell&lt;/I&gt; concludes--as you might expect--with an excellent and well-cross-referenced index. &lt;I&gt;--Jennifer Buckendorff&lt;/I&gt;</Content></EditorialReview><EditorialReview><Source>Book Description</Source><Content>&lt;i&gt;Perl in a Nutshell&lt;/i&gt; is a comprehensive reference guide to the Perl programming language.  This book covers all the core features of the language.  It ranges widely through the Perl programmer's universe, gathering together in convenient form a wealth of information about Perl itself and its application to CGI scripts, network programming, database interaction, and graphical user interfaces.  It also gives detailed coverage about using Perl within a Win32 environment.&lt;p&gt;This book assembles more information about the language in one place than any other reference work.  Here are just some of the topics covered in the book:&lt;p&gt;&lt;ul&gt;&lt;li&gt;Basic language reference&lt;/li&gt;&lt;li&gt;Introduction to using Perl modules&lt;/li&gt;&lt;li&gt;Perl and CGI: CGI basics, CGI.pm, mod_perl&lt;/li&gt;&lt;li&gt;DBI, the database-independent API for Perl&lt;/li&gt;&lt;li&gt;Sockets programming in Perl&lt;/li&gt;&lt;li&gt;LWP, the library for World Wide Web programming in Perl&lt;/li&gt;&lt;li&gt;The Net::* modules&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;As part of the successful "in a Nutshell" series of books from O'Reilly &amp; Associates, &lt;i&gt;Perl in a Nutshell&lt;/i&gt; is for readers who want a single  reference for all their needs.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://ec1.images-amazon.com/images/P/1565922867.01._SCMZZZZZZZ_.jpg
62	Perl in a Nutshell	Ellen Siever et al	Perl	A comprehensive reference guide to the Perl programming language. Donated by Steven Whitehouse	f	\N	O'Reilly	\N	\N	1565922867	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0T0AKAJH2R3F48E3Q2CS</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1565922867"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0442659854888916</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1565922867</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1565922867</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1565922867%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1565922867%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>564610</SalesRank><SmallImage><URL>http://ec1.images-amazon.com/images/P/1565922867.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">49</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/1565922867.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">105</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/1565922867.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">329</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://ec1.images-amazon.com/images/P/1565922867.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">49</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/1565922867.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">105</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/1565922867.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">329</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Ellen Siever</Author><Author>Ellen Siever</Author><Author>Nathan Patwardhan</Author><Binding>Paperback</Binding><EAN>0636920922865</EAN><Edition>1st</Edition><ISBN>1565922867</ISBN><Label>O'Reilly</Label><ListPrice><Amount>3495</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$34.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>674</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">133</Height><Length Units="hundredths-inches">899</Length><Weight Units="hundredths-pounds">176</Weight><Width Units="hundredths-inches">602</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1998-12-01</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>Perl in a Nutshell (In a Nutshell (O'Reilly))</Title><UPC>636920922865</UPC></ItemAttributes><OfferSummary><LowestNewPrice><Amount>200</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$2.00</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>78</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.78</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>1500</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$15.00</FormattedPrice></LowestCollectiblePrice><TotalNew>5</TotalNew><TotalUsed>39</TotalUsed><TotalCollectible>3</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Amazon.com</Source><Content>&lt;I&gt;Perl in a Nutshell&lt;/I&gt; strives to be a perfect set of socket tools for the active Perl programmer. By and large, it succeeds, providing endless and well-thought-out lists and tables on the language's modules, flags, and extensions. The authors briefly address basic learner's questions--such as the difference between a hash and an array--but these concepts are not the purpose of the book. (Those new to Perl would be better off with others in the O'Reilly Perl series, such as &lt;I&gt;Learning Perl&lt;/I&gt;, while programmers making the switch to Perl can pick up the nuances of the language with &lt;I&gt;Programming Perl&lt;/I&gt;.) This book is pure Perl reference, briefly covering Perl/Tk (for GUI Perl programs on Unix and Windows 95/NT) and Perl for Win 32.&lt;p&gt; The authors do start at the very beginning, and even in a self-described "desktop quick reference" find the time to comment on less urgent--but still interesting--Perl-related matters (like how to find online help amidst the "Perl culture"). The format of the book makes sections on topics such as Perl debugging easily understandable, illustrating how to make an interactive and timesaving environment.&lt;p&gt; Of particular convenience is the outstanding section on the standard Perl modules. A four-page "quick look" allows you to easily scan through short definitions of all the modules and find the entry you're looking for. An index with full definitions for each module follows, showing you how to use each module and providing a more in-depth explanation (and often, examples). &lt;I&gt;Perl in a Nutshell&lt;/I&gt; concludes--as you might expect--with an excellent and well-cross-referenced index. &lt;I&gt;--Jennifer Buckendorff&lt;/I&gt;</Content></EditorialReview><EditorialReview><Source>Book Description</Source><Content>&lt;i&gt;Perl in a Nutshell&lt;/i&gt; is a comprehensive reference guide to the Perl programming language.  This book covers all the core features of the language.  It ranges widely through the Perl programmer's universe, gathering together in convenient form a wealth of information about Perl itself and its application to CGI scripts, network programming, database interaction, and graphical user interfaces.  It also gives detailed coverage about using Perl within a Win32 environment.&lt;p&gt;This book assembles more information about the language in one place than any other reference work.  Here are just some of the topics covered in the book:&lt;p&gt;&lt;ul&gt;&lt;li&gt;Basic language reference&lt;/li&gt;&lt;li&gt;Introduction to using Perl modules&lt;/li&gt;&lt;li&gt;Perl and CGI: CGI basics, CGI.pm, mod_perl&lt;/li&gt;&lt;li&gt;DBI, the database-independent API for Perl&lt;/li&gt;&lt;li&gt;Sockets programming in Perl&lt;/li&gt;&lt;li&gt;LWP, the library for World Wide Web programming in Perl&lt;/li&gt;&lt;li&gt;The Net::* modules&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;As part of the successful "in a Nutshell" series of books from O'Reilly &amp; Associates, &lt;i&gt;Perl in a Nutshell&lt;/i&gt; is for readers who want a single  reference for all their needs.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://ec1.images-amazon.com/images/P/1565922867.01._SCMZZZZZZZ_.jpg
64	TCL/TK Tools	Mark Harrison	Tcl, Tk	Extentions to the Tcl language and Tk toolkit. Donated by Steven Whitehouse	f	\N	O'Reilly	\N	\N	1565922182	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>14AJRWFF3NYQN5XTNGDW</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1565922182"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0452919006347656</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1565922182</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1565922182</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1565922182%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1565922182%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>613965</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/1565922182.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">56</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565922182.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">120</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565922182.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">374</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/1565922182.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">56</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565922182.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">120</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565922182.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">374</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Mark Harrison</Author><Binding>Paperback</Binding><EAN>0636920922186</EAN><Edition>1</Edition><ISBN>1565922182</ISBN><Label>O'Reilly</Label><ListPrice><Amount>4995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$49.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfPages>661</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">950</Height><Length Units="hundredths-inches">125</Length><Weight Units="hundredths-pounds">220</Weight><Width Units="hundredths-inches">700</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1997-09-01</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>Tcl/Tk Tools</Title><UPC>636920922186</UPC></ItemAttributes><OfferSummary><LowestNewPrice><Amount>1870</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$18.70</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>239</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$2.39</FormattedPrice></LowestUsedPrice><TotalNew>2</TotalNew><TotalUsed>12</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>The Tcl language and Tk toolkit, even alone, offer many benefits: They're easy to learn, capable of producing good interfaces quickly, great  for prototyping applications, and they are infinitely customizable. But one of the greatest strengths of Tcl/Tk is the range of extensions written for it.  Now you can read about the most popular and robust  extensions, clearly documented in the classic O'Reilly style by  the extension authors themselves, supported with a foreword by Tcl/Tk  creator John Ousterhout.&lt;p&gt;With Tcl/Tk extensions, you can:&lt;ul&gt;&lt;li&gt;Write robust object-oriented programs ([incr Tcl] and [incr Tk])&lt;/li&gt;&lt;li&gt;Produce complex interfaces with one-line commands ([incr Widgets] and Tix)&lt;/li&gt;&lt;li&gt;Layout graphs and tables (BLT)&lt;/li&gt;&lt;li&gt;Display 3D graphics with rich textures (TSIPP)&lt;/li&gt;&lt;li&gt;Interact with Oracle and Sybase databases (Sybtcl and Oratcl)&lt;/li&gt;&lt;li&gt;Network over sockets and remote procedure calls (Tcl-DP)&lt;/li&gt;&lt;li&gt;Create collaborative multi-user environments (GroupKit)&lt;/li&gt;&lt;li&gt;Automate programs that call for human users (expect)&lt;/li&gt;&lt;li&gt;Use complex data structures and UNIX system calls (TclX)&lt;/li&gt;&lt;li&gt;Embed Tk calls in C programs (ET)&lt;/li&gt;&lt;li&gt;Display tree structures (Tree)&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;This book documents all these extensions -- in an eminently readable and usable form by the people who created them -- and contains information  on configuration, debugging, and other important tasks.&lt;p&gt;This book comes with a CD-ROM that includes Tcl/Tk, the extensions, and  other tools documented in the text both in source form and as binaries  for Solaris and Linux.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/1565922182.01._SCMZZZZZZZ_.jpg
65	TCL/TK Tools	Mark Harrison	Tcl, Tk	Extentions to the Tcl language and Tk toolkit. Donated by Steven Whitehouse	f	\N	O'Reilly	\N	\N	1565922182	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>14AJRWFF3NYQN5XTNGDW</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1565922182"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0452919006347656</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1565922182</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1565922182</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1565922182%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1565922182%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>613965</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/1565922182.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">56</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565922182.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">120</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565922182.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">374</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/1565922182.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">56</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565922182.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">120</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565922182.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">374</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Mark Harrison</Author><Binding>Paperback</Binding><EAN>0636920922186</EAN><Edition>1</Edition><ISBN>1565922182</ISBN><Label>O'Reilly</Label><ListPrice><Amount>4995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$49.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfPages>661</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">950</Height><Length Units="hundredths-inches">125</Length><Weight Units="hundredths-pounds">220</Weight><Width Units="hundredths-inches">700</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1997-09-01</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>Tcl/Tk Tools</Title><UPC>636920922186</UPC></ItemAttributes><OfferSummary><LowestNewPrice><Amount>1870</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$18.70</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>239</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$2.39</FormattedPrice></LowestUsedPrice><TotalNew>2</TotalNew><TotalUsed>12</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>The Tcl language and Tk toolkit, even alone, offer many benefits: They're easy to learn, capable of producing good interfaces quickly, great  for prototyping applications, and they are infinitely customizable. But one of the greatest strengths of Tcl/Tk is the range of extensions written for it.  Now you can read about the most popular and robust  extensions, clearly documented in the classic O'Reilly style by  the extension authors themselves, supported with a foreword by Tcl/Tk  creator John Ousterhout.&lt;p&gt;With Tcl/Tk extensions, you can:&lt;ul&gt;&lt;li&gt;Write robust object-oriented programs ([incr Tcl] and [incr Tk])&lt;/li&gt;&lt;li&gt;Produce complex interfaces with one-line commands ([incr Widgets] and Tix)&lt;/li&gt;&lt;li&gt;Layout graphs and tables (BLT)&lt;/li&gt;&lt;li&gt;Display 3D graphics with rich textures (TSIPP)&lt;/li&gt;&lt;li&gt;Interact with Oracle and Sybase databases (Sybtcl and Oratcl)&lt;/li&gt;&lt;li&gt;Network over sockets and remote procedure calls (Tcl-DP)&lt;/li&gt;&lt;li&gt;Create collaborative multi-user environments (GroupKit)&lt;/li&gt;&lt;li&gt;Automate programs that call for human users (expect)&lt;/li&gt;&lt;li&gt;Use complex data structures and UNIX system calls (TclX)&lt;/li&gt;&lt;li&gt;Embed Tk calls in C programs (ET)&lt;/li&gt;&lt;li&gt;Display tree structures (Tree)&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;This book documents all these extensions -- in an eminently readable and usable form by the people who created them -- and contains information  on configuration, debugging, and other important tasks.&lt;p&gt;This book comes with a CD-ROM that includes Tcl/Tk, the extensions, and  other tools documented in the text both in source form and as binaries  for Solaris and Linux.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/1565922182.01._SCMZZZZZZZ_.jpg
93	Palm Programming - The Developer's Guide	Rhodes & McKeehan	Palm C Programming	Donated by Mr Andy Gimblett, 8/03/2005	f	\N	O'Reilly	\N	\N	1565925254	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>19HWYPFMGNSXSVBS9TQC</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1565925254"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0431900024414062</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1565925254</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1565925254</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1565925254%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1565925254%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>142917</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/1565925254.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">56</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565925254.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">120</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565925254.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">375</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/1565925254.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">56</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565925254.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">120</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565925254.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">375</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Neil Rhodes</Author><Author>Julie McKeehan</Author><Binding>Paperback</Binding><EAN>0636920925255</EAN><Edition>1</Edition><ISBN>1565925254</ISBN><Label>O'Reilly</Label><ListPrice><Amount>3495</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$34.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>476</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">950</Height><Length Units="hundredths-inches">125</Length><Weight Units="hundredths-pounds">170</Weight><Width Units="hundredths-inches">725</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1998-12-01</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>Palm Programming: The Developer's Guide (Developer's Guides (Osborne))</Title><UPC>636920925255</UPC></ItemAttributes><OfferSummary><LowestNewPrice><Amount>394</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$3.94</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>24</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.24</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>1000</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$10.00</FormattedPrice></LowestCollectiblePrice><TotalNew>12</TotalNew><TotalUsed>45</TotalUsed><TotalCollectible>2</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Amazon.com</Source><Content>&lt;I&gt;Palm Programming: The Developer's Guide&lt;/I&gt; succeeds in documenting both the elegance and the pitfalls associated with developing software for this handy gadget. The authors are experienced palmtop developers, and their wisdom is evident in the level of detail provided. A comprehensive introduction to the evolution of the device and its systems opens the book, followed by a classic "hello, world" example program.&lt;p&gt; The complexity continues to increase as the reader is introduced to forms design and handling and Palm Databases interaction (the equivalent of the Windows registry). Rounding out the applications-development tutorials is an excellent discussion of event-driven user interface (UI) programming and the widgets available in the Palm toolbox.&lt;p&gt; A number of development options and platforms are covered. If you don't want to shell out hundreds of dollars for commercial software, GNU's Not Unix (GNU) tools from the Free Software Foundation are presented as a viable option. The discussion of conduit development is limited to Visual C++, but only because of the limitations of the official Conduit Developers Kit. &lt;I&gt;--Tim Kohn&lt;/I&gt;</Content></EditorialReview><EditorialReview><Source>Book Description</Source><Content>PalmPilot's popularity is growing and with over a million units sold, the Palm OS dominates the hand-held market. &lt;i&gt;Wired&lt;/i&gt; has astutely described Palm's position in a recent article: "On its way to becoming the bestselling hand-held computer of all time, the 3Com PalmPilot has spawned an intense, emotional, and fanatical developer following not seen since the glory days of the Mac." (Wired, 20 Feb. 98).&lt;p&gt;&lt;i&gt;Palm Programming&lt;/i&gt; should be eagerly accepted by programmers because  the authors worked closely with Palm to ensure that the book is tailored  exactly to the needs of the ever-growing group of Palm developers. As  nothing but some piecemeal documentation exists currently, this book  provides a much needed solution to the Palm developers. In fact, Palm  uses this book as their official developer's guide and will be  using it in the future as a key part of their training materials for  developers.&lt;p&gt;There are currently no books on Palm programming (and we know of none that are planned). The only way to learn is by using the reference material published by Palm (available freely on their Web site), the tutorial they provide, or various Palm programming FAQs compiled by third parties. &lt;p&gt;&lt;i&gt;Palm Programming&lt;/i&gt; shows intermediate to experienced C programmers  how to build a Palm application from the ground up. Using an easy-to- understand tutorial approach, this book gives readers everything necessary  to create a wide range of Palm applications and conduits, from simple  scripts through full-blown applications, and in the process provides  thorough coverage of Palm programming. It includes a CD-ROM (Macintosh and  Windows compatible) with the full source code to the examples in the book,  a trial version of Palm's Software Development Kit, and third-party developer  tools, including Metrowerks' CodeWarrior Lite programming kit.&lt;p&gt;Outline&lt;p&gt;Part 1: Overview of Palm OS and devices&lt;p&gt;Chapter 1: The Palm Solution Chapter 2: Developing for Palm OS Chapter 3: Designing a solution&lt;p&gt;Part 2: Programming for the handheld              &lt;p&gt;Chapter 4: Structure of an Application Chapter 5: Forms and Form Objects Chapter 6: Databases Chapter 7: Menus Chapter 8: Extras Chapter 9: Communications Chapter 10: Debugging              &lt;p&gt;Part 3: Programming for the desktop: conduits&lt;p&gt;Chapter 11: Getting started with conduits  Chapter 12: Uploading and Downloading Data Chapter 13: Two-way Syncing Appendix: Where to go from here</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/1565925254.01._SCMZZZZZZZ_.jpg
22	DNS and BIND - 3rd Edition	Paul Albitz & Cricket Liu	dns bind	3rd Edition	t	2006-01-25 10:44:36.857736+00	O'Reilly	elsmorian	t	1565925122	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0VQG8EVX4KGV84XGXFZT</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1565925122"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0428309440612793</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1565925122</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1565925122</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1565925122%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1565925122%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>95563</SalesRank><SmallImage><URL>http://ec1.images-amazon.com/images/P/1565925122.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">56</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/1565925122.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">120</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/1565925122.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">374</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://ec1.images-amazon.com/images/P/1565925122.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">56</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/1565925122.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">120</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/1565925122.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">374</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Cricket Liu</Author><Author>Paul Albitz</Author><Author>Mike Loukides</Author><Binding>Paperback</Binding><EAN>0636920925125</EAN><Edition>3</Edition><ISBN>1565925122</ISBN><Label>O'Reilly</Label><ListPrice><Amount>3995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$39.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>499</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">925</Height><Length Units="hundredths-inches">100</Length><Weight Units="hundredths-pounds">180</Weight><Width Units="hundredths-inches">700</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1998-09</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>DNS and BIND</Title><UPC>636920925125</UPC></ItemAttributes><OfferSummary><LowestNewPrice><Amount>298</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$2.98</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>84</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.84</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>3977</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$39.77</FormattedPrice></LowestCollectiblePrice><TotalNew>10</TotalNew><TotalUsed>43</TotalUsed><TotalCollectible>2</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Amazon.com</Source><Content>This is the definitive book on the Domain Name System (DNS), the powerful scheme that facilitates the translation of English-like domain names (www.amazon.com) into computer-comprehensible Internet Protocol (IP) addresses (208.216.182.15). If you run a DNS server of any kind, particularly under Unix, you need to have this book on hand.&lt;p&gt; This book's early chapters give a view of DNS from high altitude, explaining basic concepts such as domains, name servers, and name resolution. From there, the authors proceed on a more practical tack, presenting specific instructions for setting up your own domain and DNS server using BIND. The authors then tell you what to do as your domain grows and you need to add more machines, subdomains, and greater throughput capacity. They also talk a lot about nslookup and C programming with the various DNS and BIND libraries. Administrators will find the chapter on BIND debugging output particularly helpful. Here, the authors translate BIND's mysterious error messages and offer specific strategies for fixing and optimizing the program. This edition covers BIND 8.1.2, but pays lots of attention to older versions that are still in wide use (4.8.3 and 4.9). The authors are careful to note differences among the versions. &lt;I&gt;--David Wall&lt;/I&gt;</Content></EditorialReview><EditorialReview><Source>Book Description</Source><Content>&lt;i&gt;DNS and BIND&lt;/i&gt; discusses one of the Internet's fundamental building blocks: the distributed host information database that's responsible for translating names into addresses, routing mail to its proper destination, and many other services. As the authors write in the preface, if you're using the Internet, you're already using DNS --  even if you don't know it.&lt;p&gt;The third edition covers BIND 4.9, on which most commercial products are currently based, and BIND 8, which implements many important new features and will be the basis for the next generation of commercial name servers. It also covers topics like DNS security (greatly improved with BIND 8.1), asynchronous notification of changes to a zone, dynamic updates, and programming with Perl's Net::DNS module.&lt;p&gt;Whether you're an administrator involved with DNS on daily basis, or a user who wants to be more informed about the Internet and how it works, you'll find that this book is essential reading.&lt;p&gt;Topics include:&lt;p&gt;&lt;ul&gt;&lt;li&gt;What DNS does, how it works, and when you need to use it&lt;/li&gt;&lt;li&gt;How to find your own place in the Internet's name space&lt;li&gt;Setting up name servers&lt;/li&gt;&lt;li&gt;Using MX records to route mail&lt;/li&gt;&lt;li&gt;Configuring hosts to use DNS name servers&lt;/li&gt;&lt;li&gt;Subdividing domains (parenting)&lt;/li&gt;&lt;li&gt;Securing your name server: restricting who can query your server, preventing unauthorized zone transfers, avoiding bogus name servers, etc.&lt;/li&gt;&lt;li&gt;Mapping one name to several servers for load sharing&lt;/li&gt;&lt;li&gt;Troubleshooting: using nslookup, reading debugging output, common problems&lt;/li&gt;&lt;li&gt;DNS programming, using the resolver library and Perl's Net::DNS  module&lt;/li&gt;&lt;/ul&gt;</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://ec1.images-amazon.com/images/P/1565925122.01._SCMZZZZZZZ_.jpg
47	Introduction to Algorithms	Thomas H Cormen et al.	algorithms	The big book of algorithms for Faron\\'s course.	f	\N	MIT Press	frosty	t	0262531968	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0SSE3XVMXT73ARJ5KECJ</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0262531968"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0452818870544434</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0262531968</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0262531968</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0262531968%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0262531968%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>232212</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/0262531968.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">51</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0262531968.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">119</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0262531968.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">403</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/0262531968.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">51</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0262531968.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">119</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0262531968.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">403</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Thomas H. Cormen</Author><Author>Charles E. Leiserson</Author><Author>Ronald L. Rivest</Author><Author>Clifford Stein</Author><Binding>Paperback</Binding><DeweyDecimalNumber>004</DeweyDecimalNumber><EAN>9780262531962</EAN><Edition>2</Edition><ISBN>0262531968</ISBN><Label>The MIT Press</Label><ListPrice><Amount>5800</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$58.00</FormattedPrice></ListPrice><Manufacturer>The MIT Press</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>1184</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">950</Height><Weight Units="hundredths-pounds">470</Weight><Width Units="hundredths-inches">750</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>2001-09-01</PublicationDate><Publisher>The MIT Press</Publisher><Studio>The MIT Press</Studio><Title>Introduction to Algorithms, Second Edition</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>6788</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$67.88</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>6046</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$60.46</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>7500</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$75.00</FormattedPrice></LowestCollectiblePrice><TotalNew>9</TotalNew><TotalUsed>2</TotalUsed><TotalCollectible>1</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Amazon.com</Source><Content>Aimed at any serious programmer or computer science student,  the new second edition of &lt;I&gt;Introduction to Algorithms&lt;/I&gt; builds on  the tradition of the original with a truly magisterial guide to the  world of algorithms. Clearly presented, mathematically rigorous, and  yet approachable even for the math-averse, this title sets a high  standard for a textbook and reference to the best algorithms for  solving a wide range of computing problems.&lt;p&gt;With sample problems and  mathematical proofs demonstrating the correctness of each algorithm,  this book is ideal as a textbook for classroom study, but its reach  doesn't end there. The authors do a fine job of explaining each  algorithm. (Reference sections on basic mathematical notation will help  readers bridge the gap, but it will help to have some math background  to appreciate the full achievement of this handsome hardcover volume.)  Every algorithm is presented in pseudo-code, which can be implemented  in any computer language, including C/C++ and Java. This ecumenical  approach is one of the book's strengths. When it comes to sorting and  common data structures, from basic linked lists to trees (including  binary trees, red-black, and B-trees), this title really shines, with  clear diagrams that show algorithms in operation. Even if you just  glance over the mathematical notation here, you can definitely benefit  from this text in other ways.&lt;p&gt;The book moves forward with more  advanced algorithms that implement strategies for solving more  complicated problems (including dynamic programming techniques, greedy  algorithms, and amortized analysis). Algorithms for graphing problems  (used in such real-world business problems as optimizing flight  schedules or flow through pipelines) come next. In each case, the  authors provide the best from current research in each topic, along  with sample solutions.&lt;p&gt;This text closes with a grab bag of useful  algorithms including matrix operations and linear programming,  evaluating polynomials, and the well-known Fast Fourier Transformation  (FFT) (useful in signal processing and engineering). Final sections on  "NP-complete" problems, like the well-known traveling salesman problem,  show off that while not all problems have a demonstrably final and best  answer, algorithms that generate acceptable approximate solutions can  still be used to generate useful, real-world answers.&lt;p&gt;Throughout this  text, the authors anchor their discussion of algorithms with current  examples drawn from molecular biology (like the Human Genome Project),  business, and engineering. Each section ends with short discussions of  related historical material, often discussing original research in each  area of algorithms. On the whole, they argue successfully that  algorithms are a "technology" just like hardware and software that can  be used to write better software that does more, with better  performance. Along with classic books on algorithms (like Donald  Knuth's three-volume set, &lt;I&gt;The Art of Computer  Programming&lt;/I&gt;), this title sets a new standard for compiling the  best research in algorithms. For any experienced developer, regardless  of their chosen language, this text deserves a close look for extending  the range and performance of real-world software. &lt;I&gt;--Richard  Dragan&lt;/I&gt; &lt;p&gt; &lt;B&gt;Topics covered:&lt;/B&gt; Overview of algorithms (including algorithms as  a technology); designing and analyzing algorithms; asymptotic notation;  recurrences and recursion; probabilistic analysis and randomized  algorithms; heapsort algorithms; priority queues; quicksort algorithms;  linear time sorting (including radix and bucket sort); medians and  order statistics (including minimum and maximum); introduction to data  structures (stacks, queues, linked lists, and rooted trees); hash  tables (including hash functions); binary search trees; red-black  trees; augmenting data structures for custom applications; dynamic  programming explained (including assembly-line scheduling, matrix-chain  multiplication, and optimal binary search trees); greedy algorithms  (including Huffman codes and task-scheduling problems); amortized  analysis (the accounting and potential methods); advanced data  structures (including B-trees, binomial and Fibonacci heaps,  representing disjoint sets in data structures); graph algorithms  (representing graphs, minimum spanning trees, single-source shortest  paths, all-pairs shortest paths, and maximum flow algorithms); sorting  networks; matrix operations; linear programming (standard and slack  forms); polynomials and the Fast Fourier Transformation (FFT); number  theoretic algorithms (including greatest common divisor, modular  arithmetic, the Chinese remainder theorem, RSA public-key encryption,  primality testing, integer factorization); string matching;  computational geometry (including finding the convex hull);  NP-completeness (including sample real-world NP-complete problems and  their insolvability); approximation algorithms for NP-complete problems  (including the traveling salesman problem); reference sections for  summations and other mathematical notation, sets, relations, functions,  graphs and trees, as well as counting and probability backgrounder  (plus geometric and binomial distributions).</Content></EditorialReview><EditorialReview><Source>Book Description</Source><Content>&lt;b&gt;PLEASE NOTE: This is the international student paperback edition of this book. The MIT Press does not have sales rights for this paperback edition in the US and Canada. Customers in the US and Canada must order the hardcover edition. &lt;/b&gt;&lt;br /&gt; &lt;br /&gt; There are books on algorithms that are rigorous but incomplete and others that cover masses of material but lack rigor. &lt;i&gt;Introduction to Algorithms&lt;/i&gt; combines rigor and comprehensiveness.&lt;br /&gt; &lt;br /&gt; The book covers a broad range of algorithms in depth, yet makes their design and analysis accessible to all levels of readers. Each chapter is relatively self-contained and can be used as a unit of study. The algorithms are described in English and in a pseudocode designed to be readable by anyone who has done a little programming. The explanations have been kept elementary without sacrificing depth of coverage or mathematical rigor.&lt;br /&gt; &lt;br /&gt; The first edition became the standard reference for professionals and a widely used text in universities worldwide. The second edition features new chapters on the role of algorithms, probabilistic analysis and randomized algorithms, and linear programming, as well as extensive revisions to virtually every section of the book. In a subtle but important change, loop invariants are introduced early and used throughout the text to prove algorithm correctness. Without changing the mathematical and analytic focus, the authors have moved much of the mathematical foundations material from Part I to an appendix and have included additional motivational material at the beginning.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/0262531968.01._SCMZZZZZZZ_.jpg
100	Mathematica	Stephen Wolfram	mathematics mathematica maths	"A System for Doning Mathematics by Computer"\r\n\r\nDonated by Dr. Grant 10/3/05	f	\N	Addison Wesley	\N	\N	0201193345	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1Y6QWAQR512AVMEFYFFS</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0201193345"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.053617000579834</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0201193345</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0201193345</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0201193345%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0201193345%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>2461531</SalesRank><ItemAttributes><Author>Stephen Wolfram</Author><Binding>Hardcover</Binding><EAN>9780201193343</EAN><ISBN>0201193345</ISBN><Label>Addison-Wesley Pub. Co., Advanced Book Program</Label><ListPrice><Amount>3995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$39.95</FormattedPrice></ListPrice><Manufacturer>Addison-Wesley Pub. Co., Advanced Book Program</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>749</NumberOfPages><PackageDimensions><Weight Units="hundredths-pounds">320</Weight></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1988</PublicationDate><Publisher>Addison-Wesley Pub. Co., Advanced Book Program</Publisher><Studio>Addison-Wesley Pub. Co., Advanced Book Program</Studio><Title>Mathematica: A system for doing mathematics by computer</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>3499</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$34.99</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>111</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$1.11</FormattedPrice></LowestUsedPrice><TotalNew>4</TotalNew><TotalUsed>22</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	\N
76	Objects First With Java	David J. Barnes & Michael Kolling	Java BlueJ	Donated by Mr Chris Whyley, 28/02/05\r\nA practical introduction to using BlueJ	f	\N	Prentice Hall	pwb	\N	0130449296	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0GQQYKXHXT6Y4V67G25M</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0130449296"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0463039875030518</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0130449296</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0130449296</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0130449296%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0130449296%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>79468</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/0130449296.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">46</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0130449296.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">107</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0130449296.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">383</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/0130449296.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">46</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0130449296.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">107</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0130449296.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">383</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>David J. Barnes</Author><Author>Michael Kolling</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.117</DeweyDecimalNumber><EAN>9780130449290</EAN><Edition>Bk&amp;CD-Rom</Edition><ISBN>0130449296</ISBN><Label>Prentice Hall</Label><ListPrice><Amount>7600</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$76.00</FormattedPrice></ListPrice><Manufacturer>Prentice Hall</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>400</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">88</Height><Length Units="hundredths-inches">1012</Length><Weight Units="hundredths-pounds">180</Weight><Width Units="hundredths-inches">688</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>2002-10-23</PublicationDate><Publisher>Prentice Hall</Publisher><Studio>Prentice Hall</Studio><Title>Objects First with Java: A Practical Introduction Using BlueJ</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>900</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$9.00</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>599</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$5.99</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>1200</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$12.00</FormattedPrice></LowestCollectiblePrice><TotalNew>10</TotalNew><TotalUsed>23</TotalUsed><TotalCollectible>1</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>/* 0-13-044929-6, 4492J-5, Barnes, Kolling, OBJECTS FIRST WITH JAVA */  &lt;/I&gt;&lt;/B&gt; BlueJ is a Java development environment that runs on top of the Sun Microsystems Java Development Kit making use of the standard compiler and virtual machine. It allows readers to create objects of any class and interact with their methods. For the first time, the traditionally difficult concepts of objects and classes are brought alive in an easily manipulable visual form. This truly &amp;#147;objects first&amp;#148; approach within the customized BlueJ environment will revolutionize the way programming is learned. The book includes a copy of BlueJ. &lt;/I&gt;&lt;/B&gt; Takes a project driven approach to problem solving&amp;#151;the book is structured along the lines of fundamental development tasks&amp;#151;providing readers with clear coverage of the principles of object-oriented programming. &lt;/I&gt;&lt;/B&gt; Programmers and non-programmers who want to learn Java with a state of the art approach and user-friendly programming environment.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/0130449296.01._SCMZZZZZZZ_.jpg
49	Advanced Programming in the UNIX&reg; Environment	W. Richard Stevens	UNIX programming system	Useful for 2nd year Operating Systems course.	f	\N	Addison-Wesley	talyn256	t	0201563177	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0HEKZ8DFDZ70PD9RYVP7</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0201563177"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0439999103546143</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0201563177</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0201563177</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0201563177%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0201563177%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>60077</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/0201563177.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">60</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0201563177.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">128</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0201563177.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">400</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/0201563177.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">60</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0201563177.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">128</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0201563177.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">400</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>W. Richard Stevens</Author><Binding>Hardcover</Binding><DeweyDecimalNumber>005.43</DeweyDecimalNumber><EAN>0785342563177</EAN><Edition>1st</Edition><ISBN>0201563177</ISBN><Label>Addison-Wesley Professional</Label><ListPrice><Amount>6999</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$69.99</FormattedPrice></ListPrice><Manufacturer>Addison-Wesley Professional</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>768</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">203</Height><Length Units="hundredths-inches">958</Length><Weight Units="hundredths-pounds">383</Weight><Width Units="hundredths-inches">766</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1992-06-30</PublicationDate><Publisher>Addison-Wesley Professional</Publisher><Studio>Addison-Wesley Professional</Studio><Title>Advanced Programming in the UNIX(R) Environment</Title><UPC>785342563177</UPC></ItemAttributes><OfferSummary><LowestNewPrice><Amount>1500</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$15.00</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>350</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$3.50</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>4994</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$49.94</FormattedPrice></LowestCollectiblePrice><TotalNew>24</TotalNew><TotalUsed>54</TotalUsed><TotalCollectible>2</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/0201563177.01._SCMZZZZZZZ_.jpg
94	Securing Java	McGraw / Felten	Java	Donated by Mr Andy Gimblett, 8/03/2005	f	\N	Wiley	\N	\N	047131952X	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1KBAFPAS48SA3MW0CHP9</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="047131952X"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0522229671478271</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>047131952X</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>047131952X</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=047131952X%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/047131952X%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>720372</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/047131952X.01._SCTHUMBZZZ_.gif</URL><Height Units="pixels">60</Height><Width Units="pixels">49</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/047131952X.01._SCMZZZZZZZ_.gif</URL><Height Units="pixels">140</Height><Width Units="pixels">113</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/047131952X.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">378</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/047131952X.01._SCTHUMBZZZ_.gif</URL><Height Units="pixels">60</Height><Width Units="pixels">49</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/047131952X.01._SCMZZZZZZZ_.gif</URL><Height Units="pixels">140</Height><Width Units="pixels">113</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/047131952X.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">378</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Gary  McGraw</Author><Author>Edward W.  Felten</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.8</DeweyDecimalNumber><EAN>9780471319528</EAN><Edition>2</Edition><ISBN>047131952X</ISBN><Label>Wiley</Label><ListPrice><Amount>3499</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$34.99</FormattedPrice></ListPrice><Manufacturer>Wiley</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>324</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">81</Height><Length Units="hundredths-inches">916</Length><Weight Units="hundredths-pounds">122</Weight><Width Units="hundredths-inches">745</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1999-01-25</PublicationDate><Publisher>Wiley</Publisher><Studio>Wiley</Studio><Title>Securing Java: Getting Down to Business with Mobile Code, 2nd Edition</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>200</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$2.00</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>189</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$1.89</FormattedPrice></LowestUsedPrice><TotalNew>3</TotalNew><TotalUsed>7</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Amazon.com</Source><Content>The Java environment is relatively secure, as far as network programming languages go. Java has strong security, but not perfect security. &lt;I&gt;Securing Java&lt;/I&gt; explains the known security problems with the language and points out steps that programmers can take to prevent bad guys from taking advantage of their Java-based systems.&lt;p&gt; Authors Gary McGraw and Edward W. Felten begin with the sandbox--the original Java security model. They then explain why the sandbox, while secure, was too restrictive and was combined with a code-signing model in Java 2.&lt;p&gt; After explaining how security ought to work, &lt;I&gt;Securing Java&lt;/I&gt; reveals a menagerie of applets that have circumvented Java security to achieve a variety of noisome and damaging ends. The authors reveal enough information about these applets to show where the dangers are, and they offer security tips for programmers and network administrators.&lt;p&gt; McGraw and Felten include a brief but well-informed chapter about the security issues raised by the Java Card environment and smart cards generally. A couple of question-and-answer sections toward the end of &lt;I&gt;Securing Java&lt;/I&gt; also deserve special recognition. One, on Java security as a whole, provides succinct and accurate answers to questions about how secure Java is and what you can do to minimize your Java security risk. The other Q&amp;A section compares--fairly and with plenty of information--the security features of Java and ActiveX. &lt;i&gt;--David Wall&lt;/i&gt;</Content></EditorialReview><EditorialReview><Source>Book Description</Source><Content>Information Security/Java "This book is mandatory reading for every user and developer of Webware." -Peter G. Neumann, Moderator of the Risks Forum, from his review of the first edition Securing Java Java security is more important now than ever before. As Java matures and moves into the enterprise, security takes a more prominent role. But as Java evolves, its security issues and architectures get more complicated. Written by the world's leading experts on mobile code security, this updated and expanded edition of the groundbreaking guide to Java security includes lessons for Web users, developers, system administrators, and business decision-makers alike. This book navigates the uncharted waters of mobile code security and arms the reader with the knowledge required for securing Java. It provides in-depth coverage of:&lt;br&gt;   * The base Java security sandbox, made up of the Verifier, Class Loaders, and the Security Manager&lt;br&gt;   * Code signing, stack inspection, and the new Java 2 security architecture&lt;br&gt;   * The pros and cons of language-based enforcement models and trust models&lt;br&gt;   * All known Java security holes and the attack applets that exploit them&lt;br&gt;   * Techniques commonly used in malicious applets&lt;br&gt;   * Twelve rules for developing more secure Java code, with explicit examples&lt;br&gt;   * Hard questions to ask third-party Java security tools vendors&lt;br&gt;   * Analysis of competing systems for mobile code, including ActiveX and JavaScript&lt;br&gt;   * Card Java security, smart card risks, and their impact on e-commerce security&lt;br&gt;   On the companion Web site www.securingjava.com you'll find:&lt;br&gt;   * The Java Security Hotlist: Over 100 categorized and annotated Java security-related Web links&lt;br&gt;   * An e-mail list to keep subscribers abreast of breaking Java security news&lt;br&gt;   * A complete electronic edition of this book</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/047131952X.01._SCMZZZZZZZ_.gif
103	Java for Students 2nd ed.	Douglas Bell and Mike Parr	java programming	Java 1.1 and 1.2 compliant\r\n\r\n"An internet-based applet approach is taken, though the text also explains the creation of free-standing applications and text-based programs"\r\n\r\nDonated by Dr. Grant 10/3/05	f	\N	Prentice Hall	\N	\N	0130109223	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1B8CFB1Q2KD4F8WESKQW</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0130109223"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.040369987487793</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0130109223</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0130109223</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0130109223%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0130109223%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>1258950</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/0130109223.01._SCTHUMBZZZ_.gif</URL><Height Units="pixels">60</Height><Width Units="pixels">43</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0130109223.01._SCMZZZZZZZ_.gif</URL><Height Units="pixels">140</Height><Width Units="pixels">101</Width></MediumImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/0130109223.01._SCTHUMBZZZ_.gif</URL><Height Units="pixels">60</Height><Width Units="pixels">43</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0130109223.01._SCMZZZZZZZ_.gif</URL><Height Units="pixels">140</Height><Width Units="pixels">101</Width></MediumImage></ImageSet></ImageSets><ItemAttributes><Author>Doug Bell</Author><Author>Mike Parr</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.133</DeweyDecimalNumber><EAN>9780130109224</EAN><Edition>2nd</Edition><ISBN>0130109223</ISBN><Label>Prentice Hall</Label><ListPrice><Amount>7200</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$72.00</FormattedPrice></ListPrice><Manufacturer>Prentice Hall</Manufacturer><NumberOfPages>586</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">950</Height><Length Units="hundredths-inches">150</Length><Weight Units="hundredths-pounds">215</Weight><Width Units="hundredths-inches">700</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1999-01-15</PublicationDate><Publisher>Prentice Hall</Publisher><Studio>Prentice Hall</Studio><Title>Java for Students 1.2</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>1</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.01</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>1</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.01</FormattedPrice></LowestUsedPrice><TotalNew>10</TotalNew><TotalUsed>27</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/0130109223.01._SCMZZZZZZZ_.gif
139	Programming With Objects And Threads (CS_211)	Mr. C. Whyley (Compiled by)	programming objects threads java POT	Official text of the UWS Programming With Objects And Threads comp sci module (CS_211). Compiled by Chris Whyley of the UWS Comp Sci department. Contains relevant sections on building GUIs, multithreading, exception handling, OO programming and design patterns.	f	\N	Pearson	susman	\N	1844797090	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0WNTDXFHFVMN9BV5WXX2</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1844797090"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0301370620727539</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1844797090</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest><Errors><Error><Code>AWS.InvalidParameterValue</Code><Message>1844797090 is not a valid value for ItemId. Please change this value and retry your request.</Message></Error></Errors></Request></Items></ItemLookupResponse>	\N
138	Programming With Objects And Threads (CS_211)	Mr. C. Whyley (Compiled by)	programming objects threads java POT	Official text of the UWS Programming With Objects And Threads comp sci module (CS_211). Compiled by Chris Whyley of the UWS Comp Sci department. Contains relevant sections on building GUIs, multithreading, exception handling, OO programming and design patterns.	f	\N	Pearson	marknew	\N	1844797090	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0WNTDXFHFVMN9BV5WXX2</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1844797090"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0301370620727539</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1844797090</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest><Errors><Error><Code>AWS.InvalidParameterValue</Code><Message>1844797090 is not a valid value for ItemId. Please change this value and retry your request.</Message></Error></Errors></Request></Items></ItemLookupResponse>	\N
137	Programming With Objects And Threads (CS_211)	Mr. C. Whyley (Compiled by)	programming objects threads java POT	Official text of the UWS Programming With Objects And Threads comp sci module (CS_211). Compiled by Chris Whyley of the UWS Comp Sci department. Contains relevant sections on building GUIs, multithreading, exception handling, OO programming and design patterns.	f	\N	Pearson	dangerousbeans	\N	1844797090	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0WNTDXFHFVMN9BV5WXX2</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1844797090"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0301370620727539</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1844797090</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest><Errors><Error><Code>AWS.InvalidParameterValue</Code><Message>1844797090 is not a valid value for ItemId. Please change this value and retry your request.</Message></Error></Errors></Request></Items></ItemLookupResponse>	\N
28	Software Engineering - Principles and Practice	Hans van Vilet	software engineering	Published in 1993	f	\N	Wiley	\N	t	0471936111	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>02VAHC5KE05HQEDR2MEF</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="ItemId" Value="0471936111"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.197278022766113</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0471936111</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0471936111</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0471936111%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0471936111%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>1964649</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/0471936111.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">47</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0471936111.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">109</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0471936111.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">370</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/0471936111.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">47</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0471936111.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">109</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0471936111.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">370</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Hans Van Vliet</Author><Binding>Hardcover</Binding><DeweyDecimalNumber>005.1</DeweyDecimalNumber><EAN>9780471936114</EAN><Edition>1</Edition><ISBN>0471936111</ISBN><Label>John Wiley &amp; Sons</Label><ListPrice><Amount>6999</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$69.99</FormattedPrice></ListPrice><Manufacturer>John Wiley &amp; Sons</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>578</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">975</Height><Length Units="hundredths-inches">150</Length><Weight Units="hundredths-pounds">265</Weight><Width Units="hundredths-inches">800</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1993-04-26</PublicationDate><Publisher>John Wiley &amp; Sons</Publisher><Studio>John Wiley &amp; Sons</Studio><Title>Software Engineering</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>6396</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$63.96</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>584</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$5.84</FormattedPrice></LowestUsedPrice><TotalNew>1</TotalNew><TotalUsed>5</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>The publisher, John Wiley &amp; Sons</Source><Content>Instructor's Guide available.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/0471936111.01._SCMZZZZZZZ_.jpg
85	Fundamentals of Database Systems	Elmasri / Navathe	Databases DB	Donated by Dr Roger Stein, 28/02/05	f	\N	Benjamin / Cummings	\N	\N	0805317538	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1M252RBJVW1N9DH6F470</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0805317538"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0452520847320557</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0805317538</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0805317538</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0805317538%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0805317538%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>2259238</SalesRank><SmallImage><URL>http://ec1.images-amazon.com/images/P/0805317538.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">48</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/0805317538.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">112</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/0805317538.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">380</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://ec1.images-amazon.com/images/P/0805317538.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">48</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/0805317538.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">112</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/0805317538.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">380</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Ramez Elmasri</Author><Author>Shamkant Navathe</Author><Binding>Paperback</Binding><EAN>9780805317534</EAN><ISBN>0805317538</ISBN><Label>Pearson Higher Education</Label><Manufacturer>Pearson Higher Education</Manufacturer><ProductGroup>Book</ProductGroup><PublicationDate>1994-01-07</PublicationDate><Publisher>Pearson Higher Education</Publisher><Studio>Pearson Higher Education</Studio><Title>Fundamentals of Data Systems</Title></ItemAttributes><OfferSummary><LowestUsedPrice><Amount>700</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$7.00</FormattedPrice></LowestUsedPrice><TotalNew>0</TotalNew><TotalUsed>2</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	http://ec1.images-amazon.com/images/P/0805317538.01._SCMZZZZZZZ_.jpg
18	Software Engineering	Gregory W. Jones	software engineering	Published in 1990	f	\N	Wiley	\N	t	047152249X	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1BJ3CMPCTHGD5Q42H7Z9</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="047152249X"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0487260818481445</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>047152249X</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>047152249X</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=047152249X%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/047152249X%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><ItemAttributes><Author>Greg Jones</Author><Binding>Paperback</Binding><EAN>9780471522492</EAN><ISBN>047152249X</ISBN><Label>John Wiley and Sons Ltd</Label><Manufacturer>John Wiley and Sons Ltd</Manufacturer><ProductGroup>Book</ProductGroup><PublicationDate>1990-04-29</PublicationDate><Publisher>John Wiley and Sons Ltd</Publisher><Studio>John Wiley and Sons Ltd</Studio><Title>An Introduction to Software Engineering</Title></ItemAttributes><OfferSummary><TotalNew>0</TotalNew><TotalUsed>0</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	\N
33	Object Solutions	Grady Booch	object oriented	Published in 1996	f	\N	Addison-Wesley	\N	t	0805305947	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>19Q9KP8FCWQ02T61KKE2</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0805305947"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.051738977432251</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0805305947</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0805305947</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0805305947%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0805305947%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>163441</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/0805305947.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">46</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0805305947.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">106</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0805305947.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">361</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/0805305947.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">46</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0805305947.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">106</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0805305947.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">361</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Grady Booch</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.11</DeweyDecimalNumber><EAN>0785342305944</EAN><Edition>1st</Edition><ISBN>0805305947</ISBN><Label>Pearson Education</Label><ListPrice><Amount>3999</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$39.99</FormattedPrice></ListPrice><Manufacturer>Pearson Education</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>336</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">64</Height><Length Units="hundredths-inches">932</Length><Weight Units="hundredths-pounds">112</Weight><Width Units="hundredths-inches">750</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1995-10-12</PublicationDate><Publisher>Pearson Education</Publisher><Studio>Pearson Education</Studio><Title>Object Solutions: Managing the Object-Oriented Project (OBT)</Title><UPC>785342305944</UPC></ItemAttributes><OfferSummary><LowestNewPrice><Amount>2075</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$20.75</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>399</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$3.99</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>3999</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$39.99</FormattedPrice></LowestCollectiblePrice><TotalNew>9</TotalNew><TotalUsed>34</TotalUsed><TotalCollectible>1</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/0805305947.01._SCMZZZZZZZ_.jpg
32	Information Systems for Managers	George W. Reynolds	information systems	Second edition	f	\N	West	\N	t	0314915451	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0JGMVAXRVBHKR5D8CB58</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0314915451"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0612831115722656</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0314915451</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0314915451</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0314915451%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0314915451%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>3435604</SalesRank><ItemAttributes><Author>George Walter Reynolds</Author><Binding>Hardcover</Binding><DeweyDecimalNumber>658.4038</DeweyDecimalNumber><EAN>9780314915450</EAN><Edition>2nd</Edition><ISBN>0314915451</ISBN><Label>West Publishing Company</Label><ListPrice><Amount>5800</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$58.00</FormattedPrice></ListPrice><Manufacturer>West Publishing Company</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>539</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">1050</Height><Length Units="hundredths-inches">100</Length><Weight Units="hundredths-pounds">250</Weight><Width Units="hundredths-inches">800</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1991-12</PublicationDate><Publisher>West Publishing Company</Publisher><Studio>West Publishing Company</Studio><Title>Information Systems for Managers</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>5288</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$52.88</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>132</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$1.32</FormattedPrice></LowestUsedPrice><TotalNew>2</TotalNew><TotalUsed>4</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	\N
24	Interactive System Design	William M. Newman & Michael G. Lamming	interactive system design	First edition (published 1995)	f	\N	Addison-Wesley	\N	t	0201631628	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1589AKKWK417Z5JRH1M6</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0201631628"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.049130916595459</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0201631628</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0201631628</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0201631628%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0201631628%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>997189</SalesRank><SmallImage><URL>http://ec1.images-amazon.com/images/P/0201631628.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">58</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/0201631628.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">124</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/0201631628.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">386</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://ec1.images-amazon.com/images/P/0201631628.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">58</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/0201631628.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">124</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/0201631628.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">386</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>M. Lamming</Author><Author>W. Newman</Author><Binding>Hardcover</Binding><DeweyDecimalNumber>004.21019</DeweyDecimalNumber><EAN>9780201631623</EAN><Edition>1st</Edition><ISBN>0201631628</ISBN><Label>Addison Wesley</Label><ListPrice><Amount>4594</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$45.94</FormattedPrice></ListPrice><Manufacturer>Addison Wesley</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>504</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">121</Height><Length Units="hundredths-inches">953</Length><Weight Units="hundredths-pounds">210</Weight><Width Units="hundredths-inches">705</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1995-05-10</PublicationDate><Publisher>Addison Wesley</Publisher><Studio>Addison Wesley</Studio><Title>Interactive System Design</Title></ItemAttributes><OfferSummary><LowestUsedPrice><Amount>2799</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$27.99</FormattedPrice></LowestUsedPrice><TotalNew>0</TotalNew><TotalUsed>7</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	http://ec1.images-amazon.com/images/P/0201631628.01._SCMZZZZZZZ_.jpg
101	Fundamentals of Interactive Computer Graphics	J. D.Foley & A. Van Dam	graphics	"This book presents graphics concepts and recent advances in graphics hardware and software"\r\n\r\nNB: "recent advances" means things that were recent in 1982.\r\n\r\nDonated by Dr. Grant 10/3/05	f	\N	Addison Wesley	\N	\N	0201144689	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1XAZRWHNC9XQ24JB98YP</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0201144689"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0654098987579346</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0201144689</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0201144689</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0201144689%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0201144689%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>444940</SalesRank><ItemAttributes><Author>James D. Foley</Author><Binding>Hardcover</Binding><DeweyDecimalNumber>001.6443</DeweyDecimalNumber><EAN>9780201144680</EAN><ISBN>0201144689</ISBN><Label>Addison-Wesley</Label><ListPrice><Amount>4440</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$44.40</FormattedPrice></ListPrice><Manufacturer>Addison-Wesley</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>664</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">898</Height><Length Units="hundredths-inches">81</Length><Weight Units="hundredths-pounds">121</Weight><Width Units="hundredths-inches">602</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1982-05</PublicationDate><Publisher>Addison-Wesley</Publisher><Studio>Addison-Wesley</Studio><Title>Fundamentals of Interactive Computer Graphics (Systems Programming Series)</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>1475</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$14.75</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>40</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.40</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>499</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$4.99</FormattedPrice></LowestCollectiblePrice><TotalNew>8</TotalNew><TotalUsed>95</TotalUsed><TotalCollectible>10</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	\N
29	Care for Your Kitten	RSPCA	kitten cat care	Second edition printed in 1997	f	\N	Collins	davea	t	0004125436	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1MZRVXAP5JRWBPTE2X42</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0004125436"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0524661540985107</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0004125436</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0004125436</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0004125436%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0004125436%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>4174760</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/0004125436.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">45</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0004125436.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">104</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0004125436.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">353</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/0004125436.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">45</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0004125436.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">104</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0004125436.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">353</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Binding>Paperback</Binding><EAN>9780004125435</EAN><ISBN>0004125436</ISBN><Label>HarperCollins Publishers</Label><Manufacturer>HarperCollins Publishers</Manufacturer><ProductGroup>Book</ProductGroup><PublicationDate>1994-05-05</PublicationDate><Publisher>HarperCollins Publishers</Publisher><Studio>HarperCollins Publishers</Studio><Title>Care for Your Kitten (Official RSPCA Pet Guides)</Title></ItemAttributes><OfferSummary><LowestUsedPrice><Amount>548</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$5.48</FormattedPrice></LowestUsedPrice><TotalNew>0</TotalNew><TotalUsed>7</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/0004125436.01._SCMZZZZZZZ_.jpg
25	System Requirements Engineering	Pericles Loucopoulos and Vassilios Karakostas	system requirements engineering	Published in 1995. The paper complies with ISO Standard 9706	f	\N	McGraw-Hill	\N	t	0077078438	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1RRDNQ59TW5E502DBC62</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0077078438"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0470030307769775</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0077078438</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0077078438</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0077078438%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0077078438%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>3139974</SalesRank><ItemAttributes><Author>Pericles Loucopoulos</Author><Author>Vassilios Karakostas</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.12</DeweyDecimalNumber><EAN>9780077078430</EAN><ISBN>0077078438</ISBN><Label>McGraw-Hill Companies</Label><ListPrice><Amount>4000</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$40.00</FormattedPrice></ListPrice><Manufacturer>McGraw-Hill Companies</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>160</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">975</Height><Length Units="hundredths-inches">50</Length><Weight Units="hundredths-pounds">80</Weight><Width Units="hundredths-inches">775</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1995-06</PublicationDate><Publisher>McGraw-Hill Companies</Publisher><Studio>McGraw-Hill Companies</Studio><Title>System Requirements Engineering (McGraw-Hill International Software Quality Assurance Series)</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>4000</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$40.00</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>7490</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$74.90</FormattedPrice></LowestUsedPrice><TotalNew>2</TotalNew><TotalUsed>2</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	\N
26	Software System Development	Carol Britton and Jill Doake	software system development	Published in 1993	f	\N	McGraw-Hill	\N	t	0077077121	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0ZTH1F21PCYGJD78NQEF</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0077077121"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0467219352722168</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0077077121</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0077077121</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0077077121%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0077077121%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>2466917</SalesRank><ItemAttributes><Author>Carol Britton</Author><Author>Jill Doake</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.1</DeweyDecimalNumber><EAN>9780077077129</EAN><ISBN>0077077121</ISBN><Label>Mcgraw-Hill (Tx)</Label><ListPrice><Amount>3000</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$30.00</FormattedPrice></ListPrice><Manufacturer>Mcgraw-Hill (Tx)</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>240</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">925</Height><Length Units="hundredths-inches">50</Length><Weight Units="hundredths-pounds">75</Weight><Width Units="hundredths-inches">625</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1993-03</PublicationDate><Publisher>Mcgraw-Hill (Tx)</Publisher><Studio>Mcgraw-Hill (Tx)</Studio><Title>Software System Development: A Gentle Introduction (The Mcgraw-Hill International Series in Software Engineering)</Title></ItemAttributes><OfferSummary><LowestUsedPrice><Amount>844</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$8.44</FormattedPrice></LowestUsedPrice><TotalNew>0</TotalNew><TotalUsed>6</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Book Description</Source><Content>This book follows the development of a system from the initial idea through to the completed software product. Keen to highlight the practicalities of developing systems, there is a continuous case study running throughout the book which demonstrates many of the problems the developer faces in real life situations.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	\N
23	Information Systems Development	Avison and Fitzgerald	information systems methodologies techniques tools	Second Edition	f	\N	McGraw-Hill	\N	t	0077092333	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1BSAHZNS7ZMYQCF19VXE</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0077092333"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0572957992553711</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0077092333</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0077092333</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0077092333%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0077092333%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>1202808</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/0077092333.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">39</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0077092333.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">91</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0077092333.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">309</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/0077092333.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">60</Height><Width Units="pixels">39</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/0077092333.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">140</Height><Width Units="pixels">91</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/0077092333.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">475</Height><Width Units="pixels">309</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>D. E. Avison</Author><Author>G. Fitzgerald</Author><Author>McGraw-Hill</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.12</DeweyDecimalNumber><EAN>9780077092337</EAN><Edition>2nd</Edition><ISBN>0077092333</ISBN><Label>McGraw-Hill Companies</Label><ListPrice><Amount>5700</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$57.00</FormattedPrice></ListPrice><Manufacturer>McGraw-Hill Companies</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>528</NumberOfPages><PackageDimensions><Weight Units="hundredths-pounds">167</Weight></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1998-02-04</PublicationDate><Publisher>McGraw-Hill Companies</Publisher><Studio>McGraw-Hill Companies</Studio><Title>Information Systems Development: Methodologies, Techniques, and Tools (Information Systems Series)</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>3995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$39.95</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>3994</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$39.94</FormattedPrice></LowestUsedPrice><TotalNew>2</TotalNew><TotalUsed>3</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/0077092333.01._SCMZZZZZZZ_.jpg
37	Information Systems in Business: An Introduction	James O. Hicks, JR.	information systems	Second edition	f	\N	West	\N	t	0314667725	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0TP9JCTQX7VQK8QQK5QP</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0314667725"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0537080764770508</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0314667725</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0314667725</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0314667725%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0314667725%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><ItemAttributes><Author>James O. Hicks</Author><Binding>Hardcover</Binding><DeweyDecimalNumber>658.4038</DeweyDecimalNumber><EAN>9780314667724</EAN><Edition>2nd</Edition><ISBN>0314667725</ISBN><Label>West Publishing Company</Label><ListPrice><Amount>6695</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$66.95</FormattedPrice></ListPrice><Manufacturer>West Publishing Company</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>512</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">1050</Height><Length Units="hundredths-inches">100</Length><Weight Units="hundredths-pounds">300</Weight><Width Units="hundredths-inches">900</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1990-01</PublicationDate><Publisher>West Publishing Company</Publisher><Studio>West Publishing Company</Studio><Title>Information Systems in Business: An Introduction</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>2888</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$28.88</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>107</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$1.07</FormattedPrice></LowestUsedPrice><TotalNew>1</TotalNew><TotalUsed>13</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	\N
83	Knowledge Representation - An approach to AI	Bench-Capon	AI artificial intelligence	Donated by Mr Chris Whyley, 28/02/05	f	\N	Academic Press	\N	\N	0120864401	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>1T0YWERDTYB6BVVMP5ZS</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0120864401"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0444221496582031</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0120864401</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0120864401</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0120864401%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0120864401%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>2855817</SalesRank><ItemAttributes><Author>T. J. M. Bench-Capon</Author><Binding>Hardcover</Binding><EAN>9780120864409</EAN><Edition>Reprinted Ed</Edition><ISBN>0120864401</ISBN><Label>Academic Pr</Label><ListPrice><Amount>5000</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$50.00</FormattedPrice></ListPrice><Manufacturer>Academic Pr</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>264</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">950</Height><Length Units="hundredths-inches">75</Length><Weight Units="hundredths-pounds">105</Weight><Width Units="hundredths-inches">625</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1990-12</PublicationDate><Publisher>Academic Pr</Publisher><Studio>Academic Pr</Studio><Title>Knowledge Representation: An Approach to Artificial Intelligence (Apic Studies in Data Processing)</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>1200</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$12.00</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>960</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$9.60</FormattedPrice></LowestUsedPrice><TotalNew>1</TotalNew><TotalUsed>6</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	\N
4	Data Communications, Computer Networks and Open Systems	Fred Halsall	Networks	3rd Edition. Donated by Steve Whitehouse\r\n	f	\N	Addison-Wesley	dhilton	t	0201565064	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0467TK7NNVYNF47QSR6T</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0201565064"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0604159832000732</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0201565064</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0201565064</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0201565064%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0201565064%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>613133</SalesRank><ItemAttributes><Author>Fred Halsall</Author><Binding>Hardcover</Binding><EAN>9780201565065</EAN><Edition>3rd</Edition><ISBN>0201565064</ISBN><Label>Addison-Wesley</Label><ListPrice><Amount>6025</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$60.25</FormattedPrice></ListPrice><Manufacturer>Addison-Wesley</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>772</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">975</Height><Length Units="hundredths-inches">150</Length><Weight Units="hundredths-pounds">330</Weight><Width Units="hundredths-inches">775</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1992-02</PublicationDate><Publisher>Addison-Wesley</Publisher><Studio>Addison-Wesley</Studio><Title>Data Communications, Computer Networks, and Open Systems (Electronic Systems Engineering Series)</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>5799</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$57.99</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>77</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.77</FormattedPrice></LowestUsedPrice><TotalNew>3</TotalNew><TotalUsed>26</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	\N
7	HTML: The Definitive Guide	Chuck Musciano & Bill Kennedy	HTML	2nd Edition, published 1997.	f	\N	O'Reilly	abdulkahar	t	1565922352	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>17EDMJDYJPFCP5VF6H66</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1565922352"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.053325891494751</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1565922352</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1565922352</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1565922352%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1565922352%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>351344</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/1565922352.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">57</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565922352.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">122</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565922352.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">382</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/1565922352.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">57</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565922352.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">122</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565922352.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">382</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Chuck Musciano</Author><Author>Bill Kennedy</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.72</DeweyDecimalNumber><EAN>9781565922358</EAN><Edition>2</Edition><ISBN>1565922352</ISBN><Label>O'Reilly</Label><ListPrice><Amount>3295</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$32.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>552</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">950</Height><Length Units="hundredths-inches">125</Length><Weight Units="hundredths-pounds">180</Weight><Width Units="hundredths-inches">700</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1997-05</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>HTML: The Definitive Guide (Nutshell Handbook)</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>295</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$2.95</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>131</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$1.31</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>800</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$8.00</FormattedPrice></LowestCollectiblePrice><TotalNew>3</TotalNew><TotalUsed>21</TotalUsed><TotalCollectible>1</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Amazon.com</Source><Content>For those with some HTML knowledge, &lt;I&gt;HTML: The Definitive Guide&lt;/I&gt; is a practical text that covers HTML 3.2 syntax, semantics, and elements of style and explains each tag in detail. Using this guide, you can learn how HTML elements interact with each other, how browsers have limitations and differences, and how to create documents that look good on a variety of browsers. &lt;I&gt;HTML: The Definitive Guide&lt;/I&gt; also details cascading style sheets, tables, frames, forms, inserting images, sound files, video, applets, JavaScript programs, and layers.&lt;p&gt; This guide will teach you the most effective use of HTML to accomplish a variety of tasks, from simple to complex. You'll become fluent in the language and learn to distinguish between good and bad HTML usage.</Content></EditorialReview><EditorialReview><Source>Book Description</Source><Content>Netscape Navigator 4.0! Internet Explorer 4.0! HTML 3.2! JavaScript! Style sheets! Layers! HTML is changing so fast it's almost impossible to keep up with developments. How do you know what's real, and how do you use it? This book brings it all together for you. &lt;i&gt;HTML: The Definitive Guide&lt;/i&gt; is the most comprehensive book available on HTML today. It covers the latest standard, HTML 3.2, and all of the features supported by every popular Web browser, including the latest editions of Netscape and Internet Explorer.&lt;p&gt;Learning HTML is like learning any new language, computer or human. Most students first immerse themselves in examples. Studying others is a natural way to learn, making learning easy and fun. Imitation can take you only so far, though. It's as easy to learn bad habits through imitation as it is to acquire good ones. The better way to become HTML-fluent is through a comprehensive reference that covers the language syntax, semantics, and variations in detail and helps you distinguish between good and bad usage.&lt;p&gt;&lt;i&gt;HTML: The Definitive Guide&lt;/i&gt; helps you both ways: the authors cover every  element of HTML in detail, explaining how each element works and  how it interacts with other elements. Many hints about HTML style  help you accomplish a variety of tasks, from simple online  documentation to complex marketing and sales presentations. With  hundreds of examples, the book gives you models for writing your  own effective Web pages and mastering advanced features, like style  sheets and frames.&lt;p&gt;&lt;i&gt;HTML: The Definitive Guide&lt;/i&gt; shows you how to:&lt;ul&gt;&lt;li&gt;Use style sheets and layers to control a document's appearance&lt;/li&gt;&lt;li&gt;Create tables, from simple to complex&lt;/li&gt;&lt;li&gt;Use Netscape's frames to coordinate sets of documents&lt;/li&gt;&lt;li&gt;Design and build interactive forms&lt;/li&gt;&lt;li&gt;Insert images, sound files, video, applets, and JavaScript programs&lt;/li&gt;&lt;li&gt;Create dynamic documents with server-push and client-pull&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;A handy quick reference card listing HTML tags is included.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/1565922352.01._SCMZZZZZZZ_.jpg
73	HTML: The Definitive Guide	Chuck Musciano & Bill Kennedy	html	2nd Edition, published 1997. Donated by Steven Whitehouse	f	\N	O'Reilly	\N	\N	1565922352	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>17EDMJDYJPFCP5VF6H66</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1565922352"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.053325891494751</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1565922352</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1565922352</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1565922352%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1565922352%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>351344</SalesRank><SmallImage><URL>http://images.amazon.com/images/P/1565922352.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">57</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565922352.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">122</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565922352.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">382</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://images.amazon.com/images/P/1565922352.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">57</Width></SmallImage><MediumImage><URL>http://images.amazon.com/images/P/1565922352.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">122</Width></MediumImage><LargeImage><URL>http://images.amazon.com/images/P/1565922352.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">382</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Chuck Musciano</Author><Author>Bill Kennedy</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.72</DeweyDecimalNumber><EAN>9781565922358</EAN><Edition>2</Edition><ISBN>1565922352</ISBN><Label>O'Reilly</Label><ListPrice><Amount>3295</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$32.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>552</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">950</Height><Length Units="hundredths-inches">125</Length><Weight Units="hundredths-pounds">180</Weight><Width Units="hundredths-inches">700</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1997-05</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>HTML: The Definitive Guide (Nutshell Handbook)</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>295</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$2.95</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>131</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$1.31</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>800</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$8.00</FormattedPrice></LowestCollectiblePrice><TotalNew>3</TotalNew><TotalUsed>21</TotalUsed><TotalCollectible>1</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Amazon.com</Source><Content>For those with some HTML knowledge, &lt;I&gt;HTML: The Definitive Guide&lt;/I&gt; is a practical text that covers HTML 3.2 syntax, semantics, and elements of style and explains each tag in detail. Using this guide, you can learn how HTML elements interact with each other, how browsers have limitations and differences, and how to create documents that look good on a variety of browsers. &lt;I&gt;HTML: The Definitive Guide&lt;/I&gt; also details cascading style sheets, tables, frames, forms, inserting images, sound files, video, applets, JavaScript programs, and layers.&lt;p&gt; This guide will teach you the most effective use of HTML to accomplish a variety of tasks, from simple to complex. You'll become fluent in the language and learn to distinguish between good and bad HTML usage.</Content></EditorialReview><EditorialReview><Source>Book Description</Source><Content>Netscape Navigator 4.0! Internet Explorer 4.0! HTML 3.2! JavaScript! Style sheets! Layers! HTML is changing so fast it's almost impossible to keep up with developments. How do you know what's real, and how do you use it? This book brings it all together for you. &lt;i&gt;HTML: The Definitive Guide&lt;/i&gt; is the most comprehensive book available on HTML today. It covers the latest standard, HTML 3.2, and all of the features supported by every popular Web browser, including the latest editions of Netscape and Internet Explorer.&lt;p&gt;Learning HTML is like learning any new language, computer or human. Most students first immerse themselves in examples. Studying others is a natural way to learn, making learning easy and fun. Imitation can take you only so far, though. It's as easy to learn bad habits through imitation as it is to acquire good ones. The better way to become HTML-fluent is through a comprehensive reference that covers the language syntax, semantics, and variations in detail and helps you distinguish between good and bad usage.&lt;p&gt;&lt;i&gt;HTML: The Definitive Guide&lt;/i&gt; helps you both ways: the authors cover every  element of HTML in detail, explaining how each element works and  how it interacts with other elements. Many hints about HTML style  help you accomplish a variety of tasks, from simple online  documentation to complex marketing and sales presentations. With  hundreds of examples, the book gives you models for writing your  own effective Web pages and mastering advanced features, like style  sheets and frames.&lt;p&gt;&lt;i&gt;HTML: The Definitive Guide&lt;/i&gt; shows you how to:&lt;ul&gt;&lt;li&gt;Use style sheets and layers to control a document's appearance&lt;/li&gt;&lt;li&gt;Create tables, from simple to complex&lt;/li&gt;&lt;li&gt;Use Netscape's frames to coordinate sets of documents&lt;/li&gt;&lt;li&gt;Design and build interactive forms&lt;/li&gt;&lt;li&gt;Insert images, sound files, video, applets, and JavaScript programs&lt;/li&gt;&lt;li&gt;Create dynamic documents with server-push and client-pull&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;A handy quick reference card listing HTML tags is included.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://images.amazon.com/images/P/1565922352.01._SCMZZZZZZZ_.jpg
82	Software Engineering: A programming approach	Doub Bell / Ian Morray / John Pugh	Software Engineering	Donated by Dr Roger Stein, 28/02/05	f	\N	Prentice / Hall international	\N	\N	0138218366	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0TC9MZAV68XPACFW1GP3</RequestId><Arguments><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="0138218366"></Argument><Argument Name="IdType" Value="ASIN"></Argument></Arguments><RequestProcessingTime>0.0487589836120605</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>0138218366</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>0138218366</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=0138218366%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/0138218366%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><ItemAttributes><Author>Doug Bell</Author><Binding>Paperback</Binding><EAN>9780138218362</EAN><ISBN>0138218366</ISBN><Label>Prentice-Hall International</Label><Manufacturer>Prentice-Hall International</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>250</NumberOfPages><ProductGroup>Book</ProductGroup><PublicationDate>1987</PublicationDate><Publisher>Prentice-Hall International</Publisher><Studio>Prentice-Hall International</Studio><Title>Software engineering: A programming approach</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>600</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$6.00</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>445</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$4.45</FormattedPrice></LowestUsedPrice><TotalNew>1</TotalNew><TotalUsed>5</TotalUsed><TotalCollectible>0</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary></Item></Items></ItemLookupResponse>	\N
55	Programming Perl	Larry Wall, Tom Christiansen & Randal L. Schwartz	Perl	2nd Edition (covers Perl 5). Donated by Steven Whitehouse	f	\N	O'Reilly	pwb	t	1565921496	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0CRMGE3EFNC4SCCDSEWH</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1565921496"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0590271949768066</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1565921496</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1565921496</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1565921496%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1565921496%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>63201</SalesRank><SmallImage><URL>http://ec1.images-amazon.com/images/P/1565921496.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">57</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/1565921496.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">122</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/1565921496.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">380</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://ec1.images-amazon.com/images/P/1565921496.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">57</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/1565921496.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">122</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/1565921496.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">380</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Larry Wall</Author><Author>Tom Christiansen</Author><Author>Randal L. Schwartz</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.133</DeweyDecimalNumber><EAN>0636920921493</EAN><Edition>2</Edition><ISBN>1565921496</ISBN><Label>O'Reilly</Label><ListPrice><Amount>4495</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$44.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>670</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">925</Height><Length Units="hundredths-inches">150</Length><Weight Units="hundredths-pounds">235</Weight><Width Units="hundredths-inches">725</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1996-10</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>Programming Perl (2nd Edition)</Title><UPC>636920921493</UPC></ItemAttributes><OfferSummary><LowestNewPrice><Amount>990</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$9.90</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>54</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$0.54</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>4495</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$44.95</FormattedPrice></LowestCollectiblePrice><TotalNew>6</TotalNew><TotalUsed>49</TotalUsed><TotalCollectible>1</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Amazon.com</Source><Content>The second edition of the Camel Book is more than 600 pages long and full of excellent instruction and sound advice. Topics include all the good stuff from the first edition plus Perl 5 features such as nested data structures (ever made a hash of arrays of hashes?), modules, and objects. From &lt;NOBR&gt;&lt;CODE&gt;"Howdy World"&lt;/CODE&gt;&lt;/NOBR&gt; to making your own modules, this book has it all.</Content></EditorialReview><EditorialReview><Source>Book Description</Source><Content>&lt;i&gt;Programming Perl, 2nd Edition&lt;/i&gt; is the authoritative guide to Perl  version 5, the scripting utility that has established itself as the  programming tool of choice for the World Wide Web, UNIX system  administration, and a vast range of other applications.  Version 5 of  Perl includes object-oriented programming facilities.  The book is  coauthored by Larry Wall, the creator of Perl.&lt;p&gt;Perl is a language for easily manipulating text, files, and processes. It provides a more concise and readable way to do many jobs that were  formerly accomplished (with difficulty) by programming with C or one of the shells.  Perl is likely to be available wherever you choose to work. And if it isn't, you can get it and install it easily and free of charge.&lt;p&gt;This heavily revised second edition of &lt;i&gt;Programming Perl&lt;/i&gt; contains a  full explanation of the features in Perl version 5.003.  Contents include:&lt;p&gt;&lt;ul&gt;&lt;li&gt;An introduction to Perl&lt;/li&gt;&lt;li&gt;Explanations of the language and its syntax&lt;/li&gt;&lt;li&gt;Perl functions&lt;/li&gt;&lt;li&gt;Perl library modules&lt;/li&gt;&lt;li&gt;The use of references in Perl&lt;/li&gt;&lt;li&gt;How to use Perl's object-oriented features&lt;/li&gt;&lt;li&gt;Invocation options for Perl itself, and also for the utilities that come with Perl&lt;/li&gt;&lt;li&gt;Other oddments:  debugging, common mistakes, efficiency, programming style, distribution and installation of Perl, Perl poetry, and so on.&lt;/li&gt;&lt;/ul&gt;</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://ec1.images-amazon.com/images/P/1565921496.01._SCMZZZZZZZ_.jpg
51	Perl Cookbook	Tom Christiansen & Nathan Torkington	perl programming	Solutions and Examples for Perl Programmers	f	\N	O'Reilly	phaser2001	t	1565922433	<?xml version="1.0" encoding="UTF-8"?><ItemLookupResponse xmlns="http://webservices.amazon.com/AWSECommerceService/2005-10-05"><OperationRequest><HTTPHeaders><Header Name="UserAgent"></Header></HTTPHeaders><RequestId>0J75CAJ7MB1PJMFW22C0</RequestId><Arguments><Argument Name="Service" Value="AWSECommerceService"></Argument><Argument Name="AWSAccessKeyId" Value="02NDPFGZ9A35HRBQ9NG2"></Argument><Argument Name="ItemId" Value="1565922433"></Argument><Argument Name="IdType" Value="ASIN"></Argument><Argument Name="ResponseGroup" Value="Medium,Images"></Argument><Argument Name="Operation" Value="ItemLookup"></Argument></Arguments><RequestProcessingTime>0.0441710948944092</RequestProcessingTime></OperationRequest><Items><Request><IsValid>True</IsValid><ItemLookupRequest><IdType>ASIN</IdType><ItemId>1565922433</ItemId><ResponseGroup>Medium</ResponseGroup><ResponseGroup>Images</ResponseGroup></ItemLookupRequest></Request><Item><ASIN>1565922433</ASIN><DetailPageURL>http://www.amazon.com/gp/redirect.html%3FASIN=1565922433%26tag=ws%26lcode=xm2%26cID=2025%26ccmID=165953%26location=/o/ASIN/1565922433%253FSubscriptionId=02NDPFGZ9A35HRBQ9NG2</DetailPageURL><SalesRank>157665</SalesRank><SmallImage><URL>http://ec1.images-amazon.com/images/P/1565922433.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">57</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/1565922433.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">121</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/1565922433.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">378</Width></LargeImage><ImageSets><ImageSet Category="primary"><SmallImage><URL>http://ec1.images-amazon.com/images/P/1565922433.01._SCTHUMBZZZ_.jpg</URL><Height Units="pixels">75</Height><Width Units="pixels">57</Width></SmallImage><MediumImage><URL>http://ec1.images-amazon.com/images/P/1565922433.01._SCMZZZZZZZ_.jpg</URL><Height Units="pixels">160</Height><Width Units="pixels">121</Width></MediumImage><LargeImage><URL>http://ec1.images-amazon.com/images/P/1565922433.01._SCLZZZZZZZ_.jpg</URL><Height Units="pixels">500</Height><Width Units="pixels">378</Width></LargeImage></ImageSet></ImageSets><ItemAttributes><Author>Tom Christiansen</Author><Author>Nathan Torkington</Author><Binding>Paperback</Binding><DeweyDecimalNumber>005.133</DeweyDecimalNumber><EAN>9781565922433</EAN><Edition>1</Edition><ISBN>1565922433</ISBN><Label>O'Reilly</Label><ListPrice><Amount>3995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$39.95</FormattedPrice></ListPrice><Manufacturer>O'Reilly</Manufacturer><NumberOfItems>1</NumberOfItems><NumberOfPages>794</NumberOfPages><PackageDimensions><Height Units="hundredths-inches">155</Height><Length Units="hundredths-inches">922</Length><Weight Units="hundredths-pounds">200</Weight><Width Units="hundredths-inches">708</Width></PackageDimensions><ProductGroup>Book</ProductGroup><PublicationDate>1998-08-01</PublicationDate><Publisher>O'Reilly</Publisher><Studio>O'Reilly</Studio><Title>Perl Cookbook</Title></ItemAttributes><OfferSummary><LowestNewPrice><Amount>1399</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$13.99</FormattedPrice></LowestNewPrice><LowestUsedPrice><Amount>390</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$3.90</FormattedPrice></LowestUsedPrice><LowestCollectiblePrice><Amount>3995</Amount><CurrencyCode>USD</CurrencyCode><FormattedPrice>$39.95</FormattedPrice></LowestCollectiblePrice><TotalNew>6</TotalNew><TotalUsed>24</TotalUsed><TotalCollectible>1</TotalCollectible><TotalRefurbished>0</TotalRefurbished></OfferSummary><EditorialReviews><EditorialReview><Source>Amazon.com</Source><Content>When the second edition of &lt;I&gt;Programming Perl&lt;/i&gt; was released, the authors omitted two chapters: "Common Tasks with Perl" and "Real Perl Programs." Publisher O'Reilly &amp; Associates soon realized that there would be too many pages in &lt;I&gt;Programming Perl&lt;/I&gt; if it put updated recipes in the new edition. Instead, O'Reilly chose to release the many Perl code examples as a separate entity: &lt;I&gt;The Perl Cookbook&lt;/I&gt;.&lt;p&gt; The recipes are well documented and the examples aren't too arcane; even beginners will be able to pick up the lessons taught here. The authors write in relatively easy-to-understand language (for a technical guide). Through this book and its arsenal of recipes, you will learn many new things about Perl to help you through your toughest projects. The next time you're working on a project at 2 a.m., you'll thank yourself for the guidance and direction &lt;I&gt;The Perl Cookbook&lt;/I&gt; provides. &lt;I&gt;--Doug Beaver&lt;/I&gt;</Content></EditorialReview><EditorialReview><Source>Book Description</Source><Content>The &lt;i&gt;Perl Cookbook&lt;/i&gt; is a comprehensive collection of problems, solutions, and practical examples for anyone programming in Perl. Topics range from beginner questions to techniques that even the most experienced of Perl programmers will learn from. More than just a collection of tips and tricks, the &lt;i&gt;Perl Cookbook&lt;/i&gt; is the long-awaited companion volume to Programming Perl, filled with previously unpublished Perl arcana.&lt;p&gt;The &lt;i&gt;Perl Cookbook&lt;/i&gt; contains thousands upon thousands of examples ranging from brief one-liners to complete applications. Covered topic areas spread across nearly four hundred separate "recipes," including:&lt;p&gt;&lt;ul&gt;&lt;li type="disc"&gt;Manipulation of strings, numbers, dates, arrays, and hashes&lt;/li&gt;&lt;li type="disc"&gt;Reading, writing, and updating text and binary files&lt;/li&gt;&lt;li type="disc"&gt;Pattern matching and text substitutions&lt;/li&gt;&lt;li type="disc"&gt;Subroutines, libraries, and modules&lt;/li&gt;&lt;li type="disc"&gt;References, data structures, objects, and classes&lt;/li&gt;&lt;li type="disc"&gt;Signals and exceptions&lt;/li&gt;&lt;li type="disc"&gt;Accessing text, hashes, and SQL databases&lt;/li&gt;&lt;li type="disc"&gt;Screen addressing, menus, and graphical applications&lt;/li&gt;&lt;li type="disc"&gt;Managing other processes&lt;/li&gt;&lt;li type="disc"&gt;Writing secure scripts&lt;/li&gt;&lt;li type="disc"&gt;Client-server programming&lt;/li&gt;&lt;li type="disc"&gt;Internet applications programming with mail, news, ftp, and telnet&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;These recipes were rigorously reviewed by scores of the best minds inside and outside Perl, foremost of which was Larry Wall, the creator of Perl himself.&lt;p&gt;The &lt;i&gt;Perl Cookbook&lt;/i&gt; is written by Tom Christiansen, Perl evangelist  and coauthor of the bestselling &lt;i&gt;Programming Perl&lt;/i&gt; and &lt;i&gt;Learning Perl&lt;/i&gt;;  and Nathan Torkington, Perl trainer and co-maintainer of the Perl  Frequently Asked Questions list.</Content></EditorialReview></EditorialReviews></Item></Items></ItemLookupResponse>	http://ec1.images-amazon.com/images/P/1565922433.01._SCMZZZZZZZ_.jpg
\.


--
-- Data for Name: games; Type: TABLE DATA; Schema: public; Owner: chckens
--

COPY games (id, name, connect) FROM stdin;
1	Counter-Strike Source	games.sucs.org:27015
3	Unreal Tournament 2004	games.sucs.org:7777
4	Unreal Tournament	games.sucs.org:17777
5	Armagetron Advanced	games.sucs.org:4534
2	Half-Life 2: Deathmatch	games.sucs.org:27016
\.


--
-- Data for Name: menu; Type: TABLE DATA; Schema: public; Owner: dez
--

COPY menu (id, title, parent, menuorder, target, title_cy, permission) FROM stdin;
16	Community	\N	4	/Community	Pobl	\N
24	FAQ	22	1	/Knowledge/FAQ	\N	\N
22	Knowledge	\N	6	/Knowledge	\N	\N
6	Regulations	3	\N	/About/Regulations	\N	\N
3	About	\N	2	/About	Gwybodaeth	\N
7	Donations	3	\N	/About/Donations	\N	\N
17	History	3	4	/About/History	Hanes	\N
15	Games	\N	5	/Games	Gêmau	\N
8	Tools	\N	3	/Tools	Gwasanaethaud	users
27	Help	22	2	/Help	\N	\N
28	Articles	22	3	/Knowledge/Articles	\N	\N
9	Library	22	\N	/Knowledge/Library	Llyfrgell	\N
2	News	\N	1	/News/	Newyddion	\N
21	Joining	3	1	/About/Joining	Ymunwch	\N
18	Staff	3	3	/About/Staff	Staff	\N
12	Room	3	2	/About/Room	Ystafell	\N
10	Mailing Lists	8	1	http://sucs.org/mailman/listinfo	Rhestri Ebost	\N
11	Web Mail	8	3	https://sucs.org/webmail/	Ebost Gwe	\N
30	ShortURI	8	2	/Tools/ShortURI	\N	\N
31	PasteBin	8	4	/Tools/PasteBin	\N	\N
13	Milliways	16	3	/Community/Milliways	Milliways	\N
26	Shop	16	5	/Community/Shop	Shop	\N
29	Planet	16	6	/Community/Planet	\N	\N
25	Bananas	16	7	/Community/Bananas	\N	\N
32	Forum	16	4	/Community/Forum/	\N	\N
19	Members	16	1	/Community/Members	Aelodau	\N
20	Societies	16	2	/Community/Societies	Cymdeithasau	\N
33	Desktop on Demand	8	5	/Tools/Desktop on Demand	\N	\N
34	Projects	16	8	/Community/Projects	\N	\N
\.


--
-- Data for Name: news; Type: TABLE DATA; Schema: public; Owner: chckens
--

COPY news (id, title, body, date, category, sticky, author) FROM stdin;
4	Welcome to the new SUCS website	<p>As existing members will have noticed, we have created a new visual identity to go with the new SUCS logo.&nbsp; At the same time, we&#39;ve taken the opportunity to reorganise the structure of the site and introduce some new features.<br /></p><p>You can now log onto the site using your SUCS username and password. It will always submit your details securely using HTTPS even if you enter your details on a page that wasn&#39;t loaded securely. Some tools (e.g. WebMail) still require you to log into them separately, but our long term aim is to allow you to log in once to access all the web-based tools SUCS offers. </p>	2006-09-18 15:50:56	\N	t	dez
5	Jabber server back up	<p>SUCS&#39; Jabber server is back up (for the technically minded, we&#39;re now using Ejabberd).</p><p>There are a few changes you need to be aware of:</p><ul><li>You now need to log in using<strong> TLS</strong>, <strong>plain text auth</strong>,&nbsp; and <strong>your SUCS username and password</strong>.</li><li>All members can connect now - there&#39;s no need to register.</li><li>Account registration is disabled. Hence, only members can log in now.</li></ul>Happy chatting!<br />	2006-09-25 19:55:43	\N	t	pwb
\.


--
-- Data for Name: pagemap; Type: TABLE DATA; Schema: public; Owner: arthur
--

COPY pagemap (id, path, depth, component) FROM stdin;
3	/News	2	news
4	/*	1	static
1	/	0	front
5	/Community/Milliways	4	milliways
2	/Community/Bananas	4	bananas
10	/Debug	2	debug
8	/Games	2	games
11	/Admin/Pagemap	4	pagemap
12	/Knowledge/Articles	4	contents
6	/Knowledge/Library	4	library
13	/fragments	2	contents
14	/Tools/ShortURI	4	uri
7	/Knowledge/Help	2	contents
9	/Community/Shop	2	shop
15	/Games/*	3	static
17	/Tools/PasteBin	4	pastebin
16	/Community/Forum	4	forum
18	/Community/Projects	2	projects
19	/signup	2	signup
\.


--
-- Data for Name: pastebin; Type: TABLE DATA; Schema: public; Owner: dez
--

COPY pastebin (id, created, username, code, highlighted_code, "language", retain_til) FROM stdin;
1	2006-09-24 09:35:42.765306	dez	Test	Test	NONE	2006-09-25 09:35:42+01
2	2006-09-24 09:38:24.842521	dez	&lt;html&gt;\r\n&lt;head&gt;\r\n    &lt;title&gt;Foo&lt;/title&gt;\r\n&lt;/head&gt;\r\n&lt;body&gt;\r\nBar\r\n&lt;/body&gt;\r\n&lt;/html&gt;	<ol class="hl-main"><li>&nbsp;<span class="hl-brackets">&lt;</span><span class="hl-reserved">html</span><span class="hl-brackets">&gt;</span><span class="hl-code"></span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-brackets">&lt;</span><span class="hl-reserved">head</span><span class="hl-brackets">&gt;</span><span class="hl-code"></span></li>\n<li>&nbsp;<span class="hl-code">&nbsp; &nbsp; </span><span class="hl-brackets">&lt;</span><span class="hl-reserved">title</span><span class="hl-brackets">&gt;</span><span class="hl-code">Foo</span><span class="hl-brackets">&lt;/</span><span class="hl-reserved">title</span><span class="hl-brackets">&gt;</span><span class="hl-code"></span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-brackets">&lt;/</span><span class="hl-reserved">head</span><span class="hl-brackets">&gt;</span><span class="hl-code"></span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-brackets">&lt;</span><span class="hl-reserved">body</span><span class="hl-brackets">&gt;</span><span class="hl-code"></span></li>\n<li>&nbsp;<span class="hl-code">Bar</span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-brackets">&lt;/</span><span class="hl-reserved">body</span><span class="hl-brackets">&gt;</span><span class="hl-code"></span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-brackets">&lt;/</span><span class="hl-reserved">html</span><span class="hl-brackets">&gt;</span></li></ol>	HTML	2006-09-25 09:38:24+01
3	2006-09-24 10:08:09.284857	chckens	&lt;?php\r\n\r\nwhile (true) {\r\n    echo &quot;chicken\\n&quot;;\r\n}\r\n\r\n?&gt;	<ol class="hl-main"><li>&nbsp;<span class="hl-inlinetags">&lt;?php</span><span class="hl-code"></span></li>\n<li>&nbsp;<span class="hl-code"> </span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-reserved">while</span><span class="hl-code"> </span><span class="hl-brackets">(</span><span class="hl-reserved">true</span><span class="hl-brackets">)</span><span class="hl-code"> </span><span class="hl-brackets">{</span><span class="hl-code"></span></li>\n<li>&nbsp;<span class="hl-code">&nbsp; &nbsp; </span><span class="hl-reserved">echo</span><span class="hl-code"> </span><span class="hl-quotes">&quot;</span><span class="hl-string">chicken</span><span class="hl-special">\\n</span><span class="hl-quotes">&quot;</span><span class="hl-code">;</span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-brackets">}</span><span class="hl-code"></span></li>\n<li>&nbsp;<span class="hl-code"> </span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-inlinetags">?&gt;</span></li></ol>	PHP	2006-09-25 10:08:09+01
4	2006-09-24 11:23:13.978692	chckens	audit(1159018254.463:141): avc:  denied  { getattr } for  pid=13769 comm=&quot;httpd&quot; name=&quot;forum.php&quot; dev=sdb3 ino=14240166 scontext=system_u:system_r:httpd_t:s0 tcontext=user_u:object_r:user_home_t:s0 tclass=file\r\naudit(1159018254.463:142): avc:  denied  { read } for  pid=13769 comm=&quot;httpd&quot; name=&quot;forum.php&quot; dev=sdb3 ino=14240166 scontext=system_u:system_r:httpd_t:s0 tcontext=user_u:object_r:user_home_t:s0 tclass=file	audit(1159018254.463:141): avc:  denied  { getattr } for  pid=13769 comm="httpd" name="forum.php" dev=sdb3 ino=14240166 scontext=system_u:system_r:httpd_t:s0 tcontext=user_u:object_r:user_home_t:s0 tclass=file\r\naudit(1159018254.463:142): avc:  denied  { read } for  pid=13769 comm="httpd" name="forum.php" dev=sdb3 ino=14240166 scontext=system_u:system_r:httpd_t:s0 tcontext=user_u:object_r:user_home_t:s0 tclass=file	NONE	2006-09-25 11:23:13+01
5	2006-09-24 15:15:18.632306	aeternus	#include&lt;stdio.h&gt;\r\n\r\nint main (char* args) {\r\n    printf(&quot;Testing&quot;);\r\n}	<ol class="hl-main"><li>&nbsp;<span class="hl-prepro">#include</span><span class="hl-quotes">&lt;</span><span class="hl-string">stdio.h</span><span class="hl-quotes">&gt;</span><span class="hl-prepro"></span><span class="hl-code"></span></li>\n<li>&nbsp;<span class="hl-code"> </span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-types">int</span><span class="hl-code"> </span><span class="hl-identifier">main</span><span class="hl-code"> </span><span class="hl-brackets">(</span><span class="hl-types">char</span><span class="hl-code">* </span><span class="hl-identifier">args</span><span class="hl-brackets">)</span><span class="hl-code"> </span><span class="hl-brackets">{</span><span class="hl-code"></span></li>\n<li>&nbsp;<span class="hl-code">&nbsp; &nbsp; </span><span class="hl-identifier">printf</span><span class="hl-brackets">(</span><span class="hl-quotes">&quot;</span><span class="hl-string">Testing</span><span class="hl-quotes">&quot;</span><span class="hl-brackets">)</span><span class="hl-code">;</span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-brackets">}</span></li></ol>	CPP	2006-09-25 15:15:18+01
6	2006-09-24 15:17:26.344165	welshbyte	#include &lt;sucs&gt;\r\n\r\nint main(void) {\r\n    printf(&quot;Hello SUCS\\n&quot;);\r\n    return 0;\r\n}	<ol class="hl-main"><li>&nbsp;<span class="hl-prepro">#include </span><span class="hl-quotes">&lt;</span><span class="hl-string">sucs</span><span class="hl-quotes">&gt;</span><span class="hl-prepro"></span><span class="hl-code"></span></li>\n<li>&nbsp;<span class="hl-code"> </span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-types">int</span><span class="hl-code"> </span><span class="hl-identifier">main</span><span class="hl-brackets">(</span><span class="hl-types">void</span><span class="hl-brackets">)</span><span class="hl-code"> </span><span class="hl-brackets">{</span><span class="hl-code"></span></li>\n<li>&nbsp;<span class="hl-code">&nbsp; &nbsp; </span><span class="hl-identifier">printf</span><span class="hl-brackets">(</span><span class="hl-quotes">&quot;</span><span class="hl-string">Hello SUCS</span><span class="hl-special">\\</span><span class="hl-string">n</span><span class="hl-quotes">&quot;</span><span class="hl-brackets">)</span><span class="hl-code">;</span></li>\n<li>&nbsp;<span class="hl-code">&nbsp; &nbsp; </span><span class="hl-reserved">return</span><span class="hl-code"> </span><span class="hl-number">0</span><span class="hl-code">;</span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-brackets">}</span></li></ol>	CPP	2006-09-25 15:17:26+01
7	2006-09-24 15:20:03.370071	dez	test	test	NONE	2006-09-25 15:20:03+01
8	2006-09-24 15:22:31.351621	dez	test some more	test some more	NONE	2006-09-25 15:22:31+01
9	2006-09-24 15:52:53.36174	aeternus	&lt;?php\r\n$test = &quot;cheese&quot;:\r\necho $test;\r\n?&gt;	<ol class="hl-main"><li>&nbsp;<span class="hl-inlinetags">&lt;?php</span><span class="hl-code"></span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-var">$test</span><span class="hl-code"> = </span><span class="hl-quotes">&quot;</span><span class="hl-string">cheese</span><span class="hl-quotes">&quot;</span><span class="hl-code">:</span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-reserved">echo</span><span class="hl-code"> </span><span class="hl-var">$test</span><span class="hl-code">;</span></li>\n<li>&nbsp;<span class="hl-code"></span><span class="hl-inlinetags">?&gt;</span></li></ol>	PHP	2006-09-25 15:52:53+01
10	2006-09-24 21:06:00.927663	frosty	Error validating server certificate for 'https://sucs.org:443':\r\n - The certificate is not issued by a trusted authority. Use the\r\n   fingerprint to validate the certificate manually!\r\n - The certificate hostname does not match.\r\nCertificate information:\r\n - Hostname: localhost.localdomain\r\n - Valid: from Apr 28 17:42:28 2006 GMT until Apr 28 17:42:28 2007 GMT\r\n - Issuer: SomeOrganizationalUnit, SomeOrganization, SomeCity, SomeState, --\r\n - Fingerprint: 38:bc:74:68:2b:39:ef:30:d5:4b:c1:6f:ec:a8:5c:62:b5:c0:3b:ee\r\n(R)eject, accept (t)emporarily or accept (p)ermanently? p\r\nAuthentication realm: &lt;https://sucs.org:443&gt; SUCS Members CD Project Area\r\nPassword for 'frosty': \r\nAuthentication realm: &lt;https://sucs.org:443&gt; SUCS Members CD Project Area\r\nUsername: frosty\r\nPassword for 'frosty': \r\nAuthentication realm: &lt;https://sucs.org:443&gt; SUCS Members CD Project Area\r\nUsername: 	Error validating server certificate for 'https://sucs.org:443':\r\n - The certificate is not issued by a trusted authority. Use the\r\n   fingerprint to validate the certificate manually!\r\n - The certificate hostname does not match.\r\nCertificate information:\r\n - Hostname: localhost.localdomain\r\n - Valid: from Apr 28 17:42:28 2006 GMT until Apr 28 17:42:28 2007 GMT\r\n - Issuer: SomeOrganizationalUnit, SomeOrganization, SomeCity, SomeState, --\r\n - Fingerprint: 38:bc:74:68:2b:39:ef:30:d5:4b:c1:6f:ec:a8:5c:62:b5:c0:3b:ee\r\n(R)eject, accept (t)emporarily or accept (p)ermanently? p\r\nAuthentication realm: <https://sucs.org:443> SUCS Members CD Project Area\r\nPassword for 'frosty': \r\nAuthentication realm: <https://sucs.org:443> SUCS Members CD Project Area\r\nUsername: frosty\r\nPassword for 'frosty': \r\nAuthentication realm: <https://sucs.org:443> SUCS Members CD Project Area\r\nUsername: 	NONE	2006-09-25 21:06:00+01
11	2006-09-24 21:28:41.511804	dez	\t\tError validating server certificate for 'https://sucs.org:443':\r\n - The certificate is not issued by a trusted authority. Use the\r\n   fingerprint to validate the certificate manually!\r\n - The certificate hostname does not match.\r\nCertificate information:\r\n - Hostname: localhost.localdomain\r\n - Valid: from Apr 28 17:42:28 2006 GMT until Apr 28 17:42:28 2007 GMT\r\n - Issuer: SomeOrganizationalUnit, SomeOrganization, SomeCity, SomeState, --\r\n - Fingerprint: 38:bc:74:68:2b:39:ef:30:d5:4b:c1:6f:ec:a8:5c:62:b5:c0:3b:ee\r\n(R)eject, accept (t)emporarily or accept (p)ermanently? p\r\nAuthentication realm: &lt;https://sucs.org:443&gt; SUCS Members CD Project Area\r\nPassword for 'frosty': \r\nAuthentication realm: &lt;https://sucs.org:443&gt; SUCS Members CD Project Area\r\nUsername: frosty\r\nPassword for 'frosty': \r\nAuthentication realm: &lt;https://sucs.org:443&gt; SUCS Members CD Project Area\r\nUsername: 	<ol class="hl-main"><li>&nbsp;<span class="hl-code">&nbsp; &nbsp; &nbsp; &nbsp; Error validating server certificate for 'https://sucs.org:443':</span></li>\n<li>&nbsp;<span class="hl-code"> - The certificate is not issued by a trusted authority. Use the</span></li>\n<li>&nbsp;<span class="hl-code">&nbsp;  fingerprint to validate the certificate manually!</span></li>\n<li>&nbsp;<span class="hl-code"> - The certificate hostname does not match.</span></li>\n<li>&nbsp;<span class="hl-code">Certificate information:</span></li>\n<li>&nbsp;<span class="hl-code"> - Hostname: localhost.localdomain</span></li>\n<li>&nbsp;<span class="hl-code"> - Valid: from Apr 28 17:42:28 2006 GMT until Apr 28 17:42:28 2007 GMT</span></li>\n<li>&nbsp;<span class="hl-code"> - Issuer: SomeOrganizationalUnit, SomeOrganization, SomeCity, SomeState, --</span></li>\n<li>&nbsp;<span class="hl-code"> - Fingerprint: 38:bc:74:68:2b:39:ef:30:d5:4b:c1:6f:ec:a8:5c:62:b5:c0:3b:ee</span></li>\n<li>&nbsp;<span class="hl-code">(R)eject, accept (t)emporarily or accept (p)ermanently? p</span></li>\n<li>&nbsp;<span class="hl-code">Authentication realm: &lt;https://sucs.org:443&gt; SUCS Members CD Project Area</span></li>\n<li>&nbsp;<span class="hl-code">Password for 'frosty': </span></li>\n<li>&nbsp;<span class="hl-code">Authentication realm: &lt;https://sucs.org:443&gt; SUCS Members CD Project Area</span></li>\n<li>&nbsp;<span class="hl-code">Username: frosty</span></li>\n<li>&nbsp;<span class="hl-code">Password for 'frosty': </span></li>\n<li>&nbsp;<span class="hl-code">Authentication realm: &lt;https://sucs.org:443&gt; SUCS Members CD Project Area</span></li>\n<li>&nbsp;<span class="hl-code">Username:</span></li></ol>	NONE	2006-09-25 21:28:41+01
\.


--
-- Data for Name: redirect; Type: TABLE DATA; Schema: public; Owner: dez
--

COPY redirect (id, from_uri, to_uri) FROM stdin;
1	/uri	/Tools/ShortURI
2	/help	/Knowledge/Help
3	/Help	/Knowledge/Help
4	/games	/Games
5	/news	/News
6	/about	/About
7	/wiki	/Knowledge/Help
8	/join	/About/Joining
9	/shop	/Community/Shop
10	/Shop	/Community/Shop
11	/pb	/Tools/PasteBin
12	/forum	/Community/Forum/
13	/punbb	/Community/Forum/
14	/planet	/Community/Planet
15	/info	/About
16	/services	/Tools
17	/people	/Community
18	/signup.php	/signup
\.


--
-- Data for Name: session; Type: TABLE DATA; Schema: public; Owner: arthur
--

COPY "session" (hash, username, "time", data, ip) FROM stdin;
e381f45795eaa1e0f9401d19af012dfc	\N	2006-09-25 16:30:00	s:0:"";	72.30.111.88
bd975112ede31515dd388e6293be11c7	\N	2006-09-25 16:30:01	s:0:"";	72.30.107.134
2bb07bebcdd96cff85809455cff488f3	\N	2006-09-25 16:30:12	s:0:"";	137.44.10.1
f7f29d8ef2a0040f84ec1b5a18bf61cd	\N	2006-09-25 16:30:17	s:0:"";	59.57.43.124
45c84e6278ae645dbcc7d473e9f6cd71	\N	2006-09-25 16:32:04	s:0:"";	65.214.44.184
075f74b98b51886dfe77fc6c63fa06d3	\N	2006-09-25 16:34:30	s:0:"";	80.176.183.202
2e351426024cbd6e2924b4c07714b6a6	\N	2006-09-25 16:35:18	s:0:"";	80.176.183.202
ad2d5d989ebb4522a9f23b8b85336169	\N	2006-09-25 16:36:30	s:0:"";	213.105.224.13
e9470ec687ac219c001b01c654faa011	\N	2006-09-25 16:36:37	s:0:"";	200.43.60.66
1b05c6d942d14dd568a258021250ffde	\N	2006-09-25 16:36:46	s:0:"";	65.214.44.184
55fadba59882f15a704351f95027e566	\N	2006-09-25 16:37:12	s:0:"";	80.176.183.202
7e51eda8299ac525249c1bfa926f8f0a	\N	2006-09-25 16:38:32	s:0:"";	66.249.65.163
fd04f889048daff805cfceb8b03520e9	art	2006-09-25 16:39:07	s:0:"";	172.207.162.239
a3a8d651808b417c5e3694c0e6d11e54	\N	2006-09-25 16:41:31	s:0:"";	72.30.226.160
221a39167348da08ab3b09badd3ee50c	\N	2006-09-25 16:41:32	s:0:"";	72.30.226.160
f5a3246abebc2618638aff0d8099d135	\N	2006-09-25 16:42:14	s:0:"";	72.14.199.65
c2acc972a13e184f2698629722fcedba	\N	2006-09-25 16:44:48	s:0:"";	200.43.60.66
c98da350eb6fdcf494fc2f369a83ad0e	\N	2006-09-25 16:44:51	s:0:"";	172.207.162.239
a5bba1a34f3257d764188150aacb7766	\N	2006-09-25 16:45:32	s:0:"";	72.30.133.144
a72d34e86885485950910c8abeeb4633	\N	2006-09-25 16:45:33	s:0:"";	72.30.110.143
4974b497901d91b13fd50e8543d9c1f3	\N	2006-09-25 16:45:34	s:0:"";	72.30.110.143
3f23de795acd8886c36656c11443bb0e	\N	2006-09-25 16:48:20	s:0:"";	221.14.132.171
2d0325beffe444c9aa24ceb42d405018	\N	2006-09-25 16:48:58	s:0:"";	72.30.252.167
d32e70c7b16d8d206786bff60d879d8f	\N	2006-09-25 16:49:50	s:0:"";	207.46.98.116
53e7cbc6de6e0ad9058a73236f66aa6f	\N	2006-09-25 16:51:11	s:0:"";	213.46.64.170
c36ae15197f92ab6977b1621f8f1bf50	\N	2006-09-25 16:56:58	s:0:"";	65.55.235.165
92a0701ed5258c5b6c7cd9cf0f3a9918	\N	2006-09-25 16:56:59	s:0:"";	65.55.235.165
96d03b3db4fade5a22735dcf59340dd4	\N	2006-09-25 16:57:07	s:0:"";	72.30.129.137
4f6aac362bd204253d20fe45e37c697d	\N	2006-09-25 16:58:25	s:0:"";	65.54.188.99
60e5362e3168cdff9a95b19ab8c0edfe	\N	2006-09-25 17:00:02	s:0:"";	74.6.76.22
eda68466e531d1009bccad5ac00aac95	\N	2006-09-25 17:00:11	s:0:"";	137.44.10.1
e25c01860697642bf006c3f7b8a94d04	\N	2006-09-25 17:00:11	s:0:"";	213.105.224.13
ccb54b08cb11821f03cf0910b017db9e	\N	2006-09-25 17:00:21	s:0:"";	59.57.43.124
76b8844328432223ca26d9300203be16	\N	2006-09-25 17:01:41	s:0:"";	72.30.128.209
6d7d14fed9967ed0a66e2bfe0773269d	\N	2006-09-25 17:03:21	s:0:"";	69.113.211.250
999a205e1b5caa512fa300db05fe9a86	\N	2006-09-25 17:06:13	s:0:"";	213.105.224.13
54096b6800533df03cff531da209abb4	\N	2006-09-25 17:07:10	s:0:"";	72.30.103.150
22106b58d7406a7c309824644b9f0823	\N	2006-09-25 17:08:55	\N	202.108.11.108
e68787726b08ea7828ed9b027c4a381a	\N	2006-09-25 17:14:09	s:0:"";	65.214.44.184
029228308f1fff1229d15da124568a28	\N	2006-09-25 17:16:37	s:0:"";	72.30.133.144
c226e772b2b8f17b9078c07473188f1e	\N	2006-09-25 17:16:40	s:0:"";	65.54.188.98
d8acadf0ca61dee9c2e5a161be3173b6	\N	2006-09-25 17:16:47	s:0:"";	74.6.74.163
e7c464fa7db7c1fe040c205eb8a891c5	\N	2006-09-25 17:17:00	s:0:"";	65.54.188.98
5179c2fd9f8b80dfb96a33c7380830be	\N	2006-09-25 17:17:06	s:0:"";	65.214.44.199
9c871cea34ff04ac599cddbbd64c0b76	\N	2006-09-25 17:17:35	s:0:"";	202.160.180.200
576387b7f9e3e632363e9a59e3269fa8	\N	2006-09-25 17:18:30	s:0:"";	65.214.44.29
4996769e322d937a5d82114246eeccb9	\N	2006-09-25 17:18:30	\N	65.214.44.29
874af249619fc866156710eb5b827694	\N	2006-09-25 17:18:33	s:0:"";	65.214.44.29
a85761a4ebcf189c2ce4470a7d044339	\N	2006-09-25 17:18:33	\N	65.214.44.29
3741169ccb38d451e97679b03b013dcd	\N	2006-09-25 17:18:42	s:0:"";	72.30.129.105
e2e4ac64bdf8583edc9cea1aae342ec5	\N	2006-09-25 17:18:47	s:0:"";	194.36.240.11
18ab0625a03562b75950a774cc3a7039	\N	2006-09-25 17:18:50	s:0:"";	65.214.44.184
01c277f44601b3a4867d453fc0cf5d15	\N	2006-09-25 17:19:55	s:0:"";	65.214.44.199
6d8bd2478586160f8490f5e2df7d6109	\N	2006-09-25 17:21:45	s:0:"";	63.88.212.164
aeef81e947a7566217362187dd71b57c	\N	2006-09-25 17:22:56	s:0:"";	65.214.44.195
bc000a6f79b6eba0ca35f2551bb9d198	\N	2006-09-25 17:23:28	s:0:"";	65.214.44.195
6ce3d3c9d62b545aef13beecbfc15ed6	\N	2006-09-25 17:23:28	s:0:"";	66.249.65.163
d4e15b3f6ac63b2b59ee55202bc94e67	\N	2006-09-25 17:23:30	s:0:"";	65.214.44.184
e90da1ad80e45be798dda26ac545fa1a	\N	2006-09-25 17:24:46	s:0:"";	137.44.10.6
bbbadb7f1040bd9bf37fa3ed5e3510af	\N	2006-09-25 17:26:06	s:0:"";	202.108.11.106
5c3e07a0412a59bf7289095bfae06495	\N	2006-09-25 17:27:12	s:0:"";	72.30.128.220
a5fc62c0c0a347e2730ceac7dd149032	\N	2006-09-25 17:27:13	s:0:"";	72.30.128.220
270fd971d45df869f9603a71884d2462	\N	2006-09-25 17:28:00	s:0:"";	207.46.98.115
bdf601cb3b115712384ad596ae2ad64b	\N	2006-09-25 17:28:20	s:0:"";	65.214.44.184
fb57adde7dde11932f8c716ade65a537	\N	2006-09-25 17:28:55	s:0:"";	72.30.111.203
6868105053d84bf16c1b00a9d72a09fb	\N	2006-09-25 17:29:32	s:0:"";	66.249.65.163
03aad91c043c6fd492a9e6c300770099	\N	2006-09-25 17:30:07	s:0:"";	137.44.10.1
da4d9d1f5bbb7b6ea1f04ef60d8b20de	\N	2006-09-25 17:30:18	s:0:"";	59.57.43.124
fd3429d46a5064594bc2d1c0110e4cd2	\N	2006-09-25 17:30:39	s:0:"";	217.43.39.234
bbe2d48a312eed705f3c66f467df18d1	\N	2006-09-25 17:30:41	s:0:"";	72.30.252.147
57f6b02b129860197deca3126977b527	\N	2006-09-25 17:34:52	s:0:"";	72.14.199.65
4ebe529a91f94dbc166ebfbd24c02d62	\N	2006-09-25 17:35:51	s:0:"";	72.14.194.29
0fa1343ff7c06517d121d1ed94964fd1	\N	2006-09-25 17:35:51	s:0:"";	72.14.194.29
4777d426b56349db768725bb1fecd250	\N	2006-09-25 17:36:12	s:0:"";	65.54.188.100
4e2747cf30a735f7c07cb0465835bd3b	\N	2006-09-25 17:36:58	s:0:"";	66.154.102.215
a5a60e484132c3134449a6404e452116	\N	2006-09-25 17:37:28	s:0:"";	212.195.160.71
83d35291310920f8074fa0bebcf7b119	\N	2006-09-25 17:37:35	s:0:"";	65.54.188.100
6095c2dbfe8e19f526b803b93e90f6b1	\N	2006-09-25 17:37:41	s:0:"";	65.214.44.184
9bbbb72bc728c71e03dac3a8a9567c14	\N	2006-09-25 17:40:11	s:0:"";	72.30.252.167
526cd65b7c52b9b825a862d8e0505300	\N	2006-09-25 17:40:14	s:0:"";	74.6.131.198
09ee086088501ce1239570c7deb59c25	\N	2006-09-25 17:40:23	s:0:"";	72.30.107.14
99731c7da1dab7158c6da7383ac05f18	\N	2006-09-25 17:40:24	s:0:"";	72.30.107.14
f7c3aa1f92d1536ab61a5031aebabe4b	\N	2006-09-25 17:42:48	s:0:"";	74.6.131.198
84fea7b4a34a34338d6d6f7875789dd7	rollercow	2006-09-25 17:43:57	s:0:"";	82.0.222.175
4695cc977720b1e8e777636eab3e0602	\N	2006-09-25 17:44:43	s:0:"";	87.80.12.220
fe802c8c40bc1bba19855072ba20eae8	\N	2006-09-25 17:45:29	s:0:"";	213.105.224.13
cb46c83a268450106d5a3f7e8e905f32	\N	2006-09-25 17:45:50	s:0:"";	72.30.129.137
008f0a23f2d5b4d589a491738427fdb5	\N	2006-09-25 17:49:15	s:0:"";	195.93.21.39
a37b197f8d2cb324b9eccfa459b6ae48	\N	2006-09-25 17:51:01	s:0:"";	137.44.10.6
004ca67b6db3a012e70791c824097b1d	\N	2006-09-25 17:51:06	s:0:"";	66.249.65.163
c90bf63a8f61ddf6097c52c57511a51a	\N	2006-09-25 17:51:47	s:0:"";	66.249.65.163
77254042d0530da8d8ad50d8a29a28f6	\N	2006-09-25 17:52:27	s:0:"";	66.249.65.163
e84f3d2bbd5063e5adf0c0eb85dc8dc8	\N	2006-09-25 17:53:08	s:0:"";	66.249.65.163
8893fe9a29a929470e5adf4e16d8bac4	\N	2006-09-25 17:54:15	s:0:"";	137.44.10.30
be4f1d2500041590be86264692840546	\N	2006-09-25 17:54:28	s:0:"";	66.249.65.163
6115ee8cc9a1fe9f41f5f733b1985248	\N	2006-09-25 17:55:09	s:0:"";	66.249.65.163
c9fb9d71b2d1b056f7ee4cb05eb164a2	\N	2006-09-25 17:55:49	s:0:"";	66.249.65.163
6b17c5105da53ea1bb259d200f1d2149	\N	2006-09-25 17:56:30	s:0:"";	66.249.65.163
1a0fd4cf79fcbb2e745e9b3543717315	\N	2006-09-25 17:56:33	s:0:"";	195.93.21.39
6276ebe2edc6cfc6beaddb8ef73d1d3c	\N	2006-09-25 17:57:10	s:0:"";	66.249.65.163
c6f1a681f41da07cf8629aa67a192855	\N	2006-09-25 17:57:14	s:0:"";	217.33.37.234
f545eccbbb65d23b2a7c65dde193407e	\N	2006-09-25 17:57:51	s:0:"";	66.249.65.163
4a62ce698a33d9267c20f6c5a00b65b7	\N	2006-09-25 17:58:31	s:0:"";	66.249.65.163
d743f92b19ed802fdc443dd844c85137	saya	2006-09-25 17:58:50	s:0:"";	137.44.10.36
4c3a7b38210347ff883c9ab7627baf2d	\N	2006-09-25 17:58:53	s:0:"";	72.30.131.209
1d7eca8b62157346b250ee852d2c1c37	\N	2006-09-25 17:58:54	s:0:"";	72.30.131.209
0842d89b9b54baf19381781d133a1d3e	\N	2006-09-25 17:59:02	s:0:"";	172.209.66.215
4db4e3098b10d796d40e5713e5cd6a90	\N	2006-09-25 17:59:03	s:0:"";	172.209.66.215
8458f99851639ced086f7f3f1b61f0de	\N	2006-09-25 17:59:11	s:0:"";	66.249.65.163
968169cc83e2ef5004cb23876fd60792	\N	2006-09-25 17:59:52	s:0:"";	66.249.65.163
6a7c1dfb09e7bf85aa2d1a6357c95a10	\N	2006-09-25 18:00:11	s:0:"";	137.44.10.1
f1a558272a6960e8924aa48fbe09c31d	\N	2006-09-25 18:00:32	s:0:"";	66.249.65.163
860a38d5c5592607d9b8a44e99992048	\N	2006-09-25 18:01:13	s:0:"";	66.249.65.163
27c6f5533ddda2035facfbfa4d08bf37	\N	2006-09-25 18:01:24	s:0:"";	213.105.224.13
4e8371f09b39ac4ca00e3b934197e7a1	\N	2006-09-25 18:01:28	s:0:"";	137.44.10.30
68c0c2c2895a20166a70412670b4fd4c	\N	2006-09-25 18:01:53	s:0:"";	66.249.65.163
80fe7bdc6b7b3882165e21e6a2bae2a0	\N	2006-09-25 18:02:34	s:0:"";	66.249.65.163
59ef162ac5451f3fae0b2b31b2159c3e	\N	2006-09-25 18:02:44	s:0:"";	72.30.128.209
8e47acd2207d24d9625db82c069eab26	\N	2006-09-25 18:03:14	s:0:"";	66.249.65.163
f3f64abad263d0c0713686556161c9ae	\N	2006-09-25 18:03:54	s:0:"";	66.249.65.163
07cb34f2bea8089f7580114ff4a62985	\N	2006-09-25 18:04:06	s:0:"";	85.25.146.46
6290db179cfbadf77a503d533a5734b4	\N	2006-09-25 18:04:35	s:0:"";	66.249.65.163
1aaa0a3e4d7f60b0becb47c608f513cb	\N	2006-09-25 18:05:15	s:0:"";	66.249.65.163
43422ed67f323ee62cd589ce249bbe62	\N	2006-09-25 18:05:44	s:0:"";	66.154.102.57
0256769ec1bdcec6dffbbe3e504d6067	\N	2006-09-25 18:05:56	s:0:"";	66.249.65.163
cda00394284a95c7034d6d9b140d776d	\N	2006-09-25 18:06:16	s:0:"";	66.249.65.163
30ba717db788c0dc6065823ab0303e1a	\N	2006-09-25 18:06:17	s:0:"";	66.249.65.163
a796bc4b9e93f0f90e0820007b36dc08	\N	2006-09-25 18:06:21	s:0:"";	66.154.102.42
cbdc6bdb6f242edcedca0b00c072c50d	\N	2006-09-25 18:06:37	s:0:"";	66.249.65.163
81a059274f09de1dd897ba0162252ada	\N	2006-09-25 18:07:01	s:0:"";	213.105.224.13
51e9db2f57e96d50d0bd09d4552213d4	\N	2006-09-25 18:07:17	s:0:"";	66.249.65.163
3e9203463fa4a9ded40ad47e997247a1	\N	2006-09-25 18:07:37	s:0:"";	65.55.213.60
3aaaad4659a70b207c46c92cb7f8ba0a	\N	2006-09-25 18:07:38	s:0:"";	65.55.213.60
35a1de33945b91162e181c6e05c50cf9	\N	2006-09-25 18:07:39	s:0:"";	72.30.103.150
0bd1e304846c8483ddca2e09d5e4dbfb	\N	2006-09-25 18:07:58	s:0:"";	66.249.65.163
6c3913c88e30fbe345026c7f920b3c3c	\N	2006-09-25 18:09:46	s:0:"";	65.54.188.99
c5f3583b7ee4258d148347c328f2c564	\N	2006-09-25 18:10:03	s:0:"";	148.137.234.7
efc9dcdbf33806acb8c1c647cc7efbcb	\N	2006-09-25 18:11:36	s:0:"";	65.214.44.29
693e839eeb99cdcf5f3422a6d25dc0f9	\N	2006-09-25 18:11:36	s:0:"";	65.214.44.29
693e839eeb99cdcf5f3422a6d25dc0f9	\N	2006-09-25 18:11:36	s:0:"";	65.214.44.29
2b2851463a5ad9a98aaf4cbd12199d56	\N	2006-09-25 18:11:37	\N	65.214.44.29
77ddf17f30d762981fd46d7f3181ca00	\N	2006-09-25 18:12:51	s:0:"";	60.181.244.221
f0f099f24d87d71075db09c8d340b027	\N	2006-09-25 18:12:55	s:0:"";	87.106.3.38
e196a5e0ba35b217aecad749eab1a838	\N	2006-09-25 18:13:43	s:0:"";	81.210.186.47
11f433ec99b73fa38706c1515daf21f7	\N	2006-09-25 18:14:47	s:0:"";	83.104.48.218
4a7dc4cb76fc1d76f915de69bc98398d	\N	2006-09-25 18:15:12	s:0:"";	65.54.188.100
63b1dea250b8cabf3b4ff333397a9ce2	\N	2006-09-25 18:16:21	s:0:"";	65.54.188.100
73834395ddc4bb8a5e8a01053b8611b0	\N	2006-09-25 18:17:18	s:0:"";	65.54.188.100
4d016826abffd00cf947cbd89d431ff9	\N	2006-09-25 18:17:27	s:0:"";	65.54.188.98
d65a4468f54ae3059feef35c08b223ae	\N	2006-09-25 18:17:32	s:0:"";	65.54.188.99
3034ca7e9a2cb0964f79c4d2210d5096	\N	2006-09-25 18:18:18	s:0:"";	213.105.224.13
073b45056bfbf6f58278e8face3bedf7	\N	2006-09-25 18:18:56	s:0:"";	65.54.188.98
c4118dbc049240f89ab66c63deea3e21	\N	2006-09-25 18:23:42	\N	202.108.11.108
8614eb307bf65e3af5b1b2f31eb444a6	\N	2006-09-25 18:24:35	s:0:"";	66.249.65.163
c10b7bfdfdc0e3a2e38ea4bd0a831fa0	\N	2006-09-25 18:26:06	s:0:"";	72.30.128.209
548c00958f9af93824d421317faa8688	\N	2006-09-25 18:26:17	s:0:"";	202.108.11.106
5d669bd798bf0b25be08b7fae8fd497f	\N	2006-09-25 18:27:49	s:0:"";	72.30.129.105
68bd5473166453705a949b92d9ea19e0	\N	2006-09-25 18:27:54	s:0:"";	202.160.178.215
16c07d637bafff7d4533f8f361178057	\N	2006-09-25 18:30:06	s:0:"";	137.44.10.1
66e207dfe424bbabb807c1845f95e078	\N	2006-09-25 18:32:21	s:0:"";	221.14.132.171
b6f9334e3f1766b91f527831f71b583a	\N	2006-09-25 18:33:53	s:0:"";	207.46.98.117
f66b60d50f6778bedd121c4f0fd58232	\N	2006-09-25 18:38:47	s:0:"";	72.30.128.221
444193162469c59a0e1f61a5b36f55ce	\N	2006-09-25 18:41:03	s:0:"";	65.214.44.29
56f54da4dfbce612f85e07e2eca54da7	\N	2006-09-25 18:41:03	\N	65.214.44.29
8ae8d236a776a3b3e1444b32cf95b86a	\N	2006-09-25 18:41:26	s:0:"";	213.105.224.13
348bf6e76c079eff755a50eaa3620ea9	\N	2006-09-25 18:42:16	s:0:"";	65.55.213.60
af2a19064d00120e01ae0925617377de	\N	2006-09-25 18:43:23	s:0:"";	202.160.180.200
9cd0ac84627dab094380b8bb5aff08b3	\N	2006-09-25 18:44:30	s:0:"";	140.123.101.67
2418abd4458c34d1c8fa5a0c44edb6ed	\N	2006-09-25 18:44:53	s:0:"";	65.55.213.60
203ac57664676f80c896970c7e923f47	\N	2006-09-25 18:46:27	s:0:"";	72.30.129.31
a8275b6d94e199635efd49e6c7e9e60d	\N	2006-09-25 18:46:48	s:0:"";	72.30.129.31
36f467c89e3953f25fa35c39e28bfc52	\N	2006-09-25 18:47:20	s:0:"";	72.30.252.167
e97eb141b609b63c133985ceafddd17e	\N	2006-09-25 18:49:53	s:0:"";	65.54.188.98
25ea7feccd7527300728750f682adf69	\N	2006-09-25 18:51:20	s:0:"";	204.185.8.244
ca2cc7dc335fba8b387866e814a79806	\N	2006-09-25 18:52:38	s:0:"";	82.152.112.137
f7d35888f930429ccb1789d815bcc90a	\N	2006-09-25 18:52:53	s:0:"";	66.249.65.163
e77363887311b08290a1026079325b85	\N	2006-09-25 18:54:41	s:0:"";	207.46.98.114
61dcfed80efe9f061bc562a7b73c6dbf	saya	2006-09-25 18:57:42	s:0:"";	81.96.205.21
6095b9ab27f06e03bd951606a2a2dbef	\N	2006-09-25 18:57:49	s:0:"";	207.46.98.89
29609953c856bc9279301a8baa3a46ef	\N	2006-09-25 18:58:09	s:0:"";	66.249.65.163
a85b60f80e52d3d45530880814306779	\N	2006-09-25 19:00:14	s:0:"";	207.46.98.114
4adfe63cb10fc9ac261c73a58bab521d	\N	2006-09-25 19:00:24	s:0:"";	66.249.65.163
889d9ece180f6d6c801512ed42465224	\N	2006-09-25 19:00:31	s:0:"";	137.44.10.1
6f87f58de639d62fb80d45b79c4dc6e6	\N	2006-09-25 19:01:29	s:0:"";	65.214.44.184
f34c1fa8eb4009652a2e43f3a613df9a	\N	2006-09-25 19:03:17	s:0:"";	202.160.180.44
802773d404bebd5c091c2cae5ec186e6	\N	2006-09-25 19:03:19	s:0:"";	202.160.179.89
f9989e81190d2a5bc8ef38e7b9fcf34c	\N	2006-09-25 19:03:26	s:0:"";	66.249.65.163
0ef18c12dc455ff122b204476b1124b7	\N	2006-09-25 19:05:22	s:0:"";	72.30.129.155
6f15a46bb5bf6ae3086d275f6ef35b94	\N	2006-09-25 19:05:23	s:0:"";	72.30.129.155
04623e00eb27bb03f0da84c93fb5ceb3	\N	2006-09-25 19:07:34	s:0:"";	66.154.102.42
77d77beb1155f0ac9828debbe653aa36	\N	2006-09-25 19:07:35	s:0:"";	66.154.103.158
ca8120d939bdd8223c4711afd9ad222e	\N	2006-09-25 19:08:27	s:0:"";	72.30.103.150
62430c301fafa618a9e973873936c5fd	\N	2006-09-25 19:08:43	s:0:"";	66.249.65.163
74f33ba355690f7612acba5358684be3	\N	2006-09-25 19:11:29	s:0:"";	84.70.29.122
0a60f636698c1d7de7f19e9a9fc88537	\N	2006-09-25 19:11:37	s:0:"";	202.160.178.94
bd5ea60a5f2d0f60e3c79232ddfd75fa	\N	2006-09-25 19:11:43	s:0:"";	66.249.65.163
1735aa8534a88d865ce23bf9178f85a7	\N	2006-09-25 19:12:03	s:0:"";	65.54.188.132
093d868e9463c1223f07cfaad3f5f784	\N	2006-09-25 19:13:40	s:0:"";	80.3.96.42
be1cede1d67974529486a091bade627c	\N	2006-09-25 19:16:34	s:0:"";	195.93.21.39
749cd489bd4f09659be6b4e4454321c2	\N	2006-09-25 19:17:54	s:0:"";	213.105.224.13
4054a167a7fa01c676fd4c2fabf94d4d	\N	2006-09-25 19:18:02	s:0:"";	65.214.44.29
77474b6af33018f948e9d43937f15c71	\N	2006-09-25 19:18:02	\N	65.214.44.29
03fb2147262cc4bbcaacc35a62099905	\N	2006-09-25 19:18:04	s:0:"";	65.214.44.29
8dbcf1a4977a34c1fb67ee68ddbf09cd	\N	2006-09-25 19:18:05	\N	65.214.44.29
ee767379946aa8fca55316f57dc3d270	\N	2006-09-25 19:20:10	s:0:"";	64.34.145.198
71204200cb45d889882109fa0a16b1a5	\N	2006-09-25 19:20:10	s:0:"";	64.34.145.198
1397c6012d2ecafb2075e04fb32898cd	\N	2006-09-25 19:22:05	s:0:"";	66.249.65.163
44408d736481b1ea700e792fe49be686	\N	2006-09-25 19:22:23	s:0:"";	65.214.44.117
b8f364100b167be0cb6063c152f334c7	\N	2006-09-25 19:22:40	s:0:"";	65.214.44.117
37a5ee0a573c28efe452c967e0922afd	\N	2006-09-25 19:22:50	s:0:"";	66.249.65.163
4f6868b40b09f12a401e734efef6f28e	\N	2006-09-25 19:23:23	s:0:"";	66.249.65.163
6b9e97cedea4756d74fc1f4113a72404	\N	2006-09-25 19:23:31	s:0:"";	65.54.188.100
7746c500a839b4ebc781f52d4ada0ff1	\N	2006-09-25 19:23:50	s:0:"";	66.249.65.163
5876b93532180ee53412efc060dd6b51	\N	2006-09-25 19:24:16	s:0:"";	66.249.65.163
6075e9c963822a1a7e2e77afeaea9540	\N	2006-09-25 19:24:17	\N	202.108.11.108
d57ebe2f9a5aad3b06dce6f9a9215ce1	\N	2006-09-25 19:24:23	s:0:"";	65.54.188.100
7cd953baeddebaebf69a800a25f1f1ab	\N	2006-09-25 19:24:43	s:0:"";	66.249.65.163
2efeca0d55f258319e1f1e27ef972cb2	\N	2006-09-25 19:25:17	s:0:"";	202.108.11.106
4fc9c2593a01fc6550a4f8926808b387	\N	2006-09-25 19:25:22	s:0:"";	66.249.65.163
a57148f5a3c674c24c42aafa2cbbd9e6	\N	2006-09-25 19:25:44	s:0:"";	207.46.98.88
143efe3dfb967dbb782b616ce2e26429	\N	2006-09-25 19:26:01	s:0:"";	66.249.65.163
b184092da517ba72f6c1bcd70c509510	\N	2006-09-25 19:27:05	s:0:"";	65.54.188.100
ed377b973d20a87b2a49d440c594ca2c	\N	2006-09-25 19:27:18	s:0:"";	66.249.65.163
81e90e9c25506073f8670e5a69fbad40	\N	2006-09-25 19:27:20	s:0:"";	65.54.188.100
95c313e733408dc916a8ff94a8e65594	\N	2006-09-25 19:28:33	s:0:"";	66.196.65.37
0e4271f68067dc4dc7f5930072fffa79	\N	2006-09-25 19:29:02	s:0:"";	66.249.65.163
041590a01a58406005019fb1ccd42bdd	\N	2006-09-25 19:29:29	s:0:"";	66.249.65.163
e62ef227cdc8507e9f9bdd6fff5717cf	\N	2006-09-25 19:29:54	s:0:"";	66.249.65.163
86f34e081c583380c27c912c1774d17e	\N	2006-09-25 19:30:18	s:0:"";	137.44.10.1
dc150fa7d8bf9d85ab3cbea44681333d	\N	2006-09-25 19:30:32	s:0:"";	66.249.65.163
6367b70455edd1bb20d80bb731224335	\N	2006-09-25 19:31:28	s:0:"";	72.30.128.209
c0bc173a63a0b95190df9699a6cd063f	\N	2006-09-25 19:32:15	s:0:"";	66.249.65.163
99966e0152524c6bcba0f90e67de0a3a	\N	2006-09-25 19:32:23	s:0:"";	72.30.252.82
2871fea7d108fee69051a817897528fb	\N	2006-09-25 19:32:54	s:0:"";	66.249.65.163
8135af6cde9cff393f943fe768970a0d	\N	2006-09-25 19:32:55	s:0:"";	72.30.252.82
e418b930d9592d39ea5a042fcd7aed1c	\N	2006-09-25 19:33:05	s:0:"";	87.106.3.38
6960b83605f521dd0219eb1f977a0106	\N	2006-09-25 19:33:05	s:0:"";	87.106.3.38
f737e4ec8757f1b4c9af70437b2c34c5	\N	2006-09-25 19:33:06	s:0:"";	66.155.203.138
9327d47f4d4a3224847ded8e561bccb1	\N	2006-09-25 19:33:32	s:0:"";	213.105.224.13
31c4662ae8a72833b5f221e9cad81690	\N	2006-09-25 19:33:33	\N	66.249.65.163
9cbd81e684e90694574c5bc931590352	\N	2006-09-25 19:33:45	s:0:"";	65.214.44.146
d90b985434c09d2795023022a85fc34c	\N	2006-09-25 19:38:38	s:0:"";	81.103.162.49
3a999723ebc5e0a4d6d5a48e28351a03	sara	2006-09-25 19:39:04	s:0:"";	81.103.162.209
3db18cbba2ed461da775fa6c52433a1d	talyn256	2006-09-25 19:39:52	s:0:"";	81.129.88.210
f40cc27d215e66cf5f881ba678cbb863	\N	2006-09-25 19:39:53	s:0:"";	65.54.188.99
1e367beadf46b0ada90a253a6d88d704	\N	2006-09-25 19:41:13	s:0:"";	72.30.129.137
83ae92e37b19a5a6b2cbbd948f0540d3	\N	2006-09-25 19:42:13	s:0:"";	72.14.199.65
b3938e21ccf17297bb9fd72107a74124	\N	2006-09-25 19:42:14	s:0:"";	65.54.188.100
eecbbd75deee2f00052e50265409f643	\N	2006-09-25 19:42:27	s:0:"";	72.30.226.198
e2fefc0f3c41022c54209d8fa30d38d0	\N	2006-09-25 19:42:27	s:0:"";	72.30.226.198
8efd26c485beb30d7167c1ed2968b2cb	\N	2006-09-25 19:45:05	s:0:"";	66.249.65.163
11e235287e75c6354a04a00da02a90df	\N	2006-09-25 19:47:47	s:0:"";	65.214.44.29
e553b4e1bfefe3d0a03d73a8ac438c11	\N	2006-09-25 19:47:47	s:0:"";	65.214.44.29
d6c11d4886fa82d24d502c9fb4f35ebf	\N	2006-09-25 19:47:48	\N	65.214.44.29
d6c11d4886fa82d24d502c9fb4f35ebf	\N	2006-09-25 19:47:48	\N	65.214.44.29
b0413901fb06c37949138c8d4401d69e	\N	2006-09-25 19:50:15	s:0:"";	72.30.252.167
688f11f598b2d456c04425fdabb6f672	\N	2006-09-25 19:50:16	s:0:"";	72.30.107.80
ca14763b855064993a5ea320b3434e7d	\N	2006-09-25 19:50:59	s:0:"";	72.30.129.105
51835695c09a37bd22c8ff71a9a36612	\N	2006-09-25 19:51:43	s:0:"";	207.46.98.87
51835695c09a37bd22c8ff71a9a36612	\N	2006-09-25 19:51:43	s:0:"";	207.46.98.87
547a42374a8d1631273f8be25a21b32e	\N	2006-09-25 19:51:49	s:0:"";	80.192.150.82
2d502eb30dac3fab53f56d8ddc2f7060	\N	2006-09-25 19:55:48	s:0:"";	72.30.133.144
a2295dc70612c4c127e59fd76a7b701f	\N	2006-09-25 19:57:46	s:0:"";	72.30.110.35
adcb60a478a6a2f1206d06accfc92899	\N	2006-09-25 19:57:47	s:0:"";	72.30.110.35
d0296e98ce11253bf95267650ddcd327	\N	2006-09-25 20:00:23	s:0:"";	137.44.10.1
6c6d14fa2d4787f00a9cd6f7af776e38	\N	2006-09-25 20:02:17	s:0:"";	202.160.180.200
1d32f7877fb96c0d0b86966df84e5f61	\N	2006-09-25 20:07:44	s:0:"";	66.249.65.163
faa19f47550c6cce15e8e85a4af780c5	\N	2006-09-25 20:08:39	s:0:"";	72.30.103.150
c0bb2c416ca040b61941fa1b819ef5ad	\N	2006-09-25 20:08:42	s:0:"";	172.142.31.225
3da04b04a3b7fe2e0d8417b58c8f0c08	\N	2006-09-25 20:08:45	s:0:"";	216.195.21.172
a62b22eb86be7b634590ac17584f91d8	\N	2006-09-25 20:11:07	\N	202.108.11.108
4a796729b281f924b48a0c27600a5b19	\N	2006-09-25 20:12:54	s:0:"";	213.105.224.13
e9e70e162e31a57c7ae4e9ad0285f841	\N	2006-09-25 20:13:34	s:0:"";	60.181.244.221
ee211aeb90340f06a4d528e92bfc2e94	\N	2006-09-25 20:14:24	s:0:"";	207.46.98.116
fc8687f59aca7a70499c109866edeca7	\N	2006-09-25 20:16:10	s:0:"";	202.160.178.238
24ae06d4119e86a9f6cfd92ae9c9e4df	\N	2006-09-25 20:17:04	s:0:"";	65.54.188.100
ae7d1ae0cd108963704dec2767ef273e	\N	2006-09-25 20:17:44	s:0:"";	65.214.44.29
e89f67c4f3757b41225931974dc20df7	\N	2006-09-25 20:17:45	\N	65.214.44.29
20eb4e288e32a8d71c0a3c920bb34bf4	\N	2006-09-25 20:18:09	s:0:"";	209.129.150.14
c45a94fe3b8bcbbd6c5926e018e521ca	\N	2006-09-25 20:18:57	s:0:"";	83.104.48.218
7c4bd6c8939d23eca0f22a79e2b8f944	\N	2006-09-25 20:19:23	s:0:"";	83.104.48.218
a31b9b0baec1876df3257f4012488ad6	\N	2006-09-25 20:19:38	s:0:"";	83.104.48.218
e00a29d6f69205426bced8a25dcb2700	\N	2006-09-25 20:23:00	s:0:"";	24.207.252.185
df62878636ea55df7e7972205fec1f35	\N	2006-09-25 20:25:19	s:0:"";	202.108.11.106
7a3392fd50001cc45f62b965b69353eb	\N	2006-09-25 20:25:28	s:0:"";	142.106.218.85
38b7488f77dd1b6f992bd626e0bfdff7	\N	2006-09-25 20:26:40	s:0:"";	202.160.180.45
d968bc0352e1bec4b961a5b5792f16c4	\N	2006-09-25 20:30:15	s:0:"";	137.44.10.1
c1273e6095ff18e2c593b741c095b223	\N	2006-09-25 20:30:48	s:0:"";	65.54.188.100
d6ceb399e3a47db3ede5f14b6bf545cd	\N	2006-09-25 20:31:25	s:0:"";	86.132.33.125
3487e7291688cab94009755f7f1e8be2	\N	2006-09-25 20:31:28	s:0:"";	72.30.128.209
734fdb128c92efe9cd9a5297868c37e9	\N	2006-09-25 20:31:49	s:0:"";	74.6.131.201
37c69319d836604304c303fc57fb109b	\N	2006-09-25 20:32:42	s:0:"";	81.129.88.210
707909a6d2ab738ac8b76b0e00cdc091	pwb	2006-09-25 20:33:07	s:0:"";	137.44.10.31
ebf958825b791c28c744947750c7740f	\N	2006-09-25 20:34:45	s:0:"";	72.14.199.65
f230a9048266330c10e98cdeb72cc7a6	\N	2006-09-25 20:37:51	s:0:"";	202.160.179.6
8bac809fbf3f3567ef39e761b46642a2	\N	2006-09-25 20:43:03	s:0:"";	72.30.226.142
9c2e0202819e69708b5bbeba82da603f	\N	2006-09-25 20:43:57	s:0:"";	199.216.95.253
3aa25d49957809eeab51349d66b462a8	\N	2006-09-25 20:45:10	s:0:"";	65.0.102.238
84dd915adc7efc084c96733cc818a3df	wedge	2006-09-25 20:45:41	s:0:"";	81.96.205.21
6cd5b6fa9830a74662b58cd95ffb90ff	\N	2006-09-25 20:45:42	s:0:"";	213.105.224.13
a9b3d2a3dd36e65d6bdf8d7b5e089902	\N	2006-09-25 20:46:24	s:0:"";	65.54.188.98
0a8791c8640ad57227e6f9ab67002d62	\N	2006-09-25 20:46:31	s:0:"";	65.214.44.29
a6e69678998fd68e757f08a1d2414cd9	\N	2006-09-25 20:46:32	\N	65.214.44.29
fdacb0c09ec1867d7e2dd5af23b21934	\N	2006-09-25 20:46:33	s:0:"";	65.214.44.29
c3281bf44be0394bfd2627a55328fe4f	\N	2006-09-25 20:46:34	\N	65.214.44.29
7990635c9864a5bbddaa6758e5a75373	\N	2006-09-25 20:48:37	s:0:"";	82.0.222.175
599959d76b8578ade7c8e6a4b14eaf86	\N	2006-09-25 20:48:38	s:0:"";	70.48.41.207
bae28c48bea6466ace7ca3a48ca2ed9d	\N	2006-09-25 20:48:38	s:0:"";	70.48.41.207
c51595963fd066564485e14132d723bd	\N	2006-09-25 20:49:16	s:0:"";	213.105.224.13
6480898b6e1e611cbe35b8ce48f98ae4	dez	2006-09-25 20:51:52	s:0:"";	81.174.227.170
0ad77ec9d9b104c1cbcc5e9eaaf81dd9	\N	2006-09-25 20:53:46	s:0:"";	82.17.79.203
ac9b33209b6536bd64dfc3f1f72839a3	\N	2006-09-25 20:54:30	s:0:"";	72.145.43.235
ce791dedbf4480facc6fafe0a9d6f847	\N	2006-09-25 20:54:43	s:0:"";	207.46.98.89
6d9a012d5f2849c26321b228c7a9e955	\N	2006-09-25 20:54:54	s:0:"";	202.165.107.18
14b74cfaaa503acd8bb9a059fece6e36	\N	2006-09-25 20:59:24	s:0:"";	66.249.65.163
29eefa3c6837494e3b6d14d83e07deee	\N	2006-09-25 21:00:10	s:0:"";	137.44.10.1
2daded11bb97e3827896c47251f7d100	\N	2006-09-25 21:00:22	s:0:"";	66.249.65.163
d2399973605914842dc3b99d09f38973	\N	2006-09-25 21:00:32	s:0:"";	195.27.215.89
e7d2dd483df3cef9b9e7e787e4f6c489	\N	2006-09-25 21:01:23	s:0:"";	66.249.65.163
e7cc08c49efef9ecffe59e0e03401ba1	\N	2006-09-25 21:02:22	\N	66.249.65.163
b8e0b2eaefa78ef987d2341fcc35558d	akyan	2006-09-25 21:05:21	s:0:"";	80.4.13.224
b2c116ff768852ca0402543d9461d5bd	\N	2006-09-25 21:06:39	s:0:"";	202.160.178.238
c54a6c5657efd41199b71e753e4799cb	\N	2006-09-25 21:08:10	s:0:"";	72.149.230.106
b8a042a73f146f800230cbf3171816e2	\N	2006-09-25 21:08:11	s:0:"";	72.149.230.106
1f6128d7c7d1b8ae9d730f21f0dc9235	\N	2006-09-25 21:08:12	s:0:"";	72.149.230.106
69dbf641ea18d6004255a7d7e0be7046	\N	2006-09-25 21:08:13	s:0:"";	72.149.230.106
4a9bee8263aca7c3a857e18c8e14bd45	\N	2006-09-25 21:08:14	s:0:"";	72.149.230.106
fc3351cf2a97ed6d22328c9119064e59	\N	2006-09-25 21:08:15	s:0:"";	72.149.230.106
4b5af224a5a8c7ff2bf69738ad4da389	\N	2006-09-25 21:08:16	s:0:"";	72.149.230.106
5aad946196b00bcb89ff5f05ed535cfa	\N	2006-09-25 21:08:17	s:0:"";	72.149.230.106
671212b73d281520ecdcfaf0028fc31e	\N	2006-09-25 21:08:18	s:0:"";	72.149.230.106
4e54c2fdbe1ef1982df88ec4ca887c96	\N	2006-09-25 21:08:19	s:0:"";	72.149.230.106
ca08337ab37754665c10841cc3a1f81b	\N	2006-09-25 21:08:20	s:0:"";	72.149.230.106
e03338cad642f6f022de9744fee2456a	\N	2006-09-25 21:08:21	s:0:"";	72.149.230.106
4cbdd66d80bec1fcbcd201e4315d0b16	\N	2006-09-25 21:08:22	s:0:"";	72.149.230.106
8d4ce934a28c06e804b2745c612d9027	\N	2006-09-25 21:08:23	s:0:"";	72.149.230.106
ce8ae50902beab4c957d36b8e18cbb32	\N	2006-09-25 21:08:24	s:0:"";	72.149.230.106
3e9053010308ca5d3a80e224e73a5182	\N	2006-09-25 21:08:25	s:0:"";	72.149.230.106
6589b60552411550efefa849fcdda340	\N	2006-09-25 21:08:26	s:0:"";	72.149.230.106
ea434992f883cb06a4d3f9a099b21363	\N	2006-09-25 21:08:27	s:0:"";	72.149.230.106
ec97caeaf81f318ba2dfd4eb2cd0ec75	\N	2006-09-25 21:08:28	s:0:"";	72.149.230.106
1419af22cb18cd9154a99b8162c87901	\N	2006-09-25 21:08:29	s:0:"";	72.149.230.106
8125ff109d2ffa729869283ca990afb7	\N	2006-09-25 21:08:29	s:0:"";	65.214.44.184
d4f9b4bb3c61047fb70555c91c9fe323	\N	2006-09-25 21:08:30	s:0:"";	72.149.230.106
366a21452555d47959dccfa8e198494a	\N	2006-09-25 21:08:31	s:0:"";	72.149.230.106
1c0735cb204e7e4564ccc2403e787454	\N	2006-09-25 21:08:32	s:0:"";	72.149.230.106
ab4146564ce9257f5058938bd95ec810	\N	2006-09-25 21:08:33	s:0:"";	72.149.230.106
e65f078564315f6ed94b981f07c12cd4	\N	2006-09-25 21:08:34	s:0:"";	72.149.230.106
fefe1eb23b30964d397e66ce71f88c83	\N	2006-09-25 21:09:02	s:0:"";	72.149.230.106
f7dd764b515d29f982292716a2542005	\N	2006-09-25 21:09:53	s:0:"";	81.96.205.21
d8806f8ccdd0c75a841a2e2fbfc0f7bf	\N	2006-09-25 21:12:19	s:0:"";	66.249.65.163
512c664350b3595ee08f590cfeb89249	\N	2006-09-25 21:13:42	s:0:"";	213.105.224.13
c88c6b6e7da8f758271ed6ed1b447153	\N	2006-09-25 21:13:43	s:0:"";	65.54.188.99
50434f8bbc18b81ec33edc327f2c70a6	\N	2006-09-25 21:15:40	s:0:"";	81.96.205.21
24ed7a6266a2ae77e6b33b39e7832412	\N	2006-09-25 21:15:51	s:0:"";	207.46.98.114
921b8ef5a73cbbad8c406ee8f08da057	\N	2006-09-25 21:16:03	\N	202.108.11.108
9c3875acf568831bd5e1bca424a1fb88	\N	2006-09-25 21:16:15	s:0:"";	74.6.75.41
a5d50268b585a1ebf2709fd3944f17ac	\N	2006-09-25 21:16:47	s:0:"";	202.160.179.92
cfe52d0098b58e4881ad017630942be7	\N	2006-09-25 21:16:54	s:0:"";	65.214.44.29
65eb68f332be0d914babbb812fcd5680	\N	2006-09-25 21:16:54	\N	65.214.44.29
7179b939a6153f144abdd7f134f85185	\N	2006-09-25 21:17:33	s:0:"";	207.46.98.114
db2543f21581d4aa5d3dc86e1131f760	dez	2006-09-25 21:17:39	s:0:"";	81.174.227.170
a0192b7f39bbe68d5a3192df995d9173	\N	2006-09-25 21:19:22	s:0:"";	207.46.98.116
e1b1fe649276fac00daba624575223e9	\N	2006-09-25 21:21:23	s:0:"";	207.46.98.116
3f823df59179b74405991e99fd882718	\N	2006-09-25 21:21:27	s:0:"";	202.160.179.116
b47ccf222ef2fa7cbf3fdf352c5b28f2	\N	2006-09-25 21:22:54	s:0:"";	204.169.236.211
4ca8107a971e1cc302539f83fcca87fe	\N	2006-09-25 21:23:47	s:0:"";	87.106.3.38
2ceabde5f6f8111ae7598f41b24a8b27	\N	2006-09-25 21:23:47	s:0:"";	87.106.3.38
3311521e39c8818bedb2f004b60e259b	\N	2006-09-25 21:24:55	s:0:"";	72.30.177.225
3a44b12faa199c2b6d480803e184c5f1	\N	2006-09-25 21:25:22	s:0:"";	202.108.11.106
16326021ee4e9de66fc74a5b99d1134a	\N	2006-09-25 21:25:24	s:0:"";	74.6.70.159
4d3c6553f715332942811b1f26ff3b49	\N	2006-09-25 21:25:38	s:0:"";	82.0.222.175
e0f856728ce54c1e53559ba4e07a5d54	\N	2006-09-25 21:26:42	s:0:"";	212.227.20.34
0e11d28cb9b031048f67bd2b757ac013	\N	2006-09-25 21:26:42	s:0:"";	72.30.177.243
6c8a122f501b81486ad601ba6bff7300	\N	2006-09-25 21:27:30	s:0:"";	202.160.180.45
ea003dbfdab107401b3feeb59cafdd50	frosty	2006-09-25 21:28:21	s:0:"";	81.103.162.49
\.


--
-- Data for Name: shorturi; Type: TABLE DATA; Schema: public; Owner: dez
--

COPY shorturi (id, url, creator, created) FROM stdin;
1	http://www.google.co.uk/	dez	2006-09-18 19:59:57.218819
2	http://www.uwshiking.org.uk	rollercow	2006-09-18 20:28:32.658491
3	http://sucs.org/gihh	dez	2006-09-18 20:30:35.181219
4	http://www.thebearsarecoming.co.uk/	frosty	2006-09-18 20:30:48.951419
5	http://www.dabs.com/ProductView.aspx?Quicklinx=3ZW5&CategorySelectedId=11195&NavigationKey=11195,50468&InMerch=1	psycodom	2006-09-18 21:00:04.341336
6	http://sucs.org/blogs/rollercow	rollercow	2006-09-18 21:00:29.629866
7	http://www.theregister.co.uk/	dez	2006-09-18 21:01:56.56057
8	http://www.theregister.co.uk	dez	2006-09-18 21:03:05.989633
9	http://groups.msn.com/_Secure/0VADnAsQaiJpu08V0CltQSGTxAyVC8OfIurT*V8SR7evS65vSl9FMCO*cGfpCGTZf1EUrj!sg8jTi4EGdJsgePyh!w5En4frihSxN9c6hlYxiJYbAI3TjO50jRHZ09rXV/getwellsoonHAMMOND.jpg	chckens	2006-09-21 15:51:08.958125
10	http://www.google.com	jonhurlock	2006-09-22 20:37:17.57498
11	http://www.bbc.co.uk/	dez	2006-09-23 15:15:32.760333
12	http://www.tobeon.co.uk	tobeon	2006-09-23 15:41:23.36563
13	http://www.awsome.com/therasd/asdsad.php	tobeon	2006-09-23 15:41:39.430555
14	https://beta.sucs.org/Tools/ShortURI	davea	2006-09-24 12:22:12.485381
15	http://beta.sucs.org/pb/5	aeternus	2006-09-24 15:31:10.108538
\.


--
-- Data for Name: static; Type: TABLE DATA; Schema: public; Owner: dez
--

COPY static (id, path, summary, editor, pageorder) FROM stdin;
1	/Knowledge/Help/SUCS Services/Printing in the SUCS room	Printing from your own computer in the SUCS room	dez	\N
2	/Knowledge/Help/SUCS Services/Logging in remotely/Using Authorisation Keys to log in	Log in using a key (removes need for password, using highly secure RSA algorithm)	dez	\N
3	/Knowledge/Help/SUCS Services/Logging in remotely/Configuring PuTTY	How to login to SUCS remotely using PuTTY	dez	\N
4	/Knowledge/Help/SUCS Services/Logging in remotely	How to login from your own computer	dez	\N
5	/Knowledge/Help/SUCS Services/Administering a mailing list	How to administer a mailing list (for societies)	dez	\N
6	/Knowledge/Help/SUCS Services/Accessing your email	Generic mail settings	dez	\N
7	/Knowledge/Help/SUCS Services/Accessing your email/Configuring OS X Mail	How to get your SUCS mail in OS X Mail	dez	\N
8	/Knowledge/Help/SUCS Services/Accessing your email/Configuring Thunderbird	How to get your SUCS mail in Thunderbird	dez	\N
9	/Knowledge/Help/SUCS Services/Accessing your email/Using shell-based mail clients	How to get your SUCS mail via a shell	dez	\N
10	/Knowledge/Help/SUCS Services/Connecting to GuestNet	Using your own computer in the SUCS room	dez	\N
11	/Knowledge/Help/SUCS Services/Jabber Server HOWTO	A guide to registering on and using the SUCS Jabber server.	dez	\N
12	/Knowledge/Help/SUCS Services/Jabber Server HOWTO/Jabber with Gaim	How to set up Jabber using Gaim	dez	\N
13	/Knowledge/Help/SUCS Services/Using Desktop on Demand	Accessing the SUCS <em>Desktop on Demand</em> system	dez	\N
14	/Knowledge/Help/SUCS Services/Using Milliways	How to use Milliways (The SUCS BBS)	dez	\N
15	/Knowledge/Help/SUCS Services/Using Milliways/Correcting your character encoding in Milliways	How to be able to see all those weird / foreign characters, and the pounds sign, that get posted to Milliways occasionally	dez	\N
16	/Knowledge/Help/SUCS Services/Using Milliways/Setting up Milliways Scripts	How to set up some basic Milliways scripts for colour coding, etc.	dez	\N
17	/Knowledge/Help/SUCS Services/Using SVN	How to set up a personal Subversion repository at SUCS	dez	\N
18	/Knowledge/Help/SUCS Services/Using Samba	Assigning your SUCS disk space to a logical drive letter	dez	\N
19	/Knowledge/Help/SUCS Services/Using WebDAV	Accessing your SUCS disk space using WebDAV	dez	\N
20	/Knowledge/Help/SUCS Services/Using mailing lists	How to subscribe to mailing lists and use them	dez	\N
22	/About/Room		chckens	\N
23	/About/Room-secondary		chckens	\N
25	/Knowledge/Help/SUCS Services	Help on Services	dez	\N
26	/fragments/Games/Counter-Strike Source		chckens	\N
27	/fragments/Games/Unreal Tournament		frosty	\N
29	/fragments/Half-Life 2 Team Deathmatch		frosty	\N
30	/fragments/Games/Half-Life 2 Team Deathmatch		frosty	\N
31	/fragments/Games/Unreal Tournament 2004		frosty	\N
32	/fragments/Games/Armagetron Advanced		frosty	\N
33	/Games-secondary		frosty	\N
34	/fragments/Join		dez	\N
35	/Games/Counter-Strike Source		chckens	\N
36	/Games/Half-Life 2 Team Deathmatch		chckens	\N
37	/Games/Unreal Tournament 2004		chckens	\N
38	/Games/Unreal Tournament		chckens	\N
39	/Games/Armagetron Advanced		chckens	\N
40	/fragments/Milliways		chckens	\N
41	/Knowledge/Help/Program Advisory/Reading an arbitrarily long line in C		wedge	\N
42	/Knowledge/Help/Program Advisory		wedge	\N
43	/Knowledge/Help/Admin Tools/GuestNET Registration		wedge	\N
44	/fragments/Front		dez	\N
45	/Community/Members		dez	\N
46	/Community/Societies		dez	\N
47	/Tools/Desktop on Demand		dez	\N
48	/Tools		saya	\N
49	/Knowledge		saya	\N
24	/Community		dez	\N
50	/Knowledge/FAQ		chckens	\N
21	/About/Staff		pwb	\N
28	/fragments/Games		frosty	\N
\.


--
-- Name: acctype_pkey; Type: CONSTRAINT; Schema: public; Owner: dez; Tablespace: 
--

ALTER TABLE ONLY acctype
    ADD CONSTRAINT acctype_pkey PRIMARY KEY (id);


--
-- Name: menu_pkey; Type: CONSTRAINT; Schema: public; Owner: dez; Tablespace: 
--

ALTER TABLE ONLY menu
    ADD CONSTRAINT menu_pkey PRIMARY KEY (id);


--
-- Name: pastebin_pkey; Type: CONSTRAINT; Schema: public; Owner: dez; Tablespace: 
--

ALTER TABLE ONLY pastebin
    ADD CONSTRAINT pastebin_pkey PRIMARY KEY (id);


--
-- Name: books_id_key; Type: INDEX; Schema: public; Owner: chckens; Tablespace: 
--

CREATE UNIQUE INDEX books_id_key ON books USING btree (id);


--
-- Name: menu_heading_fkey; Type: FK CONSTRAINT; Schema: public; Owner: dez
--

ALTER TABLE ONLY menu
    ADD CONSTRAINT menu_heading_fkey FOREIGN KEY (parent) REFERENCES menu(id);


--
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- Name: acctype; Type: ACL; Schema: public; Owner: dez
--

REVOKE ALL ON TABLE acctype FROM PUBLIC;
REVOKE ALL ON TABLE acctype FROM dez;
GRANT ALL ON TABLE acctype TO dez;
GRANT ALL ON TABLE acctype TO apache;


--
-- Name: acctype_id_seq; Type: ACL; Schema: public; Owner: dez
--

REVOKE ALL ON TABLE acctype_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE acctype_id_seq FROM dez;
GRANT ALL ON TABLE acctype_id_seq TO dez;
GRANT ALL ON TABLE acctype_id_seq TO apache;


--
-- Name: awards; Type: ACL; Schema: public; Owner: chckens
--

REVOKE ALL ON TABLE awards FROM PUBLIC;
REVOKE ALL ON TABLE awards FROM chckens;
GRANT ALL ON TABLE awards TO chckens;
GRANT ALL ON TABLE awards TO apache;
GRANT ALL ON TABLE awards TO dez;


--
-- Name: awards_id_seq; Type: ACL; Schema: public; Owner: chckens
--

REVOKE ALL ON TABLE awards_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE awards_id_seq FROM chckens;
GRANT ALL ON TABLE awards_id_seq TO chckens;
GRANT ALL ON TABLE awards_id_seq TO dez;
GRANT ALL ON TABLE awards_id_seq TO apache;


--
-- Name: books; Type: ACL; Schema: public; Owner: chckens
--

REVOKE ALL ON TABLE books FROM PUBLIC;
REVOKE ALL ON TABLE books FROM chckens;
GRANT ALL ON TABLE books TO chckens;
GRANT ALL ON TABLE books TO apache;
GRANT ALL ON TABLE books TO dez;


--
-- Name: books_id_seq; Type: ACL; Schema: public; Owner: chckens
--

REVOKE ALL ON TABLE books_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE books_id_seq FROM chckens;
GRANT ALL ON TABLE books_id_seq TO chckens;
GRANT ALL ON TABLE books_id_seq TO apache;
GRANT ALL ON TABLE books_id_seq TO dez;


--
-- Name: games; Type: ACL; Schema: public; Owner: chckens
--

REVOKE ALL ON TABLE games FROM PUBLIC;
REVOKE ALL ON TABLE games FROM chckens;
GRANT ALL ON TABLE games TO chckens;
GRANT ALL ON TABLE games TO apache;
GRANT ALL ON TABLE games TO dez;


--
-- Name: games_id_seq; Type: ACL; Schema: public; Owner: chckens
--

REVOKE ALL ON TABLE games_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE games_id_seq FROM chckens;
GRANT ALL ON TABLE games_id_seq TO chckens;
GRANT ALL ON TABLE games_id_seq TO apache;
GRANT ALL ON TABLE games_id_seq TO dez;


--
-- Name: menu; Type: ACL; Schema: public; Owner: dez
--

REVOKE ALL ON TABLE menu FROM PUBLIC;
REVOKE ALL ON TABLE menu FROM dez;
GRANT ALL ON TABLE menu TO dez;
GRANT ALL ON TABLE menu TO apache;


--
-- Name: menu_id_seq; Type: ACL; Schema: public; Owner: dez
--

REVOKE ALL ON TABLE menu_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE menu_id_seq FROM dez;
GRANT ALL ON TABLE menu_id_seq TO dez;
GRANT ALL ON TABLE menu_id_seq TO apache;


--
-- Name: news; Type: ACL; Schema: public; Owner: chckens
--

REVOKE ALL ON TABLE news FROM PUBLIC;
REVOKE ALL ON TABLE news FROM chckens;
GRANT ALL ON TABLE news TO chckens;
GRANT ALL ON TABLE news TO dez;
GRANT ALL ON TABLE news TO apache;


--
-- Name: news_id_seq; Type: ACL; Schema: public; Owner: chckens
--

REVOKE ALL ON TABLE news_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE news_id_seq FROM chckens;
GRANT ALL ON TABLE news_id_seq TO chckens;
GRANT ALL ON TABLE news_id_seq TO dez;
GRANT ALL ON TABLE news_id_seq TO apache;


--
-- Name: pagemap; Type: ACL; Schema: public; Owner: arthur
--

REVOKE ALL ON TABLE pagemap FROM PUBLIC;
REVOKE ALL ON TABLE pagemap FROM arthur;
GRANT ALL ON TABLE pagemap TO arthur;
GRANT ALL ON TABLE pagemap TO apache;
GRANT ALL ON TABLE pagemap TO dez;


--
-- Name: pagemap_id_seq; Type: ACL; Schema: public; Owner: arthur
--

REVOKE ALL ON TABLE pagemap_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE pagemap_id_seq FROM arthur;
GRANT ALL ON TABLE pagemap_id_seq TO arthur;
GRANT ALL ON TABLE pagemap_id_seq TO apache;
GRANT ALL ON TABLE pagemap_id_seq TO dez;


--
-- Name: pastebin; Type: ACL; Schema: public; Owner: dez
--

REVOKE ALL ON TABLE pastebin FROM PUBLIC;
REVOKE ALL ON TABLE pastebin FROM dez;
GRANT ALL ON TABLE pastebin TO dez;
GRANT ALL ON TABLE pastebin TO apache;


--
-- Name: pastebin_id_seq; Type: ACL; Schema: public; Owner: dez
--

REVOKE ALL ON TABLE pastebin_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE pastebin_id_seq FROM dez;
GRANT ALL ON TABLE pastebin_id_seq TO dez;
GRANT ALL ON TABLE pastebin_id_seq TO apache;


--
-- Name: redirect; Type: ACL; Schema: public; Owner: dez
--

REVOKE ALL ON TABLE redirect FROM PUBLIC;
REVOKE ALL ON TABLE redirect FROM dez;
GRANT ALL ON TABLE redirect TO dez;
GRANT ALL ON TABLE redirect TO apache;


--
-- Name: redirect_id_seq; Type: ACL; Schema: public; Owner: dez
--

REVOKE ALL ON TABLE redirect_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE redirect_id_seq FROM dez;
GRANT ALL ON TABLE redirect_id_seq TO dez;
GRANT ALL ON TABLE redirect_id_seq TO apache;


--
-- Name: session; Type: ACL; Schema: public; Owner: arthur
--

REVOKE ALL ON TABLE "session" FROM PUBLIC;
REVOKE ALL ON TABLE "session" FROM arthur;
GRANT ALL ON TABLE "session" TO arthur;
GRANT ALL ON TABLE "session" TO apache;
GRANT ALL ON TABLE "session" TO dez;


--
-- Name: shorturi; Type: ACL; Schema: public; Owner: dez
--

REVOKE ALL ON TABLE shorturi FROM PUBLIC;
REVOKE ALL ON TABLE shorturi FROM dez;
GRANT ALL ON TABLE shorturi TO dez;
GRANT ALL ON TABLE shorturi TO apache;


--
-- Name: shorturi_id_seq; Type: ACL; Schema: public; Owner: dez
--

REVOKE ALL ON TABLE shorturi_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE shorturi_id_seq FROM dez;
GRANT ALL ON TABLE shorturi_id_seq TO dez;
GRANT ALL ON TABLE shorturi_id_seq TO apache;


--
-- Name: static; Type: ACL; Schema: public; Owner: dez
--

REVOKE ALL ON TABLE static FROM PUBLIC;
REVOKE ALL ON TABLE static FROM dez;
GRANT ALL ON TABLE static TO dez;
GRANT ALL ON TABLE static TO apache;


--
-- Name: static_id_seq; Type: ACL; Schema: public; Owner: dez
--

REVOKE ALL ON TABLE static_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE static_id_seq FROM dez;
GRANT ALL ON TABLE static_id_seq TO dez;
GRANT ALL ON TABLE static_id_seq TO apache;


--
-- PostgreSQL database dump complete
--

